go:-ga.
:-ensure_loaded(library(lists)).

/*
----------
X-Sun-Data-Type: text
X-Sun-Data-Description: text
X-Sun-Data-Name: text
X-Sun-Charset: us-ascii
X-Sun-Content-Lines: 42


Hi, I appreciate your help. Attached you will find my
program. It is my GA implementation in Prolog.

My program starts with ga. ga reads some parameters and
calls initial_population to create the initial population
of size PS with strings of length CS.
initial_population calls gen_cromo to generate the cromosomas.
For each new cromosoma just created its fitness has to be
computed. This is done with the predicate fitness. This predicate
sets a counter and starts the decoding process with predicate
decode but first reads the first input/output (hence the
name ino). So for each string there are 16 "ino's" to evaluate
and therefore a fitness for the string. The total fitness is
counted with the counter mentioned above. This application is
trying to optimize logic circuits, therefore the fact gate.
Each string represents a circuit with 16 gates in 4 rows and
four columns. The decode process is hard because I did it as
one predicate and one auxiliar. First 24 bits (from left to right) 
represent 4 gates and their outputs have to be feeded to the next 
level of 4 gates and therefore another set of 24 bits, and so on.

In this process is where I got the message I mentioned. In my
trace I found out that the decoding process went fine until
the error did occur, which happened at the time the predicate gate 
is going to be instantiated. Several cromosomas could be decoded.

Thank you

Arturo Hernandez Aguirre



>The error hints towards using findall on very large data or in a
>recursive loop. Because findall uses a `sparse' heap structure
>in needs a very large (-h20000 or so) heap.

>Paul Tarau

>P.S. If you send me the code producing the error I can be more specific
>on what exactly goes wrong.

----------
X-Sun-Data-Type: default
X-Sun-Data-Description: default
X-Sun-Data-Name: gacir.rs6
X-Sun-Charset: us-ascii
X-Sun-Content-Lines: 417
*/

/* Arturo Hernandez Aguirre    */
/*   GACIR.SIC */
/* comienzo hoy 20 de julio/96 el programa del circuito */
/* martes 23 de julio. comienza a correr. need optimiz */
/* sabado 27 de julio. Corriendo bastante bien pero el resultado todavia no sale */
/* viernes 9 de agosto. Estaba todo bien pero decodifique mal el circuito a mano */

r:-reconsult('gacir.sic').
re:-reconsult('gacir.sic'),ga.
c:-reconsult('gacir.sic'),compile('gacir.sic'),ga.


/* start this shet as follows bp -h 500 -s 500 -t 500 */


 
%:-spy ga/0,spy do_ga/3, spy initial_population/2.


:-dynamic crom/3.
:-dynamic child/2.
:-dynamic nchild/2.
:-dynamic seed/1.
:-dynamic bf/2.
:-dynamic fit/1.
:-dynamic bsf/2.



/*
:-abolish(crom/3).
:-abolish(child/2).
:-abolish(nchild/2).
:-abolish(bf/2).
:-abolish(fit/1).
:-abolish(bsf/2).

:-notrace.
*/

pop_size(10).
code_size(96). /*rows x cols x units*/
max_itera(200).
probcv(60).
probmt(8). /*2*/
seed(17). /* 1 -> bestf=20 */ /*17 ->bestf=21*/

rows(4).
cols(4).
zts(16).
unit(6).
inlines(4).
outlines(4).
zino(8).  /* inlines + outlines */



bf([],0).
fit(0).
bsf([],0).


/*

:-assert(bf([],0)).
:-assert(fit(0)).
:-assert(bsf([],0)).

*/

/* prolog_flag(compiling,_,fastcode). */ /* For SICTus prolog enter this directive */

/* in - out */
ino(1,[0,0,0,0,0,0,0,0]).
ino(2,[0,0,0,1,0,0,1,0]).
ino(3,[0,0,1,0,0,1,0,0]).
ino(4,[0,0,1,1,0,1,1,0]).
ino(5,[0,1,0,0,0,0,1,0]).
ino(6,[0,1,0,1,0,1,0,0]).
ino(7,[0,1,1,0,0,1,1,0]).
ino(8,[0,1,1,1,1,0,0,0]).
ino(9,[1,0,0,0,0,1,0,0]).
ino(10,[1,0,0,1,0,1,1,0]).
ino(11,[1,0,1,0,1,0,0,0]).
ino(12,[1,0,1,1,1,0,1,0]).
ino(13,[1,1,0,0,0,1,1,0]).
ino(14,[1,1,0,1,1,0,0,0]).
ino(15,[1,1,1,0,1,0,1,0]).
ino(16,[1,1,1,1,1,1,0,0]).

gate([0,0,1,0,1],w). /* wire */
gate([0,0,1,1,1],w).
gate([0,0,0,0,0],w).
gate([0,0,0,1,0],w).
gate([0,1,0,0,0],and). /* and */
gate([0,1,0,1,0],and).
gate([0,1,1,0,0],and).
gate([0,1,1,1,1],and).
gate([1,0,0,0,0],or). /* or */
gate([1,0,0,1,1],or).
gate([1,0,1,0,1],or).
gate([1,0,1,1,1],or).
gate([1,1,0,0,0],xor). /* xor */
gate([1,1,0,1,1],xor).
gate([1,1,1,0,1],xor).
gate([1,1,1,1,0],xor).
gate([2,1,0,_,1],not). /*inversor */
gate([2,1,1,_,0],not).

ga:-max_itera(MI),pop_size(PS),code_size(CS),
    initial_population(PS,CS),
    do_ga(MI,PS,CS),!.


do_ga(MI,PS,CS):-nl,write('Initial Population '), best_fitness,
	   for(1,MI,Ixmi,1), nl,
	   write('Generation Number: '),write(Ixmi),
	   tournament(PS,CS),crossover(PS,CS),mutation(PS,CS),
	   best_fitness,
	   fail.

do_ga(_,_,_).

tournament(PS,CS):-for1(1,PS,Ixps,1),
		   tournament1(Ixps,PS,CS),
		   fail.
tournament(_,_):-!.

tournament1(Ixps,PS,CS):-random(C1,PS),
			 crom(C1,L1,F1),
		      /* random(C2,PS), crom(C2,L2,F2), */
			 crom(Ixps,L2,F2),
			 new_child(L1,F1,L2,F2,Ixps),!.

new_child(L1,F1,L2,F2,Ixps):- F1 > F2,asserta(child(Ixps,L1)).
new_child(L1,F1,L2,F2,Ixps):- asserta(child(Ixps,L2)).



crossover(PS,CS):-for2(1,PS,Ixps,2),cross(Ixps,PS,CS),fail.
crossover(_,_):-!.


cross(Ixps,PS,CS):- Ixps1 is Ixps+1,
		    random(K,PS),
		    random(R,PS),
		    child(K,CH1),
		    child(R,CH2),
		    random(Start,CS),random(End,CS),
		    order(Start,End,St,Ed),
		    split_crom(St,Ed,CH1,L1,L2,L3),
		    split_crom(St,Ed,CH2,L11,L22,L33),
		    append(L1,L22,Lt), append(Lt,L3,NCH1),
		    append(L11,L2,Lx), append(Lx,L33,NCH2),
		    asserta(nchild(Ixps,NCH1)),
		    asserta(nchild(Ixps1,NCH2)),!.


mutation(PS,CS):-for3(1,PS,Ixps,1),muta(Ixps,CS),fail.
mutation(_,_):-!.


muta(Ixps,CS):-retract(nchild(Ixps,NCH)),
	       retract(child(Ixps,_)),
	       retract(crom(Ixps,_,_)),
	       probmt(Pm),
	       check_muta(Ixps,NCH,Pm),!.

check_muta(Ixps,NCH,Pm):-allbits(NCH,Pm,NN),fitnes(NN,F),
			 asserta(crom(Ixps,NN,F)).

allbits([],_,[]):-!.
allbits([A|B],Pm,[A1|B1]):-random(R,100),
			   R =< Pm,switch(A,A1),
			   allbits(B,Pm,B1).

allbits([A|B],Pm,[A|C]):-allbits(B,Pm,C).

switch(0,1).
switch(1,0).


order(S,E,S,E):-S < E.
order(S,E,E,S):-S > E.
order(S,E,S,E1):-S==E,E1 is S+1.


split_crom(A,B,L,L1,L2,L3):-split1(A,L,L1),
			    extract(A,B,L,L2),
			    split2(B,L,L3).

split1(1,L,[]).
split1(A,L,L1):-A1 is A-1, extract(1,A1,L,L1).

split2(CS,L,[]):-code_size(CS).
split2(Z,L,L1):-Z1 is Z+1,code_size(CS),extract(Z1,CS,L,L1).



e:-etapa(1,[0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1],[1,1,0,0],24,R),write(R).

e1:-decode([0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1],[0,1,0,1,0,1,0],R),write(R).


/*this cromosoma with ino(4,P) */
c([0,0,1,0,0,0,1,0,1,0,0,0,1,1,0,0,1,0,0,0,1,1,1,1,1,1,0,0,1,0,0,1,1,0,0,1,0,0,0,1,0,1,1,1,0,1,1,1,1,0,1,1,0,1,0,0,0,1,0,1,1,0,1,0,1,0,0,0,1,0,0,0,0,1,1,0,0,0,1,0,0,0,1,1,1,0,0,1,1,1,0,0,0,0,1,0]).

fitnes(CROM,F):-retract(fit(X)),
		assert(fit(0)),
		find_fit(CROM,F).

find_fit(CROM,F):-ino(A,INO),
		  decode(CROM,INO,FF),
		  correct(INO,FF),
		  fail.

find_fit(CROM,F):-fit(F),F < 16,!.
find_fit(CROM,F):-fit(FF), wires(CROM,W),F is FF + W,!.

wires([],0):-!.
wires([A,B,C,D,0,0|R],N):-!,wires(R,NN),N is NN + 1.
wires([A,B,C,D,E,F|R],N):-!,wires(R,N).
                          

correct(INO,F):-inlines(In),N is In+1,zino(Z),
		extract2(N,Z,INO,L,R),
		veri(L,F,V),
		retract(fit(X)),
		X1 is X+V,
		assert(fit(X1)),!.

veri([A,_,_,_],[A,_,_,_],1).


verify([A],[B],0):-!.
verify([A|B],[C|D],N):-A\==C,
		       verify(B,D,N).
verify([A|B],[A|D],N):-verify(B,D,NN),
		       N is NN+1.



decode(CROM,INO,F):-cols(N),rows(R),unit(U),T is U*R,
		    etapa(N,CROM,INO,T,F),!.

etapa(1,[],_,_,[]):-!.
etapa(1,[A,B,C,D,E,F|Rc],INO,T,[R|MR]):-decode_gate([A,B,C,D,E,F],INO,R),
					etapa(1,Rc,INO,T,MR).
etapa(N,CROM,INO,T,F):-N1 is N-1,
		       rtrim(T,CROM,L1,L2),
		       etapa(N1,L1,INO,T,FF),
		       etapa(1,L2,FF,T,F).


decode_gate([A,B,C,D,E,F],INO,R):-bintodec([A,B],F1),F11 is F1+1,
				  bintodec([C,D],F2),F22 is F2+1,
				  get_ele(F11,INO,E1),
				  get_ele(F22,INO,E2),
				  gate([E,F,E1,E2,R],_).

bintodec([0,0],0).
bintodec([0,1],1).
bintodec([1,0],2).
bintodec([1,1],3).


get_ele(1,[A|B],A):-!.
get_ele(N,[A|B],C):-NN is N-1,get_ele(NN,B,C).



rtrim(T,L,L1,L2):-length(L,Len), H is Len-T,extract2(1,H,L,L1,L2).

/* This is nice but rather slow */
/* rtrim(T,L,L1,L2):-append(L1,L2,L),len(L2,T). */
/* ltrim(T,L,L1,L2):-append(L1,L2,L), len(L1,T). */



pause:-nl,write('Pulse una tecla para continuar...'),nl,get0(A).

show_pop:-crom(A,B,_),nl,
	  write(A), write(B), fail.
show_pop:-!.

show_child:-child(A,B),nl,
	    write('child '),write(A),fail.
show_child.

show_nchild:-nchild(A,B),nl,write('nchild '),
	    write(A),fail.
show_nchild.

best_fitness:-retract(bf(X,XX)),
	      assert(bf([],0)),
	      find_bf.

find_bf:-crom(A,L,F),
	 bf(_,BF),
	 F > BF,
	 retract(bf(X,XX)),assert(bf(L,F)),
	 fail.

find_bf:-bf(L,F),bsf(_,BSF),F>=BSF,retract(bsf(_,_)),asserta(bsf(L,F)),!,fail.

best_fitness:-bf(L,F),bsf(_,BSF),
	      write('   Fitness:'),write(F),
	      write('     Best So Far: '), write(BSF), nl.




initial_population(PS,CS):-gen_cromo(PS,CS).



gen_cromo(0,CS):-!.
gen_cromo(PS,CS):-cromosoma(CS,L),
		  fitnes(L,F), 
		  asserta(crom(PS,L,F)),
		  PS1 is PS-1,
		  gen_cromo(PS1,CS).


cromosoma(0,[]):-!.
cromosoma(CS,[A|B]):-random(N,100),!,
		     ( N > 50, A is 1,!; A is 0 ),C is CS-1,
		     cromosoma(C,B).


random(N,R):-retract(seed(S)),
	     N is S mod R + 1,
	     NEW is (13 * S + 1 ) mod 1024,
	     asserta(seed(NEW)).

for(X,X,X,I):-!.
for(Y,X,Y,I).
for(X,Y,Z,I):-X1 is X+I,X1=<Y,for(X1,Y,Z,I).

for1(X,X,X,I):-!.
for1(Y,X,Y,I).
for1(X,Y,Z,I):-X1 is X+I,X1=<Y,for1(X1,Y,Z,I).


for2(X,X,X,I):-!.
for2(Y,X,Y,I).
for2(X,Y,Z,I):-X1 is X+I,X1=<Y,for2(X1,Y,Z,I).


for3(X,X,X,I):-!.
for3(Y,X,Y,I).
for3(X,Y,Z,I):-X1 is X+I,X1=<Y,for3(X1,Y,Z,I).


extract(1,1,[A|B],[A]):-!.
extract(1,Y,[A|B],[A|C]):-NN is Y-1, extract(1,NN,B,C),!.
extract(X,Y,[A|B],R):-X > 1, Y > 1,
		      NN is X-1,YY is Y-1,
		      extract(NN,YY,B,R).


extract2(1,1,[A|B],[A],B):-!.
extract2(1,Y,[A|B],[A|C],D):-NN is Y-1, extract2(1,NN,B,C,D),!.
extract2(X,Y,[A|B],R,[A|T]):-X > 1, Y > 1,
		      NN is X-1,YY is Y-1,
		      extract2(NN,YY,B,R,T).



a([1,1,0,1,0,1,0,0,0,0,0,1,0,0,1,0,0,0,1,0,1,1,0,0,1,1,1,0,1,1,1,0,1,0,0,0,0,0,0,1,0,0,1,1,0,1,0,1,0,0,1,0,0,1,0,0,0,1,0,1,1,1,1,1,0,1,1,1,0,1,0,1,1,1,0,0,1,0,1,0,0,1,0,0,0,0,1,1,0,0,1,1,1,0,1,0]).


/************************************************************************/

/*
decode(CROM):-cols(N),rows(R),unit(U),T is U*R,
	      etapa(N,CROM,T),!.

etapa(1,[],_):-!.
etapa(1,[A,B,C,D,E,F|Rc],T):-decode_gate([A,B,C,D,E,F]),
			     etapa(1,Rc,T).
etapa(N,CROM,T):-N1 is N-1,
		 rtrim(T,CROM,L1,L2),
		 etapa(N1,L1,T),
		 etapa(1,L2,T).


decode_gate([A,B,C,D,E,F]):-bintodec([A,B],F1),F11 is F1+1,
			    bintodec([C,D],F2),F22 is F2+1,
			    gate([E,F,E1,E2,R],G),
			    nl,write(F11),write(' '),write(F22),write(G).

*/

/*

4 2and
1 1and
1 3w
3 4w
4 3xor
3 3w
1 2w
4 2and
1 3and
1 2and
4 4and
4 2and
4 1or
3 2w
1 4w
4 3or


L = [1,1,0,1,0,1,0,0,0,0,0,1,0,0,1,0,0,0,1,0,1,1,0,0,1,1,1,0,1,1,1,0,1,0,0,0,0,0,0,1,0,0,1,1,0,1,0,1,0,0,1,0,0,1,0,0,0,1,0,1,1,1,1,1,0,1,1,1,0,1,0,1,1,1,0,0,1,0,1,0,0,1,0,0,0,0,1,1,0,0,1,1,1,0,1,0] ? ;

*/
