% ## predefined opcodes: see global.h
go:-go(66).

/* ADD NEW BUILTINS HERE */

% simple inline builtins of arity 0,1 with no returned value

b0(fail/0,simple,in_body,'always fails').
b0(cwrite/1,simple,in_body,'basic but quick C-version of write/1').
b0(cnl/0,simple,in_body,'new line').
b0(var/1,simple,in_body,'true if currently a variable').
b0(nonvar/1,simple,in_body,'true if currently instantiated').
b0(integer/1,simple,in_body,'true if an integer').
b0(atomic/1,simple,in_body,'true if an integer or symbolic constant').
b0(is_compiled/1,simple,in_body,'true if head of a compiled predicate').

% builtin inline functions of arity >= 1 f(i,....,i,optional:o)

b0((+)/3,arith(1),in_body,'add'- x(10,3,_)).
b0((-)/(3),arith(1),in_body,'subtract'- x(10,3,_)).
b0((*)/3,arith(1),in_body,'multiply'- x(10,3,_)).
b0(mod/3,arith(1),in_body,'modulo'- x(10,3,_)).

b0('//'/3,arith(1),in_body,'integer division'- x(10,3,_)).
b0((/)/3,arith(1),in_body,'division'- x(10,3,_)).

b0(random/1,arith(1),in_body,'returns a random integer'-x(_)).

b0(get0/1,arith(1),in_body,'reads a char as an ascii code').

b0(put/1,arith(0),in_body,'writes and ascii code as a char'-x(99)).

b0(less/2,arith(0),in_body,'arithemetic comparison').
b0(greater/2,arith(0),in_body,'arithemetic comparison').
b0(less_eq/2,arith(0),in_body,'arithemetic comparison').
b0(greater_eq/2,arith(0),in_body,'arithemetic comparison').
b0(arith_eq/2,arith(0),in_body,'arithemetic comparison').
b0(arith_dif/2,arith(0),in_body,'arithemetic comparison').

b0((<<)/3,arith(1),in_body,'left shifts arg 1 by arg 2 bits'-x(1,5,_)).
b0((>>)/3,arith(1),in_body,'right shifts arg 1 by arg 2 bits'-x(16,2,_)).
b0((/\)/3,arith(1),in_body,'bitwise AND'-x(1,2,_)).
b0((\/)/3,arith(1),in_body,'bitwise OR'-x(1,2,_)).
b0((#)/3,arith(1),in_body,'bitwise XOR'-x(1,2,_)).
b0((\)/3,arith(1),in_body,'bitwise complement'-x(0,2,_)). % complement

b0(compare0/3,arith(1),in_body,'').
b0(arg/3,arith(1),in_body,
   'arg(I,T,X) extracts arg I of term T to be unified with X'-
   x(2,f(a,b),_)
 ).
b0(setarg/3,arith(0),in_body,
  'backtrackable: setarg(I,T,X) replaces arg I of T with X'-
   x(2,f(a,b),c)
 ).
b0(change_arg/3,arith(0),in_body,
   'destructive: change_arg(I,T,X) replaces arg I of T with X'-
   x(2,f(a,b),c)
 ).

b0(def/3,arith(0),in_body,'').
b0(rm/2,arith(0),in_body,'').
b0(set/3,arith(0),in_body,'').
b0(val/3,arith(1),in_body,'').
b0(lval/3,arith(1),in_body,
   'backtrackable: lval(K1,K2,V) associates V to keys K1 and K2'-
    x(a,b,f(_))
  ).
b0(symcat/3,arith(1),in_body,
  'makes new identifier from arg 1 and arg 2'-
  [x(a,b,_),x(a,1,_)]
).

% C-ification of frequently used builtins ends here
% it is not clear that for the remaining ones it is a good idea to do it

b0(namecat/4,arith(1),in_body,'concatenates 3 names'-x(a,':',b,_)).

b0(hkey/2,arith(1),in_body,
  'computes hash key based on main functor'-[x(f(a),_),x(f(b),_)]).
b0(gval/2,arith(1),in_body,'').
b0(hval/2,arith(1),in_body,'').
b0(tval/3,arith(1),in_body,'').
b0(tlet/3,arith(0),in_body,'').
b0(get_asserted/2,arith(1),in_body,'').

b0(array_set/3,arith(0),in_body,
  'sets array element').
b0(array_get0/3,arith(1),in_body,
  'gets  array element').
b0(array_get/3,arith(1),in_body,
  'gets and dereferences array element').
b0(make_array/2,arith(1),in_body,
  'creates an array').
b0(destroy_array/1,arith(0),in_body,
  'frees an array').

b0(addq0/2,arith(0),in_body,'').
b0(pushq0/2,arith(0),in_body,'').
b0(popq0/2,arith(1),in_body,'').

b0(dcg_connect/1,arith(1),in_body,
   'handles a terminal symbol in HAGs, as [a] in DCGs').
b0(list2term/2,arith(1),in_body,'').
b0(term2list/4,arith(1),in_body,'').
b0(self_info/1,arith(1),in_body,'').
b0(add_instr/4,arith(0),in_body,'').
b0(lift_heap/2,arith(0),in_body,'').
b0(det_append0/3,arith(1),in_body,'').

b0(copy_term/3,arith(1),in_body,'').
b0(unify_to/2,arith(1),in_body,'').
b0(bb_list0/3,arith(1),in_body,'').

b0(older_file/2,arith(0),in_body,
  'true if arg 1 is a file older than arg 2').
b0(seeing_telling/2,arith(1),in_body,''). % seeing=0,telling=1
b0(see_tell/2,arith(0),in_body,''). % see=0,tell=1
b0(seen_told/1,arith(0),in_body,''). % seen=0,told=1,flush=2
b0(seeing_telling_at/2,arith(1),in_body,''). % seeing_at=0,telling_at=1
b0(see_tell_at/2,arith(0),in_body,''). % see_at=0,tell_at=1

b0(string_op/3,arith(1),in_body,''). % was: sread=0, swrite0=1

b0(op0/3,arith(0),in_body,''). 

b0(term_append/3,arith(1),in_body,
  'efficiently concatenates 2 terms'-x(f(a,b),g(c,d),_)).

b0(float_fun2/4,arith(1),in_body,'').
b0(float_fun/3,arith(1),in_body,'').
b0(input_float/4,arith(1),in_body,'').

b0(strip_cont0/2,arith(1),in_body,'').

% invisible dcgs (up to 256 streams)
b0(dcg_def/1,arith(0),in_body,
   'backtrackable: defines current Assumption Grammar stream').
b0(dcg_val/1,arith(1),in_body,
   'backtrackable: retrieves current Assumption Grammar stream').
b0(dcg_tell/1,arith(0),in_body,'').
b0(dcg_telling/1,arith(1),in_body,'').

b0(open_stream/4,arith(1),in_body,'').
b0(close_stream/2,arith(0),in_body,'').
b0(fgetc/2,arith(1),in_body,
  'fgetc(IntegerStreamNo,CharCode) inputs a char code from a C stream').
b0(fputc/2,arith(0),in_body,
  'fputc(IntegerStreamNo,CharCode) outputs a char code to a C stream').
b0(fflush/1,arith(0),in_body,
  'fflush(IntegerStreamNo) flushes a C-stream').
b0(fsize/2,arith(1),in_body,
  'returns the size of the file associated to a C stream, in bytes').

b0(iso_open_stream/3,arith(1),in_body,'').
b0(iso_close_stream/2,arith(0),in_body,'').
b0(iso_write_term/3,arith(0),in_body,'').
b0(iso_read_term/3,arith(1),in_body,'').
b0(iso_put_byte/2,arith(0),in_body,'').
b0(iso_get_byte/2,arith(1),in_body,'').
b0(iso_peek_byte/2,arith(1),in_body,'').
b0(iso_eof/1,arith(0),in_body,'').
b0(iso_lseek/4,arith(1),in_body,'').

b0(bb_put/2,arith(0),in_body,'').
b0(bb_get/4,arith(1),in_body,'').
b0(bb_op/3,arith(1),in_body,'').

b0(setref/2,arith(0),in_body,'').

b0(unix_argc/1,arith(1),in_body,
  'gets cmd line arg counter'-x(_)).
b0(unix_argv/2,arith(1),in_body,
   'gets a cmd line arg from 0 to argc'-x(0,_)).
b0(unix_getenv/2,arith(1),in_body,'gets an environment variable').
b0(unix_access/2,arith(0),in_body,
  'checks if arg1 (a path+file) is accessible in arg 2 (integer) mode').
b0(unix_cd/1,arith(0),in_body,'changes local dir to arg 1').
b0(unix_fork/1,arith(1),in_body,'starts child process with Unix fork').
b0(unix_pid/1,arith(1),in_body,'returns process id of current process').
b0(unix_kill/2,arith(0),in_body,
    'sends signal arg 1 to process with pid arg 2').

b0(create_engine/4,arith(1),in_body,
 'create_engine(Heap,Stack,Trail,IntHandle) creates an engine IntHandle').
b0(destroy_engine/1,arith(0),in_body,
  'destroy_engine(E) frees memory of engine E (an integer)').
b0(load_engine/3,arith(0),in_body,
  'load_engine(E,Goal,Answer) prepares engine E to execute Goal/Answer').
b0(ask_engine/2,arith(1),in_body,
  'ask_engine(E,X) retrieves from engine E (a copy of) answer X').
b0(multitask_engines/1,arith(0),in_body,'').
b0(list_engines/1,arith(1),in_body,'lists available engine handles').
b0(current_engine/1,arith(1),in_body,'returns current engine handle').

b0(untrail_to/1,arith(0),in_body,'unwinds the trail up to a choice point').
b0(get_neck_cut/1,arith(1),in_body,'gets the choice point as an integer').

b0(override/3,arith(0),in_body,'').
b0(trim_cp/1,arith(0),in_body,'').
b0(random_seed/1,arith(0),in_body,
  'initializes random/1 with an integer, uses clock if 0').

b0(member_scan/3,arith(1),in_body,
  'finds first element without unifying to it'-
  member_scan(s(_),[1,s(s(_)),2],_)).
b0(cmember_scan/3,arith(1),in_body,'').
b0(cdel_scan/3,arith(1),in_body,'').

b0(push_code/1,arith(1),in_body,
  'moves code to kernel after compile, returns top of code area').

b0(system0/2,arith(1),in_body,'').
b0(new_name/2,arith(1),in_body,'returns a new name based on arg 1').

b0(new_client/3,arith(1),in_body,'from a (host,port) to a client').
b0(new_server/2,arith(1),in_body,'opens on a port a new server').
b0(new_service/3,arith(1),in_body,'from (server,timeout) to a service').

b0(peer_addr/2,arith(1),in_body,
  'gets address of peer connected to socket').

b0(peer_port/2,arith(1),in_body,'gets port of peer connected to socket').

b0(close_socket/1,arith(0),in_body,'closes a server, service or client').
b0(sock_readln/2,arith(1),in_body,'reads from a socket, a line').
b0(sock_writeln/2,arith(0),in_body,'writes to a socket, a line').
b0(sock_read/2,arith(1),in_body,'reads from a socket, a string').
b0(sock_write/2,arith(0),in_body,'writes to a socket, a string').
b0(sock2file/2,arith(0),in_body,'reads from a socket, to a file').
b0(file2sock/2,arith(0),in_body,'writes to a socket, from a file').
b0(sleep/1,arith(0),in_body,'waits arg 1 seconds').

% $$ add here
b0(new_builtin/3,arith(1),in_body,''). % arity 3+1 by binarization
b0(halt/1,arith(0),in_body,'stops Prolog with given return code').

% unspecified i-o pattern builtins

b0(true/0,simple,in_head,'always succeeds').
b0(call/1,simple,in_head,'executes (atomic!) arg 1'). 

b0(abort0/0,simple,in_head,'').
b0(restart0/0,simple,in_head,'').

b0(findall_store_heap/1,simple,in_head,'').
b0(findall_load_heap/1,simple,in_head,'').

b0(functor/3,simple,in_head,
   'builds or decomposes a coumpound term'-
  [x(f(a,b),_,_),x(_,f,3),x(f(a),f,1)]).

b0(name/2,simple,in_head,
  'bidirectional: converts atomic to/from list of chars'-
  [x(hello,_),x(_,[98,121,101])]).

b0(load0/1,simple,in_head,'').

b0(stat0/3,simple,in_head,'').

b0(list_asm/3,simple,in_head,'').
b0(bb_reset/1,simple,in_head,
'cleans up and resizes to at least arg 1 bytes compound term area of the blackboard').

b0(garbage_collect/0,simple,in_head,'performs heap gc now').

b0(profile/0,simple,in_head,'').

b0(member_entry/2,simple,in_head,'').
b0(for_entry/3,simple,in_head,'').

b0(if0/3,simple,in_head,'').

% things defined in Prolog which should look like builtins

% lib.pl 

p0('!',0,'').
p0(get_deep_cut,2,'gets a choice point address, used with 1 arg only').
p0(cut_to,1,'cuts to an int in arg 1, a choicepoint address').
p0(translate_clause,2,'').
p0(translate_def,2,'').
p0('.',2,'').
p0(end_of_file,0,'').
p0(pc,0,'').
p0(restart,0,'cleans up data areas').
p0(abort,0,'returns to toplevel').
p0(heap_size,1,'').
p0(stack_size,1,'').
p0(trail_size,1,'').

p0(gc,0,'enables heap gc').
p0(nogc,0,'disables heap gc').
p0(gc_status,1,'shows if heap gc is enabled or not').

p0(dynbbgc,0,'makes blackboard dynamic with gc on').
p0(bbgc,0,'enables blackboard gc ').
p0(nobbgc,0,'disables blackboard gc').
p0(bbgc_status,1,'shows if blackboard gc is enabled or not').

p0(bb_gc,0,'performs blackboard gc now').
p0(quiet,1,'gets/sets level of "quietness"').

p0(create_engine,1,'creates an engine as big as the current one').
p0(open_engine,3,
  'open_engine(G,X,E) creates an engine E ready to execute goal G with answer X').
p0(show_engine,0,
  'if debugmes/1 is on (as with quiet(1)), shows params of current engine').

p0(include,1,'includes/loads a file with current load method').

p0(dconsult,1,
  'reconsult/1 variant: cleans up data areas, consults, allowing dynamic recompilation').
p0(sconsult,1,
 'reconsult/1 variant: cleans up data areas consults, makes all static').
p0(oconsult,1,
  'reconsult/1 variant: consults and overwrites old clauses').
p0(scompile,1,
  'smart compile/1 variant: if the *.wam file is newer reloads otherwise fcompiles first').
p0(mcompile,1,'compile/1 variant: cleans up data areas and compiles to memory').
p0(compile,1,
  'applies current compilation method to the file arg 1').
p0(load,1,'clean loads from a bytecode *.wam file').
p0(fcompile,1,'compiles a *.pl or *.pro file to a *.wam bytecode file').

p0(debug,1,'').
p0(consult,1,
  'consults with possible duplication of clauses, allows later dynamic recompilation').
p0(consult,2,
  'consult(File,DB) consults File into DB)').

p0(reconsult,1,'applies current consult method to file: arg 1').
p0((~),1,'short hand for reconsult').

p0(consult_cmd,1,'').
p0(consult_cmd,2,'').
p0(consult_included,2,'').
p0(consult0,1,'').
p0(consult0,2,'').

p0(load_file,1,'').
p0(fcompile_file,1,'').
p0(scompile_file,1,'').
p0(mcompile_file,1,'').

p0(translate_all,2,'').
p0(get_a_predicate,3,'').
p0(or,2,'').
p0(if,3,'').
p0(strip_cont,3,'').
p0(termcat,3,'').
p0(add_cont,3,'').
p0(asm,0,'shows readable wam assembler for Prolog code entered at terminal').
p0(asm,1,'generates readable binarized form and wam assembler to a file').
p0('=..',2,'bidirectional: from a term from/to a alist of components'-
  [x(f(a,b),_),x(_,[f,a,b])]
).
p0('::-',2,'variant of :- for hand transformed binary clauses').

p0('##',1,'executes arg 1 at compile time').
p0(proto_append,2,'').
p0(proto_member,2,'').
p0(member3,3,'').

p0(n_inline,1,'').
p0(n_arith,1,'').
p0(n_builtin,1,'').
p0(n_nop,1,'').

p0(statistics,0,'shows info about data areas'-x).
p0(stat,0,'').
p0(interactive,1,'toggles interactive query answering/tracing').

p0(def_to_mbin,2,'').
p0(bincall,2,'call binary predicate with given continuation').
p0(metacall,1,'calls the interpreter').
p0(metatrue,0,'calls the interpreter on current continuation').

p0(call,2,'efficient call/N variant').
p0(call,3,'efficient call/N variant').
p0(call,4,'efficient call/N variant').
p0(call,5,'efficient call/N variant').
p0(call,6,'efficient call/N variant').
p0(call,7,'efficient call/N variant').

p0(override,2,'').

p0(once,1,'executes with no backtracking').

p0(map,3,'maps a function to a list'-
  x(+(1),[10,20],_)).

p0(foldl,4,'iterator'-
  x(+,0,[10,20,30],_)).
p0(foldr,4,'iterator'-
  x(+,0,[10,20,30],_)).

p0(sum,2,'sum of a list'-
  x([10,20],_)).
p0(prod,2,'product of a list'-
  x([10,20],_)).

p0(expand_term,2,'').
% p0(':-',2,'').
p0('=',2,'true if args unify'-
  x(f(_,s(a)),f(Y,Y))
).
p0('->',2,
  'Cond->Then executes Cond once; if it succeeds it also executes Then').
p0(';',2,'A;B succeeds if A succeeds or B, called after A, succeeds').
p0(',',2,'A,B succeeds if A suceeds and B, called after A, succeeds').
p0(repeat,0,
  'backtracks until its continuation succeeds; defined as repeat. repeat:-repeat. ').
p0(forall,1,
  'forall(G) backtracks over all answers to G and succeeds').
p0(forall,2,
  'forall(A,B) fails for all cases when A succeeds and B fails').
p0((\+),1,'succeeds if its argument is executed and fails').
p0((\=),2, 'true if args fail to unify').
p0(findall_workhorse,5,'').
p0(findall,3,
  'findall(X,G,Xs) collects copies of all answers X of G on Xs'-
     x(s(X),
       (member(X,[1,2,3]),X>1),
       _)
).
p0(findall,4,
 'findall(X,G,Xs,Ys) appends the list of answers X of G to Ys to obtain Xs'
 -
  x(s(X),
       (X=1;X=2),
       _,[3,4])
).
p0(findall_conj,3,
  'same as findall/3 but giving (a,b,c) instead of [a,b,c]').
p0(findall_conj,4,
  'same as findall/4 but working with (,)/2 based sequences').
p0(findall_disj,3,
  'same as findall/3 but working with (;)/2 based sequences').
p0(findall_disj,4,
 'same as findall/4 but working with (;)/2 based sequences').


p0(all_answers,3,'cleaner findall/3').
p0(while,2,'findall variant').
p0(skip_until,2,'findall variant').
p0(skip_when,2,'findall variant').
p0(find_while,4,'findall variant').
p0(nth_answer,2,'findall variant').
p0(take_at_most,2,'findall variant').
p0(drop_at_least,2,'findall variant').
p0(has_fuel,1,'').
p0(find_at_most,4,'findall variant').
p0(all_but_at_least,4,'findall variant').
p0(det_call,1,'calls and detects if not deterministic').

p0(for,3,'generates an integer in a range'-
  x(_,1,3)).
p0(argn,3,'generates all n args of term'-
  x(_,f(a,b),_)
).
p0(append,3,'concatenates/decomposes lists'-
 [
   x([1,2],[3,4],_),
   x(_,_,[1,2])
 ]
 ).
p0(member,2,'generates/check if an element is on a list'-
  [x(2,[1,2]),
   x(_,[1,2])
  ]).
p0(memberchk,2,'').
p0(member_conj,2,'').
p0(det_append,3,'').
p0('.',3,'').
p0('++',3,'concatenates N lists, usable in is/2').
p0(length,2,'generates/mesures length of a list').
p0(make_cmd0,2,'').
p0(make_cmd,2,'').
p0(listify,2,'transforms, if needed, to list of chars').

p0(is_spec,1,'').
p0(is_terminator,1,'').
p0(is_maj,1,'').
p0(is_min,1,'').
p0(is_an,1,'').
p0(is_num,1,'').

p0(numbervars,3,
  'binds to $VAR(I) with I over distinct integers variables in a term').
p0(numbervar_name,2,'').

p0(answer_of,2,'').
p0(solutions,2,'adds output arg to closure in arg 1, executes and collects').
p0(gc_call,1,'').
p0(ground,1,'true if arg has no free variables').
p0(atom,1,'true if symbol (functor of arity 0)').
p0(float,1,'true if represented as a 64 bit float number (C-double)').
p0(number,1,'true if integer or float').
p0(compound,1,'true if it has arity > 0').
p0(appendN,2,'concatenates N lists').
p0(append_conj,3,'concatenates 2 conjunctions').
p0(append_disj,3,'concatenates 2 disjunctions').
p0(subsumes_chk,2,'checks if arg 1 is subsumed by arg 2, after renaming vars').
p0(variant_of,2,'checks if args are the same up to a renaming of vars').
p0(tab,1,'outputs N blanks').
p0(get,1,'inputs the next char code after skiping over white space').
p0(is,2,'calls the function evaluator, mostly for arithmetics'-
  x(_,3+4*2)
).
p0(expr,2,'').

p0(compare,3,'returns <,=,> in arg 1 after comparing arg 2 with arg 3'-
  [x(_,1,2),x(_,f(b),f(a)),x(_,s(X),s(X))]).
p0(( == ),2,'true if args are identical terms').
p0(( \== ),2,
  'true if arg 1 is not identical to arg 2').
p0(( @< ),2,'instance of compare/3 with arg 1: <').
p0(( @> ),2,'instance of compare/3 with arg 1: >').
p0(( @=< ),2,'instance of compare/3 with arg 1: = or <').
p0(( @>= ),2,'instance of compare/3 with arg 1: > or =').
p0((  <  ),2,'numeric comparison').
p0((  >  ),2,'numeric comparison').
p0(( =< ),2,'numeric comparison').
p0(( >= ),2,'numeric comparison').
p0(( =:=),2,'numeric comparison').
p0(( =\=),2,'numeric comparison').
p0((+),2,'returns 0 + arg 1').
p0((-),2,'returns 0 - arg 1').
p0((\),2,'complement').

p0(bb_def,3,
  'bb_def(K1,K2,T) associates to K1 and K2 (a copy of) T on the blackboard').
p0(bb_set,3,
  'bb_set(K1,K2,T) updates the term associated with K1 and K2 to be a copy of T').
p0(bb_let,3,
  'bb_let(K1,K2,T) updates or defines the term associated with K1 and K2 to be T').
p0(bb_val,3,
  'bb_val(K1,K2,T) T is (a copy of) the term associated with keys K1 and K2').
p0(bb_rm,2,
  'removes the term associated with K1 and K2 from the blackboard').

p0(let,3,'').

%p0(let,2,'').
%p0(def,2,'').
%p0(set,2,'').
%p0(val,2,'').
%p0(rm,1,'').

p0(bb_def,2,'').
p0(bb_set,2,'').
p0(bb_val,2,'').
p0(bb_rm,1,'').
p0(bb_let,2,'').

p0(vread,2,'').
p0(vget0,2,'').
p0(vget,2,'').
p0(vset,2,'').
p0(gvset,2,'').
p0(gvget,2,'').

p0(set_bp_error,4,'').
p0(get_bp_error,4,'').
p0(clear_bp_error,0,'').


p0(dcg_phrase,3,'emulates DCG phrase/3 for HAGs').
p0(dcg_phrase,2,'emulates DCG phrase/2 for HAGs').
p0(dcg_apply,1,'applies a method like +(1) to current HAG stream').

p0(( :=: ),2,''). % for lval

p0((#),1,'short hand for dcg_connect/1'). % for i.v. dcgs
p0((#<),1,'short hand for dcg_def/1'). % for i.v. dcgs
p0((#>),1,'short hand for dcg_val/1'). % for i.v. dcgs

p0(pow,3,'').
p0('**',3,'returns arg 1 at power arg 2, a float'-x(2,3,_)).
p0(log,3,'returns log in base arg 1 of arg 2, a float'-x(2,8,_)).
p0(atan2,3,'float function').
p0(hypot,3,'float function').

p0(sqrt,2,'returns square root of arg 1, a float'-x(2,_)).
p0(exp,2,'float function').
p0(log,2,'float function').
p0(sin,2,'float function').
p0(cos,2,'float function').
p0(tan,2,'float function').

p0(asin,2,'float function').
p0(acos,2,'float function').
p0(atan,2,'float function').

p0(integer,2,'float to int cast').
p0(float,2,'float function').
p0(sign,2,'int function').
p0(abs,2,'int function').
p0(floor,2,'float to int function').
p0(ceiling,2,'float to int function').
p0(truncate,2,'float to int function').
p0(round,2,'float to int function').

p0(statistics,2,'returns info about data areas'-x(_,_)).
p0(predicate_property,2,'returns a property of a predicate'-
  predicate_property(write(_),_)
).
p0(current_predicate,2,'generates/checks name and head of a currently defined predicate').
p0(current_predicate,1,'generates/checks the head of an existing predicate').
p0(ctime,1,'gets elapsed time in ms'-x(_)).

p0(help,1,'same as apropos/1'-x(assert)).
p0(apropos,1,'prints names of predicates defined in the system'-
   x(garbage)).
p0(apropos,2,'returns names of predicates defined in the system'-
   x(retract,_)).
p0(unix,1,'executes various Unix commands').

p0(unix_argv,1,'gets the list of cmd line args from 1 to argc'-x(_)).

p0(unix_cat,1,'prints a file to user terminal').

p0(file2chars,2,'reads a file to a list of ascii codes').

p0(shell,1,'passes a command to the OS').
p0(system,1,'passes a command to the OS').
p0(system,2,'passes a command to the OS and gets back return code').
p0(cd,1,'changes local dir to arg 1').
p0(cd,0,'changes local dir to HOME directory or / if no such env var').
p0(pwd,0,'shows current dir').
p0(pwd,1,'returns current dir as a list of chars').

% extra.pl

p0(trace,1,'traces execution of a goal').
p0((dynamic), 1,'states that a predicate can be updated').
p0((multifile), 1,'states that clauses of a predicate can be in different files').
p0(is_multifile, 1,'').
p0((discontiguous), 1,'states that clauses of a predicate can be in different places').
p0(is_discontiguous, 1,'').
p0((delphi),1,'delphi(f/3-10) declares a Delphi predicate f/3 with memoing probability 10/100').
p0(is_delphi,2,
  'recognizes a Delphi predicate and returns its probability').
p0(delphi_call,3,'').
p0(delphi_call_1,3,'').
p0(memo_call,2,'').
p0(memo_call_1,2,'').
p0((memo),1,'declares a predicate Name/Arity to be memoized').

p0(term_hash,3,
  'computes hash code based on main functor and functors of listed argument positions; fails if something is unbound'-
  [term_hash(t(a,b),[1,2],_),
  term_hash(t(a,c),[1,2],_)]
).

p0(addq,3,'adds to end of persistent queeue'-
 x(key1,key2,33)).
p0(pushq,3,'adds to beginning of persistent queeue'-
 x(key1,key2,f(X,X))).
p0(cpopq,3,'pops (copy of) first element of persistent queue'-
 x(key1,key2,_)).
p0(cmembq,3,'generates (copies of) members of a queue'-
  x(key1,key2,_)).
p0(cdelq,4,'deletes first matching element from a queue'-
 x(key1,key2,_,_)).

p0(membq,3,'').
p0(memoq,3,'').

%p0(persistent,1,'').
%p0(is_persistent,1,'').

p0(set_db,1,'sets the name of active database for dynamic code').
p0(current_db,1,'gets the name of currently active database').

p0(asserted,1,'runs a predicated if asserted').
p0(asserta,1,'adds a clause to be first in a predicate definition').
p0(assertz,1,'adds a clause to be last in a predicate definition').
p0(assert,1,'adds a clause').
p0(retract,1,'backtracks over deleting matching clauses').
p0(retract1,1,'deletes first matching clause in the current database').
p0(retractall,1,'deletes all matching clauses').
p0(clause,2,
 'clause(H,B) generates a clause with head matching H and body B').
p0(abolish,1,'abolish(F/N) deletes predicate F/N').
p0(abolish,2,'').

p0(disable_static,1,'').
p0(disable_static,2,'').

p0(disable_builtins,0,'').

p0(db_asserted,2,'runs predicate arg 2 if asserted in database arg 1').
p0(db_asserta,2,'does asserta/1 arg 2 into database given as arg 1').
p0(db_assertz,2,'does assertz/1 arg 2 into database given as arg 1').
p0(db_assert,2,'does assert/1 arg 2 into database given as arg 1').
p0(db_retract,2,'does retract/1 arg 2 from database given as arg 1').
p0(db_retract1,2,'deletes from database given as arg 1 a matching clause').
p0(db_retractall,2,
  'removes fro database given as arg 1 all matching clauses').
p0(db_head,2,'generates/checks a predicate head in database (arg 1)').
p0(db_clause,3,
 'clause(DB,H,B) generates a clause found in database DB with head matching H and body B').
p0(db_abolish,2,'db_abolish(DB,F/N) removes predicate F/N from DB').
p0(db_abolish,3,'').
p0(db_clean,1,'db_clean(DB) abolishes all predicates in DB').
p0(db_clean,0,'abolishes all predicates in currently active database').
p0(db_move,2,'db_move(FromDB,ToDB) moves the content of database FromDB over database ToDB while replacing similar predicates').

p0(db_ratio,1,'sets/gets call/assert ratio which triggers dynamic recompilation').
p0(make_all_static,0,'').
p0(make_all_dynamic,0,'').

p0(make_static,1,'').
p0(make_dynamic,1,'').
p0(dyn2stat,1,'').
p0(dyn2stat,2,'').
p0(stat2dyn,1,'').
p0(stat2dyn,2,'').


p0(listing,0,'lists current database').
p0(listing,1,'lists given predicate if in current database').
p0(listing,2,'lists predicate F of arity N if in current database').
p0(assumei,1,'backtrackable: assertz style intuitionistic assumption').
p0(assumel,1,'backtrackable: assertz style linear assumption').
p0(assumeai,1,'backtrackable: asserta style intuitionistic assumption').
p0(assumeal,1,'backtrackable: asserta style linear assumption').
p0(assumed,1,'calls assumed clause with matching head').
p0(assumed_clause,2,
  'assumed_clause(H,B) retrieves assumed clause with matching head H and body B').
p0(assumed_clause,3,'').

p0((=>>),2,'intuitionistic implication - stack (asserta) ordering').
p0((=>),2,'intuitionistic implication - assertz ordering').
p0((-::),2,'affine linear implication - asserta ordering').
p0((-:),2,'affine linear implication - assertz ordering').
p0((=::),2,'linear implication - asserta ordering').
p0((=:),2,'linear implication - assertz ordering').

p0(throw,1,'throws a term to be caught by a matching catch').
p0(catch,3,'executes arg 1 and if it catches arg 2, it executes arg 3').
p0(catch0,4,'').
p0(call_cont,1,'calls arg 1 as current continuation').
p0(swap_cont,2,'calls arg 1 as cc and returns cc in arg 2').
p0(handle_uncaught,1,'calls arg 1 as current continuation').
p0(commit,0,'removes all choicepoints and executes current continuation').
p0(topcall,1,'calls arg 1 and signals uncaught throws').

p0(is_assumed,1,'checks if currently assumed').
p0(was_assumed,1,'checks if it was assumed  in current AND-branch').
p0(is_assumed,2,'checks if linear or intuitionistic').
p0(is_asserted,1,'checks if currently asserted').
p0(is_dynamic,1,'checks if dynamic').

p0(bb,0,'lists (long!) content of the blackboard').
p0(bb0,0,'').
p0(bb,1,'').
p0(bb_list,1,'').
p0(bb_element,2,'').

p0(sort,2,'sorts and removes duplicates'-
  x([2,1,3,1,4,4,2],_)).
p0(merge_sort,3,'').
p0(msort,2,'sorts and keeps duplicates'-
  x([2,1,3,1,4,4,2],_)).
p0(keysort,2,'sorts while grouping similar keys'-
  x([3-a,1-a,2-b,1-c,2-d],_)).

p0(bagof,3,'all solutions predicate generating bags of answers').
p0(setof,3,'all solutions predicate generating sets of answers').
p0((^),2,'calls arg 2 and binds arg 1').
p0(free_variables,4,'').
p0(not,1,'sound negation').
p0(vars_of,2,'lists free vars of a term'-
  x( f(X,t(X,_,Y),Y),_)
).


p0(term_chars,2,
  'converts between a term and its list of char code representation'-
[x(f(a,b),_),x(_,"f(a,b)")]).

p0(atom_chars,2,
  'converts between an atom and its list of char code representation'-
[x(hello,_),x(_,"hello")]).

p0(read_term_from_chars,2,
  'reads a term from a list of char codes'-
[x("f(X,X,Y,Y)",_)]).

p0(write_term_to_chars,2,
  'writes a term to a list of char codes'-
[x(f(X,X,Y,Y),_)]).

p0(read_term_from_chars,3,
  'reads a term with variable names from a list of char codes'-
[x("f(X,X,Y,Y)",_,_)]).

p0(write_term_to_chars,3,
  'writes a term with variables names to a list of char codes'-
[x(f(X,Y),['X'=X,'Y'=Y],_)]).

p0(write_term_to_chars1,3,'').

p0(read_tokens_from_chars,3,
  'reads tokens from a list of char codes'-
[x("f(X,X+Y,Y)",_,_)]).

p0(do_s2tokens,2,'').

p0(do_t2s,2,'').
p0(do_s2t,2,'').
p0(dcg_get_code,1,'').
p0(dcg_put_code,1,'').
p0(dcg_cwrite,1,'').
p0(dcg_write_name,1,'').
p0(dcg_nl,0,'').

% init.pl

p0(trim_term,2,'').
p0(trim_term,3,'').
p0(trim_term,4,
 'trim_term(D,Filler,T,NewT) replaces subterms of T deeper than D with Filler').
p0(user_error,2,'').
p0(errmes,2,'writes error message and fails').
p0(quietmes,1,'writes message if in low quietness mode').
p0(quietmes,2,'writes message if quietness is lower than arg 1)').
p0(debugmes,1,'writes message in debug mode (low quietness)').
p0(main,0,'user defined optional startup predicate').
p0(main,1,'default startup predicate').
p0(toplevel,0,'interactive toplevel Prolog loop').
p0(topstep,1,'interactive toplevel Prolog step').


% read.pl

p0(is_prolog,1,'recognizes binprolog - useful for portability').
p0(bp_only,1,'').
p0(bp_only,2,'').

p0(read,1,'reads a term').
p0(read_term,2,'reads a term and also a list of variable-name associations').
p0(top_read_term,2,'').
p0(warn_singletons,3,'').
p0(read_with_singletons,3,'').
p0(read_clause,1,'').
p0(read_tokens,2,'').
p0(get_code,1,'').
p0(put_code,1,'').
p0(nl,0,'').
p0(fast_write,1,'').
p0(write_float,1,'').
p0(generic_write,2,'').
p0(write,1,'writes to current output stream').
p0(print,1,'variant of write/1').
p0(writeq,1,'variant of write/1').
p0(portable_display,1,'').
p0(display,1,'writes to terminal while ignoring operator definitions').
p0(portray,1,'').
p0(portray_clause,1,'pretty prints a clause').
p0(pp_clause,1,'').
p0(pp_term,1,'').

p0(read_chars,1,'reads list of ascii codes').
p0(write_chars,1,'writes list of ascii codes').

p0(get_code,2,'inputs a char code from a stream').
p0(put_code,2,'outputs a char code to a stream').
p0(get_char,2,'inputs a char from a stream').
p0(put_char,2,'outputs a char to a stream').

p0(flush_output,0,'flushes current output stream').
p0(flush_output,1,'flushes a stream').

p0(file_size,2,'returns the size of a file, in bytes').

p0(ttyin,1,'').
p0(ttyout,1,'').

p0(ttyput,1,'').
p0(ttynl,0,'').

p0(ttyprin,1,'writes to terminal').
p0(ttyprint,1,'writes to terminal with a new line').

p0(ttycwrite,1,'').
p0(ttycwriteln,1,'').

p0(popen,3,
  'popen(Cmd,read/write,Stream) opens Stream using a pipe from/to process executing Cmd').
p0(pclose,1,'closes a pipe generated stream').
p0(pcollect,2,'collects output from a command to a list of char codes').

p0(fopen,3,
  'Prolog equivalent of C-function: opens a stream in a given mode and returns an integer handle to it').
p0(fclose,1,
  'closes the C-stream specifiend as an integer handle').

p0(open,3,
  'returns a stream (arg 3) on a file (arg 1) in read/write/append mode (arg 2)').
p0(close,1,'closes a stream opened by open/3').
p0(set_input,1,'sets current input stream').
p0(set_output,1,'sets current output stream').
p0(current_input,1,'gets current input stream').
p0(current_output,1,'gets current output stream').


p0(see,1,'focuses input on a file').
p0(seeing,1,'gets file name opened and set by see/1').
p0(seen,0,'close file opened by see/1').

p0(tell,1,'focuses output on a file').
p0(telling,1,'gets file name opened and set by tell/1').
p0(told,0,'closes file opened by tell/1').
p0(tell_at_end,1,'focuses output on file opened in append mode').

p0(see_at,1,'seeks a seekable file at a give offset (in bytes)').
p0(seeing_at,1,'retrieves position in current file opened by see/1').

p0(tell_at,1,'moves output file pointer to a given offset (in bytes)').
p0(telling_at,1,'retrieves output file position (in bytes)').

p0(file_search_path,1,'defines search path relative to BP_PATH').
p0(file_extension_list,1,'defines default file extensions for find_file').
p0(file_library,2,'').

p0(make_file_name,4,'').
p0(find_file,2,'finds a file name on search path').
p0(exists_file,1,'true if file exists').
p0(see_or_fail,1,'').
p0(flush,0,'').

p0(sread,3,'reads a term and a list of vars from a string (atom)').
p0(sread,2,'reads a term from a string (atom)').
p0(swrite,3,'writes a term with a liste of vars to a string (atom)').
p0(swrite,2,'writes a term to a string (atom)').

p0(bp_val,3,'unifies with 2 key indexed global logical variable').

p0(bu0,4,'').
p0(bu1,2,'').
p0(bu_ctr,2,'').

p0(current_op,3,'generates/check current op/3 operator definition(s)').
p0(op,3,
  'op(Pri,A,Op) defines an operator Op of priority Pri and associativity A').

%p0(pset,2,'').
%p0(pget,2,'').

p0(is_builtin,1,'recognizes a predicate head as a builtin').

p0(edit,2,'edit(E,F) edits file F with editor E').
p0(my_edit,1,'').

p0(edit,0,'calls DOS editor edit on last compiled file').
p0(ed,0,'edits last compiled/consulted file with default editor and refreshes it in memory').
p0(textedit,0,'calls texedit editor on last compiled file').
p0(emacs,0,'calls emacs editor on last compiled file').
p0(pico,0,'calls pico editor on last compiled file').
p0(notepad,0,'calls notepad editor on last compiled file').
p0(vi,0,'calls vi editor on last compiled file').

p0(co,0,'').
p0(current_user_file,1,'').
p0(ls,0,'list files under Unix').
p0(dir,0,'lists files under DOS').

p0(make_appl,1,'').
p0(make_executable_unix_appl,3,'').

p0(reboot,0,'regenerates BinProlog from its sources').
p0(remake,0,'').
p0(remake1,0,'').

p0(make,0,'').
p0(make,1,'').
p0(make,2,'').
p0(make,4,'').

p0(make,5,'').
p0(make0,4,'').

p0(cmake,0,'').
p0(cmake,1,'').
p0(cmake,2,'').
p0(kmake,0,'').
p0(kcmake,0,'').

p0(tboot,0,'').
p0(tboot,1,'').
p0(tboot,2,'').

p0(tmake,0,'').
p0(tmake,1,'').
p0(tmake,2,'').

p0(cboot,0,'').
p0(boot,0,'regenerates file wam.bp in BinProlog src directory').

p0(add_true,2,'').
p0(gc_read,1,'').
p0(gc_read_clause,1,'').
p0(call_body,1,'').
p0(expand_call_body,2,'').
p0(tr_body,2,'').
p0(char_in_cmd,2,'').
p0(show_code0,2,'').
p0(patch_it,4,'').
p0(lwrite,1,'').

p0(is_engine,1,'recognizes and integer as an engine handle').
p0(module_call,2,'').
p0((module),1,'').
p0((begin_module),1,'').
p0((end_module),0,'ends current module').
p0((end_module),1,'ends module if current, signals erro if not').

p0((module),2,'starts a module specifying a list of visible predicates').
p0(is_module,1,'recognizes/generates a module name').
p0(modules,1,'returns a list of existing modules').
p0(current_module,1,'gets name of current module').
p0(module_predicate,3,'').
p0(module_name,3,'').
p0((public),1,'declares globally visible predicate Name/Arity').
p0(is_public,1,'checks predicate head if globally visible').

p0(gensym,2,'generates a new name based on arg 1').
p0(gensym_no,2,'generates a new number based on arg 1').
p0(init_gensym,1,'resets gensym for names based on arg 1').

p0(spy_goal,1,'').
p0(spy,1,'set spy point on goal, triggering trace when interpreted').
p0(spying,1,'checks what we are spying').
p0(nospy,1,'do not spy on Pred/Arity anymore').
p0(trace,0,'trace all predicates when interpreted').
p0(notrace,0,'do not trace predicates when interpreted').

p0(otherwise,0,'always succeeds').
p0(false,0,'always fails').

p0(call_ifdef,2,'calls if predicate head is defined, calls arg 2 if not').
p0(callable,1,'checks if predicate head is defined (callable)').

p0(default,2,'default that can be overriden if assumed or asserted'-
  x(host(X),X=localhost)
).

p0(set_default,1,'asserts arg 1 as default state for use by default/2').

p0(copy_term,2,'returns a copy of arg 1 with fresh variables'-
 x(f(X,X,Y,Y),_)
).
p0(clone_term,3,
  'clone_term(Vs,T,CT) does copy_term(T,C) while keeping unchanged variables Vs'-
   x([X,Z],f(X,Y,Y,Z),_)
).

p0(phrase,2,'DCG evaluator').
p0(phrase,3,'DCG evaluator').

p0(nth_member,3,'retrieves N-th element of a list').
p0(member_i,4,'').

p0(saved,2,'').
p0(stat_dict,2,'').
p0(c_threshold,1,'').
p0(c_threshold,2,'').
p0(set_c_threshold,1,'sets C-ification threshold').
p0(set_c_threshold,2,'').
p0(set_c_trace,1,'').

p0(('C'),3,'DCG connect predicate').

p0(halt,0,'stops BinProlog').

p0((:),2,'M:P calls predicate P hidden in module M').

% lib pl

p0(hostname,1,'the name of current host, if detected, localhost if not').
p0(ip_addr,1,'the ip address of current host, if detected, that of localhost if not').

% extra.pl - Linda operations

p0(run_server,0,'runs foreground Linda server on localhost, on a free port').
p0(run_server,1,'runs foreground Linda server on given or on free Port').

p0(run_default_server,0,'runs foreground Linda server on localhost, port 9001 by default').

p0(fork_server,0,'runs background Linda server on localhost, port 9001 by default').
p0(fork_server,1,'forks Linda server and returns its Pid').
%p0(fork_server,2,'forks Linda server on Port and returns its Pid').

p0(stop_server,0,'stops server and forces it back to intractive mode').
p0(stop_server,1,'stops server using given password').

p0(halt_server,0,'halts Linda server').
p0(halt_server,1,'halts Linda server using given password').

p0(ask_server,2,'sends a query and gets an answer from server(s)').
p0(ask_a_server,2,'sends a query and gets an answer from a Linda server').
p0(ask_a_server,5,'args: Interactor,Host,Port,Question,Answer').
p0(ask_all_servers,2,'broadcast query to all server given by master').

%p0(sock_read_term,2,'reads a term from a socket').
%p0(sock_write_term,2,'writes a term to a socket').

p0(server_loop,2,'answers client queries on server').

p0(term_server_action,1,'opens service socket and answers query').

p0(term_server_interactor,2,'filters secure commands known to the server').


p0(term_server_step,1,'answers query on service socket').

p0(term_client_action,4,'opens client socket and sends query').

p0(term_client_step,3,'sends query on client socket').

p0(unrestricted_server_interactor,2,
  'allows unrestricted commands run1/ run/2 on the server').

p0(run_unrestricted_server,0,'runs foreground Linda server on localhost, on a free port').

p0(master_server_interactor,2,'filters commands available on master server').

p0(ask_master_server,2,'asks a question the master server').

p0(new_service,2,
  'creates new service socket on server socket and returns it').

p0(new_server_on_free_port,2,
  'runs new server on first random free port').

p0(new_client,1, 'creates new client socket and returns it').

p0(from_sock,2,'copies from a socket to a file (fast, all in C)').
p0(to_sock,2,'copies from a file to a socket (fast, all in C)').

p0(out,1,'puts a term on Linda server').
p0(in,1,'waits to remove a term from Linda server').
p0(all,2,'gets the list of terms matching arg 1 from Linda server').
p0(all,3,'gets a selection arg 1 of terms matching arg 2 from Linda server').
p0(rd,1,'reads a terms matching arg 1 from Linda server').
p0(cin,1,'tries to remove a term from Linda server').
p0(cout,1,'adds a term to server, unless already a matching one there').
p0(id,1,'gets identity info from current remote server').
p0(this_id,1,'gets identity info of this server').
p0(detect_user,1,'guesses the user from environment information').
p0(detect_host,1,'guesses, if possible, an IP address different form localhost').

% overridable defaults

p0(default_host,1,'returns default host for remote Linda server').
p0(set_host,1,'asserts IP adress or name of server host we want to talk to').
p0(host,1,'assumes default host for Linda server').

p0(default_port,1,'returns default port for remote Linda server').
p0(set_port,1,'asserts port number of the server we want to talk to').
p0(port,1,'assumes default port for Linda server').

p0(default_server_port,1,'returns default port to work as a server on').
p0(server_port,1,'assumes default port for to work as a server on').
p0(set_server_port,1,'asserts default port for to work as a server on').

p0(default_code,1,'returns default remote code file on Linda server').
p0(set_code,1,'asserts default file on server - for remote code fetching').
p0(code,1,'assumes default remote code file on Linda server').

p0(default_server_action,1,'returns default server-side action').
p0(set_server_action,1,'asserts default server-side action').
p0(server_action,1,'assumes default server-side action').

p0(default_server_interactor,1,'returns default server-side answerer').
p0(set_server_interactor,1,'asserts default server-side interactor').
p0(server_interactor,1,'assumes default server-side intractor').

p0(default_client_action,1,'returns default client-side action').
p0(set_client_action,1,'asserts default client-side action').
p0(client_action,1,'assumes default client-side action').

p0(default_timeout,1,'returns default socket wait timout').
p0(set_timeout,1,'asserts default socket wait timout').
p0(timeout,1,'assumes default socket wait timout').

p0(set_id,1,'sets identification number after receiving it from a server').
p0(get_id,1,'gets identification number previously obtained from server').

p0(default_master_server,2,'returns master server (Host and Port)').
p0(set_master_server,2,'asserts default master server (Host and Port)').
p0(master_server,2,'assumes default master server (Host and Port)').

p0(default_proxy_server,2,'returns proxy server (Host and Port)').
p0(set_proxy_server,2,'asserts default proxy server (Host and Port)').
p0(proxy_server,2,'assumes default proxy server (Host and Port)').

p0(default_login,1,'returns default (nick)name for user').
p0(set_login,1,'asserts default (nick)name for user').
p0(login,1,'assumes default (nick)name for user').

p0(default_password,1,'returns default password for user').
p0(set_password,1,'asserts default password for user').
p0(password,1,'assumes default password for user').

% end defaults

p0(run_master_server,0,'runs master server keeping track of servers').
p0(run_master_server,1,'runs kind of master server given as arg 1').
p0(fork_master_server,0,'forks master server in separate process').
p0(run_local_master_server,0,'runs master server on local host').

p0(register_server,0,'registers this on master server').
p0(register_server,1,'registers this on master server and returns answer').

p0(all_servers,0,'prints the list of servers registered on master server').
p0(all_servers,1,'returns list of servers registered on master server').
p0(all_servers,2,'returns servers registered on master matching arg 1').

p0(refresh_servers,0,'asks master server to update its list of servers').
p0(refresh_servers,1,'asks master server to update its list of servers matching arg 1').
p0(cleanup_dead_servers,1,'on master: removes servers who do not answer').

p0(ping,1,'checks if server is alive and returns its current CPU time').
p0(ping,0,'checks if server is alive').

p0(remote_run,1,'runs Goal on remote Linda server').
p0(remote_run,2,'runs arg 2 on remote server and unifies arg 1 with result').
p0(remote_mes,3,'sends From, Mes and returns yes if displayed on server').
p0(say,1,'sends Mes and succeds if displayed on server').
p0(yell,1,'broadcasts Mes to all servers on default master server').

p0(proxy,4,'args: Host,Port,Query,Answer, asks proxy to forward Query to Host').

p0(chat,0,'sends what you type in to all BinProlog users').
p0(chat,1,'sends what you type in to selected BinProlog users').
p0(talk,0,'sends what you type in another BinProlog user').

p0(ask_servant,3,'sends query and waits until servant answers').
p0(run_servant,0,'executes queries obeying to sever at default host, port').

p0(all_servants,0,'lists all servants on current server').
p0(all_servants,1,'returns all servants on current server').

%now built in all servers
%p0(run_forwarding_server,0,'runs server which forwards quieries to servants').
%p0(forwarding_server_interactor,2,'interactor forwarding to servants').

p0(rsh,2,'runs arg 1 as a remote shell command and collects the result').
p0(rsh,1,'runs arg 1 as a remote shell command and prints result').
p0(rexec,2,'runs arg 1 as a remote PC command and collects the result').
p0(rexec,1,'runs arg 1 as a remote PC command and prints the result').
p0(rshell,0,'runs commands on remote PC and prints the result').

p0(non_local_host,0,'checks if BinProlog is talking to a remote host').
p0(fetch_and_call,1,'fetches remote code for arg 1  and calls it').
p0(fetch_pred_for,1,'fetches remote code for arg 1, without calling it').
p0(fetch_file,1,'fetches code from remote file (arg 1) on server').
p0(fetch_file,4,'fetches remote code, args:RemoteF,RemoteDB,Head,LocalDB').
p0(fetch_remote_operators,0,'fetches operators in use on remote server').

p0(start_remote_engine,3,'starts remote engine, args: Answer,Goal,Engine').
p0(ask_remote_engine,2,'askes remote engine, args: Engine,Answer').
p0(stop_remote_engine,1,'stops and frees resources of remote engine').

p0(db_mirror,2,'mirrors a file (arg 1) as a database (arg 2)').

p0(rget,1,'downloads remote (binary) file from Linda server').
p0(rget,2,'copies remote (binary) file arg1 to local file arg 2').

p0(rput,1,'uploads (binary) file to Linda server').
p0(rput,2,'copies local (binary) file arg1 to remote file arg 2').

p0(fput_chars,2,'puts to CStream list of chars in arg 2').
p0(fget_chars,4,'gets from CStream, BufSize, PlacesNotFilled, Chars').

p0(fget,1,'downloads remote (binary) file from Linda server').
p0(fget,2,'copies remote (binary) file arg1 to local file arg 2').

p0(fput,1,'uploads (binary) file to Linda server (fast)').
p0(fput,2,'copies local (binary) file arg1 to remote file arg 2 (fast)').

p0(rconsult,1,'downloads to cache/file.pl and reconsults').
p0(rcompile,1,'downloads to cache/file.pl and compiles').
p0(rload,1,'downloads to cache/file.bp and loads it').

p0(this,1,'').
p0((extends),2,'').
p0((with),2,'').
p0((extends),1,'').
p0((::),2,'').
p0((:=),2,'').
p0((::),1,'').
p0((:-),2,'').
p0((@),1,'').
p0((^),1,'').
p0((>>),2,'').
p0((<<),2,'').
p0(is_object,1,'').
p0(is_proto,1,'').
p0(is_verb,1,'').

p0(default_proto,1,'').

p0(oblist,0,'').
p0(oblist,1,'').
p0(oblist,2,'').
p0(oblist0,2,'').

p0(bp_info,2,'keeps basic help info on BinProlog builtins').
p0(bp_info,3,'').
p0(extract_ex,3,'').
p0(info,0,'generates info on predicates with examples').
p0(info,1,'generates info and examples of use for predicate Pred/Arity').
p0(show_info,2,'generates components of info/1 output').
p0(has_info,1,
  'checks/generates predicates Pred/Arity for which info is available').


% ---------- tools to generate builtins.pl -------------- %

  
make_ps:-
  test_ps,
  make_ps0.

test_ps:-
  findall(F/N,p0(F,N,_),Xs),length(Xs,L1),sort(Xs,Ys),length(Ys,L2),
  (L2=:=L1->true
  ; tell(user),write('redundant relation in p0/3'),
    nl,halt
  ).

make_ps0:-
  p0(F,N,X),
  functor(P,F,N),
  pp_c(bu1(P,X)),
  fail.
make_ps0:-
  nl.

get_all_bs(Bs):-
  G0=(b0(F/N,X,Y,Z),N1 is N+1,functor(B,F,N1)),
  G=b0(B,X,Y,Z),
  findall(G,G0,Bs).

filter_b(Class,All,N):-
  arg(1,Class,I),
  findall(I-B,
    ( member_i(OldB,All,0,_),
      rewrite_b(Class,OldB,B)
    ),
  Bs),
  length(Bs,N),
  ( member_i(I-B,Bs,0,I),
    pp_c(B),
    fail
  ; nl
  ).

rewrite_b(n_inline(N),b0(B,simple,in_body,X), bu0(B,N,in_body,X)).
rewrite_b(n_arith(N),b0(B,arith(K),in_body,X),bu0(B,arith(N,K),in_body,X)).
rewrite_b(n_builtin(N),b0(B,simple,in_head,X),bu0(B,N,in_head,X)).

/*
pp_c(C):-
  numbervars(C,0,_),
  writeq(C),write('.'),nl,fail.
pp_c(_).
*/

pp_c(C):-portray_clause(C). % had a bug with writing out anonymous vars

make_builtins(Start,Info):-
  Info=[P1,P2,P3,P4],
  get_all_bs(All),
  P1=n_inline(A1),filter_b(P1,All,N1),
  P2=n_arith(A2),filter_b(P2,All,N2),
  P3=n_builtin(A3),filter_b(P3,All,N3),
  P4=n_nop(A4),
  A1=Start,
  A2 is A1+N1,
  A3 is A2+N2,
  A4 is A3+N3,
  pp_ctr(P1),
  pp_ctr(P2),
  pp_ctr(P3),
  pp_ctr(P4),
  nl.

pp_ctr(P):-P=..[F,X],NewP=bu_ctr(F,X),pp_c(NewP).
  
make_pl(N,Info):-
  BU='builtins.pl',
  write(making(BU)),nl,
  tell(BU),
  make_builtins(N,Info),
  make_ps,
  gen_tables,
  told.

go(Start):-
  make_pl(Start,Info),
  make_h(Info),
  check_headers.

make_h(Info):-
  DEF='defs.h',PROF='prof.h',
  Info=[n_inline(First),n_arith(Arith),n_builtin(Bu),n_nop(Nop)],
  Last is Nop-1,
  write([inline=First,arith=Arith,in_body=Bu,last=Last]),nl,
  write(making(DEF)),nl,
  tell(DEF),
  ( make_defs(First,Arith,Bu,Last)
  ; tell(user),write(failing_on(DEF)),nl,tell(DEF)
  ),
  !,
  make_stats,
  make_vals,
  !,
  told,
  write(making(PROF)),nl,
  tell(PROF),
  (   make_names(Info)
    ; tell(user),write(failing_on(PROF)),nl,tell(DEF)
  ),
  !,
  told.

make_defs(First,Arith,Bu,Last0):-
  number_bu(First,Last,N-X),
  write('#define '),write(X),write(' '),write(N),nl,
  N=:=Last,
  !,
  Last=:=Last0,
  nl,write('#define INLINE '),write(First),nl,
  write('#define ARITH '),write(Arith),nl,
  write('#define BUILTIN '),write(Bu),nl,
  write('#define LAST_BUILTIN '),write(Last),nl.

make_stats:-
        nl,
        stat_dict(Name,Val),name(Name,L),
        to_upper(L,L1),
        lappend("STAT_",L1,L2),
        name(SName,L2),
        write('#define '),write(SName),write(' '),write(Val),nl,
        fail.
make_stats:-nl.

make_names(Info):-
  Info=[n_inline(Max)|_],
  write('#if TRACE>0 || PROF '),nl,
  write('char *bu_name[]={'),nl,
  number_bu(Max,Last,N-X),
  write('"'),write(X),write('",'),nl,
  N=:=Last,
  !,
  write('"LAST_BUILTIN"};'),nl,write('#endif'),nl,nl.

number_bu(First,Last,N-X):-
  bagof(B,bname(B),Bs),
  length(Bs,L),!,Last is First+L-1,
  member_i(X,Bs,First,N).

to_upper1(X,Y):-[A]="a",[Z]="z",X>=A,X=<Z,[AA]="A",!,
  Y is AA+(X-A).  
to_upper1(X,X).

to_upper([],[]).
to_upper([X|Xs],[Y|Ys]):-
  to_upper1(X,Y),
  to_upper(Xs,Ys).

b_idiom(+,"PLUS").
b_idiom(-,"SUB").
b_idiom(*,"MUL").
b_idiom(//,"DIV").
b_idiom(/,"FDIV").
b_idiom(put,"PUT0").

b_idiom(<<,"LSHIFT").
b_idiom(>>,"RSHIFT").
b_idiom(/\,"L_AND").
b_idiom(\/,"L_OR").
b_idiom(#,"L_XOR").
b_idiom(\,"L_NEG").

to_bname(F,U):-b_idiom(F,U),!.
to_bname(F,U):-name(F,L),to_upper(L,U).

bname(Name):-
  [X]="_",
  b0(F/N,_,_,_),name(N,Arity),
  to_bname(F,U),
  lappend(U,[X|Arity],List),
  name(Name,List).

lappend([],Ys,Ys).
lappend([A|Xs],Ys,[A|Zs]):-
        lappend(Xs,Ys,Zs).

lmember(X,[X|_]).
lmember(X,[_|Xs]):-lmember(X,Xs).

range(Min,Min,Max):-Min=<Max.
range(I,Min,Max):-Min<Max,Min1 is Min+1,range(I,Min1,Max).

% char tables

maj(Ch):- 
	Ch >= 65, Ch =< 90
;	Ch=95
;	latin1_maj(Ch).

min(Char):- 
	Char >= 97, Char =< 122
;	latin1_min(Char).

num(Char) :- Char >= 48, Char =< 57.

% support for latin1 - thanks to Ulrich Neumerkel

latin1_maj(Ch) :- 
	Ch >= 192, Ch =< 214
;	Ch >= 216, Ch =< 222. 

latin1_min(Ch) :- 
	Ch >= 223, Ch =< 246
;	Ch >= 248, Ch =< 254.

an(Char):- 
	min(Char)
;	maj(Char)
;	num(Char).

spec(35).
spec(36).
spec(38).
spec(42).
spec(43).
spec(45).
spec(46).
spec(47).
spec(58).
spec(60).
spec(61).
spec(62).
spec(63).
spec(64).
spec(92).
spec(94).
spec(96).
spec(126).

terminator(10).
terminator(13).
terminator(-1).

% CHAR=MIN|MAJ|NUM|LMAJ|LMIN|SPEC|TERMIN|OTHER

gen_table(Arg,Generator,Name,Target):-
  lsymcat(is,Name,IsName),
  Source=..[Name,Arg],
  Target=..[IsName,Arg],
  Generator,
  Source.
  
lsymcat(Op,Type,OpType):-	
	[Link]="_",
	name(Op,Pref),
	name(Type,Suf),
	lappend(Pref,[Link|Suf],Chars),
	!,
	name(OpType,Chars).

gen_tables:-
  nl,
  lmember(Name,[maj,min,num,an,spec,terminator]),nl,
  gen_table(Char,range(Char,-1,254),Name,Target),
  write(Target),write('.'),nl,
  fail
; nl.

make_vals:-
  nl,
  make_one_val,
  fail
; write('}'),nl,nl.


make_one_val:-
  write('#define MAKE_BP_VALS() {\'),nl,
  bp_val(V,H,I),
  functor(H,F,N),
  write('  BP_VAL(INPUT_STRING("'),write(V),
  write('"),new_func("'),write(F),write('",'),write(N),
  write('),INPUT_INT('),write(I),write('));\'),nl.
  

check_headers:-
    is_prolog(binprolog),
    write('Unused, possibly new public predicates: '),nl,
    ( b0(F,N,_,_)
    ; p0(F,N,_)
    ),
    functor(P,F,N),
    \+ is_compiled(P),
    write('unused, possibly new predicate: '),write(F/N),nl,
    fail.
check_headers.
