/* This file contains ISO-versions of some builtins
*  and various other ISO extensions.
*/

#include <string.h>
#include <ctype.h>
#include <assert.h>
#include <sys/types.h>
#include <unistd.h>
#include "global.h"

extern struct specsyms g;
extern struct limit max;
extern string *atomtable;
extern term *unwind_trail(),local_error();
extern term unify();
extern string lextable,newlex;
extern no newatom;
extern no hcount;
extern no hget(),hset(),hdef();
extern hentry htable;

extern term readterm();

term iso_open_stream_3(H,regs,wam,A)
register term H,regs,*A;
register stack wam;
{ 
  string opt,cmd; FILE *f;
  opt=NAME(X(1));
  cmd=NAME(X(2));
  if (!strcmp(cmd,"user_input")) f = stdin;
  else if (!strcmp(cmd, "user_output")) f = stdout;
  else if(!(f=fopen(cmd,opt))) return 0;
  if (opt[0] == 'r')
    allocatefilebuffer(f,cmd);
  PUSHVAL(INPUT_INT((cell)(f)>>2));
  return H;
}

int iso_close_stream_2(H,regs,wam,A)
register term H,regs,*A;
register stack wam;
{ 
  string opt; 
  opt=NAME(X(1)); 
  if (fileno((FILE*)(OUTPUT_INT(X(2))<<2)) >= 3)
    fclose((FILE*)(OUTPUT_INT(X(2))<<2));
  if (opt[0] == 'r')
    returnfilebuffer((FILE*)(OUTPUT_INT(X(2))<<2));
  return 1;
}

term iso_read_term_3(H,regs,wam,A)
register term H,regs,*A;
register stack wam;
{ 
  register term result;

  if (result = readterm(OUTPUT_INT(X(1))<<2,H)) {
    term *options;
    cell  xval;
    options = (term*)(X(2));
    DEREF2(options[1],xval);
    if ((cell)xval & 4) /* variables */
      if (!unify(options[2],makevariablesoption(H),wam,A)) return 0;
    if ((cell)xval & 8) /* variable_names */
      if (!unify(options[3],makevariable_namesoption(H),wam,A)) return 0;
    if ((cell)xval & 16) /* singletons */ {
      if (!unify(options[4],makesingletonsoption(H),wam,A)) return 0;
    }
    releasevars();
    return result;
  } else {
    releasevars();
    return 0;
  }
}

int iso_write_term_3(H,regs,wam,A)
register term H,regs,*A;
register stack wam;
{
  term xref = (term)X(1);
  cell xval = (cell)NULL;

  FDEREF(xref);
#if 1
  assert(INTEGER(xval)); 
  return writeterm(OUTPUT_INT(xval)<<2, X(3), OUTPUT_INT(X(2)));
#else
  return writeterm(stdout, X(3), OUTPUT_INT(X(2)));
#endif
}

FILE *current_output()
{
  term xref = (term)hget(new_func("current_stream",0), new_func("write",0));
  cell xval = (cell)NULL;

  FDEREF(xref);
  xref = (term)(xref[1]);
  FDEREF(xref);
  return (FILE*)(OUTPUT_INT(xval)<<2);
}

FILE *current_input()
{
  term xref = (term)hget(new_func("current_stream",0), new_func("read",0));
  cell xval = (cell)NULL;

  FDEREF(xref);
  xref = (term)(xref[1]);
  FDEREF(xref);
  return (FILE*)(OUTPUT_INT(xval)<<2);
}
