p:-compile(bug).
go:-bug.

out_check(1).

% data
	input(1,1,0.03). input(1,2,0.03).
	input(2,1,0.97).   input(2,2,0.03).
	input(3,1,0.03). input(3,2,0.97).
	input(4,1,0.97).   input(4,2,0.97).

	output(1,1,0.03). output(1,2,0.03).
	output(2,1,0.03). output(2,2,0.97).
	output(3,1,0.03). output(3,2,0.97).
	output(4,1,0.97).   output(4,2,0.03).
	
sum([],S0,S0):-!.
sum([X|Xs],S1,S3):-
	S2 is S1+X,
	sum(Xs,S2,S3).

def2(N,I,J,X):-K is 5*I+J,bb_def(N,K,X).
val2(N,I,J,X):-K is 5*I+J,val(N,K,X).
put2(N,I,J,X):-K is 5*I+J,bb_set(N,K,X).

def_weight(I,J,K,X):-L is 3*I+J,bb_def(L,K,X).
get_weight(I,J,K,X):-L is 3*I+J,val(L,K,X).
put_weight(I,J,K,X):-L is 3*I+J,bb_set(L,K,X).

initialize :-
	init_err_out
;	init_weight
;	true.

init_err_out:-
	for(I,0,2),
	  for(J,0,2),
	    def2(err,I,J,0.0),
	    def2(out,I,J,0.97),
	fail.

init_weight:-	
	for(I,1,2),
	  for(J,1,2),
	    for(K,0,2),
	      random(100,R),Rand is R/100.0,
	      W is 0.2*Rand-0.1,
	      def_weight(I,J,K,W),
	fail.
	  	
get_input(Step):-
	for(J,1,2),
	  input(Step,J,Output0),
	  put2(out,0,J,Output0),
	fail.


print_cells:-
		for(J,1,2),
		  val2(out,2,J,Out),
		  write(' '),write(Out),
		fail
;	true.


random_init:-bb_let(rseed,rseed,43).

random(Max,R):-
        val(rseed,rseed,X),!,
        Y is (X*17+131) mod 31183,
        % Y is (X*7+131) mod 331,
        bb_set(rseed,rseed,Y),
        R is Y mod Max.


forward_pass0:-
	for(Row,1,2),
	  for(Col,1,2),
	    forward_pass(Row,Col),
	fail.

forward_pass0(Row,Col):-
	findall(O,forward_calc0(Row,Col,O),Os),
write(os=Os),nl,
	sum(Os,0.0,Sum),
ttyprint(sum(Sum)),
	NSum is -Sum,
        exp(NSum,Exp),
ttyprint(exp(Exp)),
        Out is 1.0/(1.0+Exp),
	put2(out,Row,Col,Out),
	put2(err,Row,Col,0.0).


forward_calc0(Row,Col,Sum):-
	Row1 is Row-1,
	for(J,0,2),
	val2(out,Row1,J,Out1),
	get_weight(Row,Col,J,W),
	Sum is W*Out1.



iterate0:-
	get_input(1)
;	forward_pass0(1,1),fail
; print_cells,nl,fail
;	forward_pass0(2,1),fail
; print_cells,nl,fail.

 
bug:-
  random_init,
  initialize,
  iterate0.


bug1:-Os=[0.023280,-0.002280],sum(Os,0.0,X),write(X),nl.
