/*
Some of this is now obsolete as is provided in BinProlog 5.00

Return-Path: <hartrump@mailhost.uni-koblenz.de>
Received: from infko.uni-koblenz.de (mailhost.uni-koblenz.de) by clement.info.umoncton.ca (4.1/SMI-4.1)
	id AA13563; Tue, 11 Apr 95 08:23:57 ADT
Received: from brian.uni-koblenz.de (hartrump@brian.uni-koblenz.de [141.26.4.22]) by infko.uni-koblenz.de (8.6.9/8.6.9) with SMTP id NAA03177 for <binprolog@info.umoncton.ca>; Tue, 11 Apr 1995 13:21:17 +0200
From: Sven Hartrumpf <hartrump@informatik.uni-koblenz.de>
Message-Id: <199504111121.NAA03177@infko.uni-koblenz.de>
Received: by brian.uni-koblenz.de (4.1/KO-2.0)
	id AA24743; Tue, 11 Apr 95 13:21:33 +0200
Subject: implementations for ISO built-ins
To: binprolog@info.umoncton.ca
Date: Tue, 11 Apr 1995 13:21:33 +0200 (MET DST)
X-Mailer: ELM [version 2.4 PL24]
Mime-Version: 1.0
Content-Type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 8bit
Content-Length: 10214
Status: RO

Hello Paul,

I keep on using BinProlog. And with each new version, I get more and more
satisfied. As I have to write mostly portable code (i.e. ISO Prolog) I have
developed a file that contains implementations of many ISO built-in predicates
that are missing in BinProlog 3.30.  I encourage you to include them in
the next release. Some of them may need some error detection like
"first argument must be ground" and may be implemented more efficiently.
Some naming problems are mentioned at the beginning of the file.
My implementations for I/O predicates are just a hack as I have seen
that there are already predicates named iso_open etc, which I can't use
at the moment (but will be able to use in the future?).

Thanks for making your work publicly available,

Regards,

Sven
*/


% isobi_bp.pl
% All ISO built-in predicates.
% (See chapter 8 and 9 of the draft ISO standard for Prolog, March 1993)
% This file contains some implementations for predicates etc that are missing
% in BinProlog 3.30.
% Predicates etc that are not provided are marked "%% missing".
% Sven Hartrumpf (C) 1994, 1995

/* Non-standard predicates etc whose names should be freed by removing them
   from BinProlog (this is a matter of taste, of course):

abolish/2 (should become abolish/1)
float/1   (should be named real/1) 
flush/0   (should be named flush_output/0)
get/1
get0/1
integer/2 (should be named floor/2)
name/2    (should be split into atom_codes/2 and number_codes/2)
pow/3     (should be named '**'/3)
put/1

Operator mod should have priority 400 and mode yfx (?).
Operator \ should have priority 200 (not 500) and mode fy (not fx) (?).
Operator - should have priority 200 (not 500) and mode fy (not fx) (?).

*/


/*
:- module(isobi_bp, [
'\='/2,
abolish/1,
atom_codes/1,
atom_concat/3,
atom_length/2,
close/2,
current_input/1,
current_output/1,
fail_if/1,
number_codes/1,
once/1,
open/3,
set_input/1,
set_output/1
...
]).
*/


% standard operators

:- op(1200,  fx, ?-).
:- op( 400, yfx, rem).
:- op( 200, xfx, **).
:- op( 100, xfx, @).
:- op(  50, xfx, :).


% term unification


% =/2
% '='(?term,?term)


% unify_with_occurs_check/2
% unify_with_occurs_check(?term,?term)

%% missing


% \=/2
% '\='(@term,@term)

% \=(A, B) :- \+ (A = B).


% type testing


% var/1
% var(@term)


% atom/1
% atom(@term)


% integer/1
% integer(@term)


% real/1
% real(@term)

real(X) :-
  float(X).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% atomic/1
% atomic(@term)


% compound/1
% compound(@term)


% nonvar/1
% nonvar(@term)


% number/1
% number(@term)


% term comparison


% ==/2
% '=='(@term,@term)


% \==/2
% '\=='(@term,@term)


% @</2
% '@<'(@term,@term)


% @=</2
% '@=<'(@term,@term)


% @>/2
% '@>'(@term,@term)


% @>=/2
% '@>='(@term,@term)


% term creation and decomposition


% functor/3
% functor(-nonvar,+constant,+integer)
% functor(@nonvar,?constant,?integer)


% arg/3
% arg(+integer,+compound_term,?term)


% =../2
% '=..'(+nonvar,?list)
% '=..'(-nonvar,+list)


% copy_term/2
% copy_term(?term,?term)


% is/2
% 'is'(?nonvar,+nonvar)


% arithmetic comparison


% =:=/2
% '=:='(+nonvar,+nonvar)


% =\=/2
% '=\='(+nonvar,+nonvar)


% </2
% '<'(+nonvar,+nonvar)


% =</2
% '=<'(+nonvar,+nonvar)


% >/2
% '>'(+nonvar,+nonvar)


% >=/2
% '>='(+nonvar,+nonvar)


% clause retrieval and information


% clause/2
% clause(+head,?body)


% current_predicate/1
% current_predicate(?predicate_indicator)


% clause creation and destruction


% asserta/1
% asserta(@clause)


% assertz/1
% assertz(@clause)


% retract/1
% retract(+clause)


/*
% abolish/1
% abolish(@predicate_indicator)

abolish(F/N) :-
  abolish(F, N).
*/

% all solutions


% findall/3
% findall(@term,@callable_term,?list)


% bagof/3
% bagof(@term,+callable_term,?list)


% setof/3
% setof(@term,+callable_term,?list)


/*
% stream selection and control


% current_input/1
% current_input(?stream)

current_input(X) :-
  seeing(X).


% current_output/1
% current_output(?stream)

current_output(X) :-
  telling(X).


% set_input/1
% set_input(@stream_or_alias)

set_input(S) :-
  (  S == user_input
  -> see(user)
  ;  see(S)
  ).


% set_output/1
% set_output(@stream_or_alias)

set_output(S) :-
  (  S == user_output
  -> tell(user)
  ;  tell(S)
  ).


% open/3
% open(@source_sink,@io_mode,-stream)

open(N, read, S) :-
  seeing(Old),
  see(N),
  seeing(S),
  see(Old).

open(N, write, S) :-
  telling(Old),
  tell(N),
  telling(S),
  tell(Old).


% open/4
% open(@source_sink,@io_mode,-stream,@io_options)

%% missing


% close/1
% close(@stream_or_alias)

%% missing


% close/2
% close(@stream_or_alias,@close_options)

%% missing. This is an implementation to simulate close/1.

close(N, read) :-
  see(N),
  seen.

close(N, write) :-
  tell(N),
  told.


% flush_output/0
% flush_output

flush_output :-
  flush.


% flush_output/1
% flush_output(@stream_or_alias)

flush_output(S) :-
  telling(Old),
  tell(S),
  flush,
  tell(Old).
*/


% stream_property/2
% stream_property(?stream,?stream_property)

%% missing


% at_end_of_stream/0
% at_end_of_stream

%% missing


% at_end_of_stream/1
% at_end_of_stream(@stream_or_alias)

%% missing


% set_stream_position/2
% set_stream_position(@stream_or_alias,@stream_position)

%% missing


/*
% character input/output


% get_char/1
% get_char(?character)

get_char(Character) :-
  get_code(Code),
  atom_codes(Character, [Code]).


% get_char/2
% get_char(@stream_or_alias,?character)

get_char(S, Character) :-
  get_code(S, Code),
  atom_codes(Character, [Code]).


% put_char/1
% put_char(@character)

put_char(Character) :-
  atom_codes(Character, [Code]),
  put_code(Code).


% put_char/2
% put_char(@stream_or_alias,@character)

put_char(S, Character) :-
  atom_codes(Character, [Code]),
  put_code(S, Code).


% nl/0
% nl


% nl/1
% nl(@stream_or_alias)

nl(S) :-
  telling(Old),
  tell(S),
  nl,
  tell(Old).


% character code input/output


% get_code/1
% get_code(?character_code)


% get_code/2
% get_code(@stream_or_alias,?character_code)

get_code(S, Code) :-
  seeing(Old),
  see(S),
  get_code(Code),
  see(Old).


% put_code/1
% put_code(@character_code)


% put_code/2
% put_code(@stream_or_alias,@code)

put_code(Out, Code) :-
  telling(Old),
  tell(Out),
  put_code(Code),
  tell(Old).
*/


% term input/output


% read_term/2
% read_term(?term,+read_options_list)


% read_term/3
% read_term(@stream_or_alias,?term,+read_options_list)

read_term(S, Term, []) :-
  !,
  seeing(Old),
  see(S),
  read(Term),
  see(Old).

read_term(S, Term, [variable_names(Vars)]) :-
  seeing(Old),
  see(S),
  read_term(Term, Vars),
  see(Old).


% read/1
% read(?term)


% read/2
% read(@stream_or_alias,?term)

read(S, Term) :-
  seeing(Old),
  see(S),
  read(Term),
  see(Old).


% write_term/2
% write_term(@term,@write_options_list)

%% incomplete

write_term(Term, []) :-
  write(Term).


% write_term/3
% write_term(@stream_or_alias,@term,@write_options_list)

%% incomplete

write_term(Out, Term, []) :-
  telling(Old),
  tell(Out),
  write(Term),
  tell(Old).


% write/1
% write(@term)


% write/2
% write(@stream_or_alias,@term)

write(Out, T) :-
  telling(Old),
  tell(Out),
  write(T),
  tell(Old).


% writeq/1
% writeq(@term)


% writeq/2
% writeq(@stream_or_alias,@term)

writeq(Out, T) :-
  telling(Old),
  tell(Out),
  writeq(T),
  tell(Old).


% write_canonical/1
% write_canonical(@term)

%% missing


% write_canonical/2
% write_canonical(@stream_or_alias,@term)

%% missing


% op/3
% op(@integer,@operator_specifier,@atom_or_atom_list)


% current_op/3
% op(?integer,?operator_specifier,?atom)


% char_conversion/2
% char_conversion(@character,@character)

%% missing


% current_char_conversion/2
% current_char_conversion(?character,?character)

%% missing


% logic and control


% fail_if/1
% fail_if(@callable_term)

fail_if(G) :-
  \+ G.

/*

% once/1
% once(+callable_term)

once(G) :-
  G,
  !.
*/

% repeat/0
% repeat


% constant processing


% atom_length/2
% atom_length(+atom,?integer)

atom_length(A, L) :-
  atom_codes(A, Codes),
  length(Codes, L).


% atom_concat/3
% atom_concat(?atom,?atom,+atom)
% atom_concat(+atom,+atom,-atom)

atom_concat(A, B, C) :-
  atom(C),
  !,
  name(C, C_string),
  append(A_string, B_string, C_string),
  name(A, A_string),
  name(B, B_string).

atom_concat(A, B, C) :-
  name(A, A_string),
  name(B, B_string),
  det_append(A_string, B_string, C_string),
  name(C, C_string).


% sub_atom/4
% sub_atom(+atom,?integer,?integer,?atom)

%% missing


% atom_chars/2
% atom_chars(+atom,+list)
% atom_chars(+atom,-list)
% atom_chars(-atom,+list)

%% missing


% atom_codes/2
% atom_codes(+atom,+list)
% atom_codes(+atom,-list)
% atom_codes(-atom,+list)

atom_codes(A, L) :-
  name(A, L).


% char_code/2
% char_code(+character,+character_code)
% char_code(+character,-character_code)
% char_code(-character,+character_code)

char_code(Character, Code) :-
  name(Character, [Code]).


% number_chars/2
% number_chars(+number,+list)
% number_chars(+number,-list)
% number_chars(-number,+list)

%% missing


% number_codes/2
% number_codes(+number,+list)
% number_codes(+number,-list)
% number_codes(-number,+list)

number_codes(N, L) :-
  name(N, L).


% implementation defined hooks


% set_prolog_flag/2
% set_prolog_flag(@flag,@term)

%% missing


% current_prolog_flag/2
% current_prolog_flag(?flag,?term)

% missing


% halt/0
% halt


% halt/1
% halt(@integer)



% mathematic predicates (evaluable functors)

% '+'/2


% '-'/2


% '*'/2


% '//'/2


% '/'/2


% rem/2

%% missing


% mod/2


% '-'/1

/*
% abs/1

abs(X, R) :-
  (  X < 0
  -> R is -X
  ;  R = X
  ).


% sqrt/1


% sign/1

sign(X, S) :-
  (  X < 0
  -> S = -1
  ;  S = 1).

*/

% float_truncate/1

%% missing


% float_round/1

%% missing


% float_integer_part/1

%% missing


% float_fractional_part/1

%% missing


% float/1

/*
% floor/1

floor(F, I) :-
  integer(F, I).

% truncate/1

truncate(F, I) :-
  (  F < 0
  -> F1 is -F,
     floor(F1, I1),
     I is -I1
  ;  floor(F, I)
  ).


% round/1

round(F, I) :-
  F1 is F + 0.5,
  floor(F1, I).


% ceiling/1

ceiling(F, I) :-
  F1 is -F,
  floor(F1, I1),
  I is -I1.


% '**'/2

**(B, E, P) :-
  pow(B, E, P).

*/

% sin/1


% cos/1


% atan/1


% exp/1


% log/1


% '>>'/2


% '<<'/2


% '/\'/2


% '\/'/2


% '\'/1
