:-dynamic self/1.

/*
An object is basically seen as a context i.e. a set
of assumed clauses.
Linear ones express state which might get updated,
intuitionistic ones specify/override unspecified methods.
Persistence (over backtracking and over halting) is ensured
in the same framework.
*/

ob_dir(obs).
ob_dir('.').

ob_load(Ob):-
   ob_dir(Dir),
   make_cmd([Dir,'/',Ob,'.pl'],File),
   file2or(File,Cs),
   ob_transform(Cs).

file2byte(B):-
  (r(X):-get0(X))=>
  end(-1)=>
  file2or(B).

file2clause(B):-
  (r(X):-read_clause(X))=>
  end(end_of_file)=>
  file2or(B).

file2pred(FN+Cs):-
  self(F0),find_file(F0,F),!,
  input_op(F,get_a_predicate(mem,FN,Cs)),
  FN\=end_of_file/0.

input_op(F,Op):-see(F),Op.

file2or(C):-
  self(F0),find_file(F0,F),!,
  repeat,
    input_op(F,r(X)),
    ( end(X),!,input_op(F,seen),fail
    ; C=X
    ).

Source>>OutV:-var(OutV),!,call(Source,OutV).
Source>>Op:-call(Source,O),call(Op,O),fail;true.

go1:-self(persist)-:file2byte>>put.
go2:-self(persist)-:file2clause>>pp_clause.
go3:-self(persist)-:file2pred>>pp_clause.

test(X):-self(persist)-:file2clause>>X.

go(X):-self(persist)-:file2pred>>X.

