:-write('requires BinProlog with peval_io disabled'),nl.
:-write('to generate it do in dir src: ?-vset(peval_io,int(0)),boot.'),nl.

% term to string

t2s(T,S):-findall(S,do_t2s(T,S),[S]).

do_t2s(T,S):-
  override(nl,my_nl),
  override(put_code(_),my_put_code(_)),
  override(fast_write(_),my_cwrite(_)),
  numbervars(T,0,_),
  dcg_def(S),  % opens current dcg stream
    generic_write(T,write),
  dcg_val([]). % closes current dcg stream

% the only way to properly emulate write is with side effects
% as write itself fails (to save heap space after doing its work)
% however, generic_write/2 is clean 
% of side effects so grammar emulation is ok

% string to term

s2t(S,T):-findall(T,do_s2t(S,T),[T]).

do_s2t(S,T):-
  override(get_code(_),my_get_code(_)),
  append(S,[46,10],NewS), % adds "." and end-of-line
  dcg_def(NewS), % opens current dcg stream
    read(T),
  dcg_val([]).   % closes current dcg stream


% tools using HAGs (hidden argument grammars - highly recommended !)

my_get_code(X):- #X.

my_nl:- #10.
my_put_code(X) :- #X.
my_cwrite(X):- name(X,Xs), my_write_name(Xs).

my_write_name([]).
my_write_name([X|Xs]):- #X, my_write_name(Xs).


/* IMPACT: BinProlog without peval_io: 

-rwxr-xr-x   1 tarau    sysadmin   94692 May 31 10:55 ru
-rw-r--r--   1 tarau    sysadmin  275148 Jun  1 13:03 wam.bp

FINISHED b1: Prolog execution halted(0). CPU time = 36.160s  from 35.570

FINISHED b2: Prolog execution halted(0). CPU time = 91.440s  from 92.270

FINISHED b3: Prolog execution halted(0). CPU time = 93.840s  from  90.80

FINISHED b4: Prolog execution halted(0). CPU time = 20.890s  from  20.200

cboot:             from 72.340s
*/
