% longest commun ground path
cgpath([T|Ts],P):-
  gpath(T,P1),
  cgpath1(Ts,P1,P).

cgpath1([],T,T).
cgpath1([T|Ts],P1,P):-
  gpath(T,P2),
  common_path(P1,P2,P3),
  cgpath1(Ts,P3,P).

% Is is a list of successive nonvar arg positions
gpath(T,Is):-gpath1(T,0,Is,[]).

ogpath(T,Is):-gpath1(T,0,Is,_).

gpath1(V,_)-->{var(V)},!,{fail}.
gpath1(V,I)-->{atomic(V)},!,[I].
gpath1(T,I)-->{all_free(T)},!,[I].
gpath1(T,J)-->[J],
  {argn(I,T,X)},
  gpath1(X,I).

all_free(T):- argn(_,T,X),nonvar(X),!,fail.
all_free(_).

common_path(P1,P2,P1):-infix(P1,P2),!.
common_path(P1,P2,P2):-infix(P2,P1).

infix(Xs,XsYs):-append(Xs,_,XsYs),!.

% largest commun ground selector
cgsel(Ts,T,[X-F/N|Fs]):-
  cgpath(Ts,[X|P]),
  functor(T,F,N),
  apply_path(P,T,Fs).

apply_path([],_,[]).
apply_path([I|Is],T,[I-F/N|Fs]):-
  arg(I,T,X),functor(X,F,N),
  apply_path(Is,X,Fs).

term_hash(Ts,Ks):-
  length(Ts,Max),
  cgpath(Ts,[0|Is]),!,
  term_hash0(Ts,Max,Is,Ks).

term_hash0([],_,_,[]).
term_hash0([T|Ts],Max,Is,[NewK|Ks]):-
   hkey(T,K),
   apply_key(Is,T,K,K1),
   NewK is K1 mod Max,
   term_hash0(Ts,Max,Is,Ks).

apply_key([],_,K,K).
apply_key([I|Is],T,K1,K):-
  arg(I,T,X),hkey(X,K2),
  K3 is K1+K2<<4,
  apply_key(Is,T,K3,K).


g0:-ogpath(a([X|_Xs],_Ys,[X|_Zs]),P),write(P),nl,fail.

g1:-ogpath(f(X,g(a,X,b(Y,Y,s(Y)),z),13),Xs),write(Xs),nl,fail.

g2:-cgpath([a([],Bs,Bs),a([X|_Xs],_Ys,[X|_Zs])],P),write(P),nl,fail.

g3:-cgpath([f(_,c),g(a,b)],Xs),write(Xs),nl,fail.

g4:-cgpath([f(a),g(_),h(s(0))],Xs),write(Xs),nl,fail.

g5:-cgpath([f(a),g(_),h],Xs),write(Xs),nl,fail.

g6:-gpath(a(_),Xs),write(Xs),nl,fail.

g7:-cgsel([
      f(c(X,_),s(X),c(X,_)),
      f(nil,   Y, c(Y,Y)),
      f(a,b,c)
    ],f(a,b,c),P),
    write(P),nl,
    fail.

g8:-cgsel([g(a,b),g(a,c),g(d,a)],g(a,c),S),write(S),nl,fail.

g9:-cgpath([f(a),_NO,h],Xs),write(Xs),nl,fail.

go:-L=[s(a),f(b),q(d),h(g(_,_),11),s,t,100],
  (cgpath(L,Ps),write(Ps),nl,fail
   ;term_hash(L,Xs),write(Xs),nl,fail
  ).
