% bounded buffer example
%   the buffer is a blackboard and free buffer space is
%   kept as tokens on the blackboard.
% 1
init(B,N) :- blackboard(B), tokens(N,B).

tokens(0,B).
tokens(N,B) :- tellt(B,token), N1 is N-1, tokens(N1,B).

put(B,X) :- gett(B,token), tellt(B,data(X)), !.
get(B,X) :- gett(B,data(X)), tellt(B,token), !.

%-----------------------------------------------

producer(0,_).
producer(N,B) :- put(B,number(N)), N1 is N-1, producer(N1,B).

consumer(0,B) :- put(B,consumer_done).
consumer(N,B) :- get(B,Data), delay(10000), write(data), nl,
                 N1 is N-1, consumer(N1, B).

delay(0) :- !.
delay(N) :- N1 is N-1, delay(N1).

go :-
  init(buffer1, 10),
  tellp(producer(25, buffer1)),
  tellp(consumer(25, buffer1)), 
  get(buffer1,consumer_done),
  bbshow(buffer1), 
  bbkill(buffer1).
