% Linda based parallel Prolog engine
% Author: Paul Tarau
% last update Mon Nov 14 09:21:53 AST 1994

go:-
  bb_open_engine(X,append(X,Y,[a,b,c,d]),E),
  query_engine(E,A),
  query_engine(E,B),
  query_engine(E,C),
  query_engine(E,D),
  close_engine(E),
  write([A,B,C,D]),nl.

bb_open_engine(X,G,Handle):-
  blackboard(Handle),
  tellt(Handle,fuel(go)),
  tellp(engine(Handle,X,G)).

getfuel(Handle,Todo) :- gett(Handle,fuel(Todo)), !.

putanswer(go,Handle,X) :-
  tellt(Handle,answer(X)), 
  fail. 
putanswer(stop,Handle,_).

engine(Handle,X,G):-
  call(G),
  getfuel(Handle,Todo),
  putanswer(Todo,Handle,X), 
  bbkill(Handle).

query_engine(Handle,Answer):-
   gett(Handle,answer(X)),
   tellt(Handle,fuel(go)),
   !,
   Answer=X.

close_engine(Handle):-
   bbkill(Handle).
