% example that illustrates the lazy evaluation of a background
% process. Evenprocess generates even numbers that are communicated
% to the blackboard on request. It will always try to calculate
% one value ahead.
%
evenprocess(N) :-
  gett(bb,request),
  tellt(bb,even(N)),
  N1 is N + 2,
  evenprocess(N1).

even(X) :-
  tellt(bb,request),
  gett(bb,even(X)), !.

go :- 
  blackboard(bb),
  tellp(evenprocess(0)),
  repeat, even(N), write(N), nl, N=10,
  bbshow(bb),
  bbkill(bb).

