%%% philo.pl

go :- go(5,7).

go(S,P) :-
   table(S),
   philosophers(P),
   T is S-1,
   tickets(T),
   stop(P),
   cleantable(S),
   bbshow(table),
   bbkill(table).

table(S) :- 
   blackboard(table), seats(S,S).

seats(0,S) :- !.
seats(F1,S) :-
   F2 is (F1 mod S) + 1,
   tellt(table,seat(F1, F2)),
   tellt(table,fork(F1)),
   F3 is F1-1,
   seats(F3,S).

cleantable(S) :- cleanseats(S,S), T is S-1, removetickets(T).

cleanseats(0,S) :- !.
cleanseats(F1,S) :-
   F2 is (F1 mod S) + 1,
   gett(table,seat(F1, F2)),
   gett(table,fork(F1)),
   F3 is F1-1,
   cleanseats(F3,S).

tickets(0) :- !.
tickets(T) :- 
   tellt(table,ticket(T)),
   T1 is T-1,
   tickets(T1).

removetickets(1) :- !.
removetickets(T) :- 
   gett(table,ticket(T)),
   T1 is T-1,
   removetickets(T1).

stop(0).
stop(P) :-
   gett(table,stop), 
   P1 is P-1,
   stop(P1).

philosophers(0).
philosophers(P) :-
   tellp(philosopher(P,100)),
   P1 is P-1,
   philosophers(P1).

philosopher(P,0) :- write('Stop'), nl, tellt(table,stop), !.
philosopher(P,N) :-
   think(P),
   gett(table,ticket(T)),
   gett(table,seat(F1,F2)),
   take_forks(F1,F2),
   eat(P),
   return_forks(F1,F2),
   tellt(table,seat(F1,F2)),
   tellt(table,ticket(T)), 
   N1 is N-1, !,
   philosopher(P,N1).

think(P) :- delay(T).
eat(P) :- delay(E).

delay(_).

take_forks(F1,F2) :-
   gett(table,fork(F1)),
   gett(table,fork(F2)).

return_forks(F1,F2) :-
   tellt(table,fork(F1)),
   tellt(table,fork(F2)).

