/* 2 engines are created and run in parallel */
/* the first backtracks through its search-tree and suspends */
/* when an answer is available until the second gets it with ask_engine */
/* the result of the consumer is available to the root-engine */
/* as a logical variable */



new_engine(Goal,Answer,E):-
  create_engine(100,100,100,E),
  load_engine(E,Goal,Answer).

p(P):-new_engine(append(X,Y,[A,B,B,A]),X+Y,P).

consume(P,[X|Xs]):-ask_engine(P,A),!,
   copy_term(A,X),
   consume(P,Xs).
consume(_,[]).

% we stop the producer engine and freeze it in a convenient state
% in which its answers are useful to the consumer
keep(P,Xs):-
  consume(P,Xs),
  suspend_engine(0). % <= this engine stops here

c(P,C):-new_engine(keep(P,Xs),Xs,C).

%  multitask_engines/1+suspend_engine/1 form
%     an experimental multi-tasker (see progs/and_engtest.pl,
%     progs/or_engtest.pl) for OS independent multi-treaded 
%     programming (works even with DOS or Windows 3.1)

go:-p(A),c(A,B),
  multitask_engines(100), % timout
  ask_engine(B,Xs),
  copy_term(Xs,Final),
  !,
  destroy_engine(A),
  destroy_engine(B),
  pp_clause(answer(Final)).

