m(X,[X|_]).
m(X,[_|Xs]):-m(X,Xs).

mc(X,[X|_]):-!.
mc(X,[_|Xs]):-mc(X,Xs).

l(X,[X]).
l(X,[_|Xs]):-l(X,Xs).

a([],[Y],[Y]).
a([X|Xs],Ys,[X|Zs]):-a(Xs,Ys,Zs).

ap([],Ys,Ys).
ap([X|Xs],Ys,[X|Zs]):-ap(Xs,Ys,Zs).

l1(X,L):-a(_,[X],L).

l2(X,L):-ap(_,[X],L).

go:-L=[1,2,3],
    (m(X,L),mc(X,L),write(X),nl,fail
    ;l(X,L),write(last=X),nl,fail
    ;l1(X,L),write('a_last'=X),nl,fail
    ;l1(X,L),write('app_last'=X),nl,fail
    ).

repl(Cs0,NewCs):-Cons=('.'),
  Cs0=[C0,(H2:-B2)],
  nonvar(B2),functor(B2,Memb,2),
  add_true(C0,(H1:-Cont)),Cs=[(H1:-Cont),(H2:-B2)],
  nonvar(H1),functor(H1,Memb,2),
  arg(2,H1,A1),nonvar(A1),functor(A1,Cons,2),
  arg(2,H2,A2),nonvar(A2),functor(A2,Cons,2),
  atomic(Cont),
  xproto_member(Ts,NewTs,_Cont),
  Dict=[Memb/2-_,Cons/2-_,Cont/0-_],
  repl_pred_pattern(Dict,Ts,NewTs,Cs,NewCs).

xproto_member(In,Out,Cont):-
  (Cont=true;Cont=(!)),
  Dict=[lmemb/2-_,('.')/2-_,Cont/0-_],
  prolog:l2hl(
    [ (lmemb(X,[X|_]):-Cont),
      (lmemb(X,[_|Xs]):-
         lmemb(X,Xs)
      )
    ],
    In,Dict),
  prolog:l2hl(
    [  
      (lmemb(X,Xs):-member_entry(X,Xs),Cont),
      (lmemb(X,[Y|Ys]) :- member3(X,Ys,Y))
    ],
    Out,Dict).

repl_pred_pattern(Dict,Ts,NewTs,Cs,NewCs):-
  prolog:l2hl(Cs,ATs,Dict),
  prolog:collapse_instances(Ts,ATs),x,pp_term(Dict+ATs),
  prolog:collapse_dict(Dict),
  prolog:hl2l(NewTs,NewCs).

data(

    [ (lmemb(X,[X|_]):- !),
      (lmemb(X,[_|Xs]):-
         lmemb(X,Xs)
      )]
).

test(R):-
  data(D),
  repl(D,R).

x:-write('@@=>'),nl.

bug:-test(R),write(R),nl.

