% TOPLEVEL

main(X):-
  clean_up_engines,
  call_ifdef(init_io,true),
  exec_run_time_commands,
%  quiet(Q),quiet(5),
  try_startup_file,
%  quiet(Q),
  check_if_server,
  call_ifdef(main,toplevel),
  X=ok.

check_if_server:-vget0(server_port,int(P)),P>0,!,
  vset(err_id,int(76)),
  guess_port(P),
  ip_addr(Host),
  quietmes('starting server at IP address'(Host)),
  host(Host)=>>run_server,
  halt(0).
check_if_server.

guess_port(1):-!.
guess_port(Port):-set_server_port(Port).

toplevel:-
  repeat,
    topstep('?- '),
  fail.

topstep(Prompt):-
	ttyprin(Prompt),flush,
        ttyin(top_read_term(Body,Vs)),
	report_answers(Vs,Body,YN),
	ttyprint(YN).

report_answers([],Goal,YN):-
  topcall(Goal)->YN=yes
  ; YN=no.
report_answers([V|Vs],Goal,YN):-
  ask_answers(Goal,[V|Vs],YN).

ask_answers(Goal,[V|Vs],YN):-
  topcall(Goal),
     report_one_var(V),report_top_vars(Vs),
     another_sol(Ok),
     ( Ok=no,!,YN=yes
       ; fail
     )
   ; YN=no,!.

report_top_vars(Eqs):-
	member(Eq,Eqs),
	ttyprint(','),report_one_var(Eq),
	fail.
report_top_vars(_).

report_one_var(V=E):-
	ttyprin(V),ttyprin(=),ttyout(writeq(E)).

another_sol(Ok):-
	is_interactive,!,
	ttyin(get_code(A)),user_action(A,Ok),ttynl.
another_sol(yes):-ttyprint(';'),ttynl.

user_action(10,no):-!.
user_action(59,yes):-!,ttyin(get_code(10)).
user_action(_,Ok):-ttyprin(' ; for more, <return> otherwise '),
  ttyin(get_code(10)),ttyin(get_code(U)),user_action(U,Ok).

try_startup_file:-
  vget(startup_file_name,Name/0),
  Name\=='$empty',
  vset(startup_file_name,'$empty'/0),
  parse_top_cmd(Name,Goal),
  Goal->true
; true.

% customize this for special handling of some commands
parse_top_cmd(Name,Goal):-
   act_on_suffix(Name,Action)->Goal=Action
;  sread(Name,Cmd),compound(Cmd)->Goal=Cmd
;  Goal=compile(Name).

act_on_suffix(File,Action):-
  [Dot]=".",
  name(File,Chars),
  append(_,[Dot|SufChars],Chars),
  name(Suf,SufChars),
  suffix2action(Suf,File,Action),
  !.

% customize this 
suffix2action(pl,F,include(F)).
suffix2action(pro,F,include(F)).
suffix2action(wam,F,load(F)).
suffix2action(au,F,system(Cmd)):-make_cmd([audioplay,' ',F,'&'],Cmd).
suffix2action(html,F,system(Cmd)):-make_cmd([netscape,' ',F,'&'],Cmd).
suffix2action(wrl,F,system(Cmd)):-make_cmd([netscape,' ',F,'&'],Cmd).



