#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_checkaddr 
#
#  Checks if a given agent address belongs to a name in global
#  array OTHER, i.e. if the agent is connected to this address.
#
# Arguments:
#
#  agtAddr - address to check, form 'host.port'
#
# Results:
#
#        0, if not connected to agtAddr
#        name of agent, if address belongs to one agent in OTHER
#
#
proc agt_checkaddr {agtAddr} {
global agents OTHER SELF

 # transform the given address to TCP/IP integer form,
 # if it isn't in this form already:
 set agtAddr [agt_hostport2addr $agtAddr]

 # check if the address is that of the agent itSELF:
 if {[cequal [keylget agents(SELF) ADDR] $agtAddr]} {
   return $SELF
 }

 # search in array OTHER for this address:
 foreach name [array name OTHER] {

   if {[cequal $OTHER($name) $agtAddr]} {
     return $name
   }
 }

 return 0
}

