#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_chgStatus
#
#  Handles a status change for the agent.
#
# Arguments:
#
#  replyTo - number to reply with status mesg to UAM
#
# Results:
#
#  None.
# 
 
proc agt_chgStatus {replyTo} {
 global agents

 # change the STATUS entry in array 'agents'
 # and display the bitmap for agent in his 'path-view' weak or solid (resp.):

 if {[keylget agents(SELF) STATUS] == "act"} {

   keylset agents(SELF) STATUS deact

   agt_drawWeak SELF

 } else {

   keylset agents(SELF) STATUS act

   agt_drawSolid SELF

 }

 # build up a statusinfo-message to send back to UAM:

 keylset identifikation NAME [keylget agents(SELF) NAME]
 keylset identifikation TYPE [keylget agents(SELF) TYPE]
 keylset identifikation STATUS [keylget agents(SELF) STATUS]

 keylset mesg :RECEIVER UAM :TYPE statusinfo \
              :IDFK $identifikation :REPLY-TO $replyTo
 agt_send $mesg

}


