#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_conDetected
#
#  Invoked by an event on agents base socket;
#  agt_conDetected accepts a new connection and sets
#  communication control on it.
#
# Arguments:
#
#	socket	-	identifier of the socket
#
# Results:
# 
#  	None
#

proc agt_conDetected {socket} {
 global agents
 
 # read event detected:
 #  try to catch a new connection
 #
 if {[catch {set conID [server_accept -buf $socket]}]} {
   agt_puts "Acception on $socket failed!\n"

 } else {
   agt_puts "Connection detected: $conID\n"

   fileevent $conID readable "agt_commCtrl $conID unknown"
 }
}


