#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_createCon
#
#  This procedure tries to establish a socket connection to an
#  specified agent address.
#
# Arguments:
#
#	agtAddr	-	address of agent to connect to; form: 'host.port'
#
# Results:
#
#  Returns an fileID for the connection or generates an error
#  and returns an error message.
#

proc agt_createCon {agtAddr} {

 # get agents host and port from agtAddr by splitting it:
 #  Form:   host.port
 #
 set a [expr [string last . $agtAddr ]-1]

 set agtHost [string range $agtAddr 0 $a]

 incr a 2
 set agtPort [string range $agtAddr $a end]

 # open the connection to the host and port
 #
 if [catch {set conID [server_connect -buf $agtHost $agtPort]}] {
   return -code error "connection refused"
 } else {
agt_puts "conID: $conID"
  return $conID
 }
  
}


