#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_doTypeInits
#
#  Invoke the parsing of agents ASL-script.
#  Sends an error-mesg to UAM if error occurs, or
#  an init-mesg to himself, if not.
#
# Arguments:
#
#  None.
#
# Results:
#
#  None.
# 
 
proc agt_doTypeInits {} {
 global agents SELF agt_MesgRules 
 global agt_VarInitialization agt_VarStdMesgRuleNo
 global agt_RecMesgList


# read the standard initial Belief-Base
#
 keylget agents(SELF) PROLOG prologFd
 
 if {[agt_loadBelBase agt_stdBelBase]} {
   return
 }

# read the standard Message-Rules
 agt_sourceStdMesgRules

# start reading the ASL file:
#
 agt_puts "Start parsing ASL-Script:\n"
 
 keylget agents(SELF) TYPE fileName

 if {[catch {agt_parseDescFile $fileName} errorMesg]} {
   agt_puts "$errorMesg\n\nInitialisation not completed!\n"

   keylset mesg :TYPE asl-error :RECEIVER UAM

   set agt_VarInitialization 0
 } else {
   agt_puts "End of script parsing.\n"

   keylset mesg :TYPE initialization \
                :RECEIVER $SELF

   # set global variable 'agt_VarInitialization' to 1, i.e. if the agent
   # will eval the 'initialization' message
   set agt_VarInitialization 1
 }

 agt_send $mesg

 catch {agt_displayBelBase}

}


