#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_exit
#
#  Handles the correct exit of the agent and
#  cleans up some stuff.
#
# Arguments:
# 
#  None
#
# Results:
#
#  None
#

proc agt_exit {} {
 global agents SELF
 global agt_VarMesgEvalSave agt_VarCommSave

 keylget agents(SELF) SOCKET socketId

 catch {removeinput $socketId}
 catch {close $socketId} 

 set fileNo [keylget agents(SELF) FILENO]

 set endTime [getclock]

 agt_puts "Logfile closed at [fmtclock $endTime "%a %b %d %Y, %T"]\n"
 agt_logMesgEval "Message evaluation Logfile closed at\
                  [fmtclock $endTime "%a %b %d %Y, %T"]\n"
 agt_logComm "Communication Logfile closed at\
              [fmtclock $endTime "%a %b %d %Y, %T"]\n" 

 update
 
 if {!$agt_VarMesgEvalSave} {
   catch {exec rm "logfiles/$SELF.$fileNo.msg"}
 }

 if {!$agt_VarCommSave} {
   catch {exec rm "logfiles/$SELF.$fileNo.com"}
 }
 
 exit
}

