#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_hostport2addr
#
# Transforms an agents address of form host.port to form
# inet_addr.port , i.e. point notation, if possible.
#
# Arguments:
#
#   addr - address if host.port form
#
# Results:
#
#   address in form inet_addr.port or addr if transforming is impossible
#
proc agt_hostport2addr {addr} {

 # get agents host and port from addr by splitting it:
 #  Form:   host.port
 #
 set a [expr [string last . $addr ]-1]

 set agtHost [string range $addr 0 $a]

 incr a 2
 set agtPort [string range $addr $a end]

 # try to replace the host in address by internet Name
 #
 catch {set addr [lindex [server_info addresses $agtHost] 0].$agtPort}

 return $addr

}

