#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_initShortHelp
#
#  This file initializes the ShortHelp for UAM.
#  The array 'agt_Shorthelp' is filled with help text for
#  specified widgets.
#
#  Entries have the following format:
#
#    set agt_ShortHelp(widgetName) helpText
#
#  This causes 'helpText' to been shown as shortHelp 
#  for widget 'widgetName'.
#
set agt_ShortHelp(.shortHelp) \
  "The IDEAS - ShortHelp :\n\nThe ShortHelp is\
   invoked by pointing with the cursor on a detail of an IDEAS-window\
   and pressing the right mouse button.\n\nIf ShortHelp is available for\
   this item a window like this appears and gives you a short description."

set agt_ShortHelp(.mbar.help.menu) $agt_ShortHelp(.shortHelp)

set agt_ShortHelp(.f0) \
  "The Agent Observation Window :\n\nEach agent has its own Observation\
   Window which provides several possibilities to control its activities."

set agt_ShortHelp(.mbar) $agt_ShortHelp(.f0)

set agt_ShortHelp(.mbar.view) \
  "The View Menu :\n\nContains menubuttons to show or to hide\n\n - the\
   standard Logfile\n - the Logfile for Message-Evaluation\n - the Logfile\
   for selected Communication\n - the actual Communication-Paths\n\ - the\
   actual Belief-Base."

set agt_ShortHelp(.mbar.view.menu) $agt_ShortHelp(.mbar.view)

set agt_ShortHelp(.mbar.trace) \
  "The Trace/Untrace Button :\n\nThe activation\
   of this button sets the agent in 'Trace-Mode'.\n\nIn this mode the agent\
   will recognize tracepoints in his script created with the standard action\
   'agt_tracepoint' and falls asleep whenever running in one of them.\n\nThe\
   user has to awake it by pressing the 'Wake Up'-button which will appear\
   in the observation window.\n\nIf the agent is in Trace-Mode invoking\
   this menubutton switches of the tracing."

set agt_ShortHelp(.mbar.exit) \
  "The Exit Menu :\n\nIf the Exit menu is visible\
   the agent lost the connection to his UAM.\n\nIn this case you can close\
   the agent correctly by invoking this menu or using 'Ctrl-q' as a shortcut."

set agt_ShortHelp(.trace.wakeup) \
  "The Wake Up Button :\n\nIf this button is\
   visible the agent is in Trace-Mode.\n\nWhenever running on a tracepoint\
   it falls asleep and you have to awake it by pressing this button to\
   continue working.\n\nYou can leave the Trace-Mode by invoking the 'untrace'\
   menubutton."

set agt_ShortHelp(.trace) $agt_ShortHelp(.trace.wakeup)

set agt_ShortHelp(.f1) \
  "The Logfile Widget :\n\nIn this widget you can control\
   agents activities by having a look in his standard Logfile.\n\nThe\
   standard Logfile takes the minute of all communication and user can add\
   text to logfile by calling the standard action 'agt_puts' in agents\
   ASL-script.\n\nThe whole Logfile is written to a file with extension\
   '.log' in directory 'logfiles'.\n\nThe 'Auto-Scroll'-checkbutton is used\
   to see always the latest entry in the widget."

set agt_ShortHelp(.f1.label) $agt_ShortHelp(.f1)
set agt_ShortHelp(.f1.mbar) $agt_ShortHelp(.f1)
set agt_ShortHelp(.f1.mbar.scroll) $agt_ShortHelp(.f1)
set agt_ShortHelp(.f1.text) $agt_ShortHelp(.f1)

set agt_ShortHelp(.f2) \
   "The Communication-Paths Widget :\n\nThis widget shows\
   you the current communication paths of your agent in a graphical\
   form.\n\nTo get informations about the displayed agents set the cursor\
   on the bitmap and press the left button.\nBy holding the middle button\
   pressed on a bitmap - not SELF - you can move it around in the\
   widget.\n\nIf a connection is drawn in grey colour it is waiting for a\
   response of the specified address.\nIf SELF is deactive its bitmap is\
   drawn in grey, too."

set agt_ShortHelp(.f2.label) $agt_ShortHelp(.f2)
set agt_ShortHelp(.f2.c) $agt_ShortHelp(.f2)

set agt_ShortHelp(.f3) \
  "The Belief Base Widget :\n\nThis widget shows\
   you the current status of the Belief-Base.\n\nProlog-clauses are sorted\
   and each group of facts has a headline signed with a '%'-character."

set agt_ShortHelp(.f3.label) $agt_ShortHelp(.f3)
set agt_ShortHelp(.f3.text) $agt_ShortHelp(.f3)

set agt_ShortHelp(.f4) \
  "The Message-Evaluation Widget :\n\nThis widget gives you a look at the\
   Message-Evaluation Logfile.\n\nIn spite of the standard Logfile this one\
   only takes the minutes of the evaled Message-Rules.\n\nIt shows which rule\
   is evaled and whats the current values of its match-variables are when it\
   matches a message.\n\nThe whole Message-Evaluation Logfile is written to a\
   file with extension '.msg' in directory 'logfiles', but it is deleted with\
   deleting the agent if you don't invoke the 'Save'-checkbutton on the\
   Message-Evaluation menubar.\n\nThe 'Auto-Scroll'-checkbutton is used to\
   see always the latest entry in the  widget."

set agt_ShortHelp(.f4.label) $agt_ShortHelp(.f4)
set agt_ShortHelp(.f4.mbar) $agt_ShortHelp(.f4)
set agt_ShortHelp(.f4.mbar.scroll) $agt_ShortHelp(.f4)
set agt_ShortHelp(.f4.mbar.save) $agt_ShortHelp(.f4)
set agt_ShortHelp(.f4.text) $agt_ShortHelp(.f4)

set agt_ShortHelp(.f5) \
  "The Communication Widget :\n\nThis widget allows you to have a nearer\
   look on the messages the agent sends and receives.\nIt enables you to\
   watch the communication of this agent with selected agents it is connected\
   to.\n\nTo select these other agent use the Communication Filter which is\
   invoke by the 'filter'-button on the Communication menubar.\n\nThe\
   'Auto-Scroll'-checkbutton is used to see always the latest entry in the\
   widget."

set agt_ShortHelp(.f5.label) $agt_ShortHelp(.f5)
set agt_ShortHelp(.f5.mbar) $agt_ShortHelp(.f5)
set agt_ShortHelp(.f5.mbar.filter) $agt_ShortHelp(.f5)
set agt_ShortHelp(.f5.mbar.save) $agt_ShortHelp(.f5)
set agt_ShortHelp(.f5.mbar.scroll) $agt_ShortHelp(.f5)
set agt_ShortHelp(.f5.text) $agt_ShortHelp(.f5)

set agt_ShortHelp(.f5.filter) \
  "The Communication Filter :\n\nIn this widget you can select which\
   communication you want to watch in the Communication widget.\n\nAll\
   messages from and to the agents in the right listbox are shown\
   in the Communication Logfile.\n\nYou can move an agent name from one\
   listbox to the other by pressing the 'Add'/'Remove'- button (resp.) or\
   just doing a double click with the mouse cursor on the selected\
   name.\n\nPress 'OK' to agree and 'Cancel' to forget your choice.\n\nThe\
   whole Communication Logfile is written to a file with extension '.com'\
   in directory 'logfiles', but it is deleted with deleting the agent if\
   you don't invoke the 'Save'-checkbutton on the Communication\
   menubar."

set agt_ShortHelp(.f5.filter.a) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.b) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.lbl1) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.lbl2) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.list1) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.list2) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.add) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.rem) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.ok) $agt_ShortHelp(.f5.filter)
set agt_ShortHelp(.f5.filter.cancel) $agt_ShortHelp(.f5.filter)

set agt_ShortHelp(.mbar.help) "The Help Menu :\n\nIt leads you to the IDEAS-Help-System."




