#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_logMesgEval
#
#  Displays text in agents observer window and
#  writes it to the Message Evaluation logfile.
#
# Arguments:
#
#	text	 -	text to display
#	nextLine -	if '0' begin no newline after text,
#			default 1
#
# Results:
#
#  None.
#

proc agt_logMesgEval {text {nextLine 1}} {
  global agents agt_VarMesgEvalScroll

  set logFile [keylget agents(SELF) MLGFID]

  if {[catch {
	.f4.text configure -state normal

	if {$nextLine != "0"} {
	  puts $logFile $text
	 .f4.text insert end "$text\n" 
	} else {
	  puts -nonewline $logFile $text
	 .f4.text insert end "$text" 
	}

	.f4.text configure -state disabled

	if {$agt_VarMesgEvalScroll} {
	  .f4.text yview -pickplace end
	}
  }]} {
    # if user close the agent window, the agent process does
    # NOT stop, so an error occurs when trying to write in
    # the destroyed window; catch it and kill the process !
    #
    kill [pid]
  }

  flush $logFile
  update

} 

