#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_openSocket
#
#  Opens a TCP-socket for listening to connections to other agents.
#
# Arguments:
#
#	agtHost	-	host of this agent
#
# Results:
#
#  Sets agents entry for SELF to correct NAME, SOCKET and ADDR
#
#
proc agt_openSocket {} {
global agents

 # the agent tries to get this portno first:
 set portNo 1200

 # if it is not free it takes the next higher, if possible, up to a upper border:
 #

 keylget agents(SELF) HOSTIP agtHost_ip 

 while {[catch {set socketId [server_create -myip $agtHost_ip \
                                       -myport $portNo \
                                       -backlog 50]} errMesg]} {
   if {$portNo < 2000} {
    incr portNo 1
   } else {
    set portNo 1200
   }
 }

 keylset agents(SELF) ADDR [keylget agents(SELF) HOSTIP].$portNo
 keylset agents(SELF) SOCKET $socketId
 keylset agents(SELF) NAME "[keylget agents(SELF) NAME].$portNo"

 return 
}

