#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_puts
#
#  Displays text in agents observer window and
#  writes it to the logfile.
#
# Arguments:
#
#	text	 -	text to display
#	nextLine -	if '0' begin no newline after text,
#			default 1
#
# Results:
#
#  None.
#

proc agt_puts {text {nextLine 1}} {
  global agents agt_VarLogScroll

  set logFile [keylget agents(SELF) LOGFID]

  if {[catch {
      .f1.text configure -state normal

      if {$nextLine != "0"} {
	  puts $logFile $text
	  .f1.text insert end "$text \n" 
      } else {
	  puts -nonewline $logFile $text
	  .f1.text insert end "$text" 
      }

      .f1.text configure -state disabled

      if {$agt_VarLogScroll} {
	  .f1.text yview -pickplace end
      }
  }]} {
    # if user close the agent window, the agent process does
    # NOT stop, so an error occurs when trying to write in
    # the destroyed window; catch it and kill the process !
    #
    kill [pid]
  }

  flush $logFile
  update

} 

