#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# agt_tracepoint
#
#  Sets a tracepoint for the agent.
#  In trace-mode the agent will stop when calling this proc
# and the user has to awake it  by pressing the 'Wake Up'-button.
#
# Arguments: None.
#
# Results: None.
#
#
proc agt_tracepoint {} {
global agt_VarTraceEnable agt_VarWakeUp

 # check if agent is in trace mode
 if {!$agt_VarTraceEnable} {
  return
 }

 .trace.wakeup configure -state normal

 # wait for 'wake Up#-button to be pressed:
 tkwait variable agt_VarWakeUp

 .trace.wakeup configure -state disabled

}

