/* headers */

#if 1
#define c_trace(Instr) \
fprintf(stderr,"H=%ld CUT=%ld %s\n",(cell)H,ires,Instr);
#else
#define c_trace(Instr)
#endif

#define c_chunk_variable(Name) \
term Name(H,regs,P,ires) \
   register term H,regs; register instr P; long ires; \
{  /* fprintf(stderr,"Fun=%d H=%d P=%d\n",Name,H,P); */

#define c_chunk_value(Offset,No) \
   X(1)=(cell)(P+No); \
   return H+Offset; \
}

/* tools */

#define newvar(Offset,Reg) \
  regs[Reg]=H[Offset]=(cell)(H+Offset);

#define newvar2(Offset,RegN,RegI) \
  regs[RegN]=regs[RegI]=H[Offset]=(cell)(H+Offset);


/* instructions */

#define put_structure(Offset,No,Reg) \
   regs[Reg]=(cell)(H+Offset); \
   H[Offset]=P[No];

#define put_constant(No,Reg) \
   regs[Reg]=P[No];

#define put_integer(No,Reg) \
   regs[Reg]=INPUT_INT(No);

#define push_structure(Offset,No,Reg) \
   *(term)regs[Reg]=(cell)(H+Offset); \
   H[Offset]=P[No];

#define write_value(Offset,Reg) \
    H[Offset]=regs[Reg];

#define write_variable(Offset,Reg) \
    newvar(Offset,Reg);

#define write_constant(Offset,No) \
    H[Offset]=P[No];

#define write_integer(Offset,No) \
    H[Offset]=INPUT_INT(No);

#define move_reg(RegN,RegI) \
    regs[RegN]=regs[RegI];

#define put_variable(Offset,RegN,RegI) \
    newvar2(Offset,RegN,RegI);

#define write_void(Offset,Times) \
    {   register cell xval=Times; \
        register term xref=H+Offset; \
        while(xval--) \
          xref[xval]=(cell)(xref+xval); \
    }

#define push_cut(Offset) \
    H[Offset]=ires;

