% begin chunk
c_spec(63, Name, c_chunk_variable(Name)):-
  c_chunk_begin,
  gensym(xx,Name).

% end chunk
c_instr(64, _, F, _Len , c_chunk_value(O,No1)):-
  c_skip(Extra),
  c_check0(No), No1 is No+Extra, % ## check this
  c_chunk_end,
  get_offset(O),
  make_bcode(64,0,F,No1).

c_instr(10, An, F, N, put_structure(O,No,An)):-
  c_inc(F,N,No),
  new_offset(O).

c_instr(9, An, F, N, Instr):-
  c_instr_put_fun_int(An,F,N,Instr).

c_instr(51, An, F, N, push_structure(O,No,An)):-
  c_inc(F,N,No),
  new_offset(O).

c_instr(4, An, _, _, write_value(O,An)):-
  c_check,
  new_offset(O).

c_instr(2, An, _, _, write_variable(O,An)):-
  c_check,
  new_offset(O).

c_instr(6, _, F, N, Instr):-c_instr_fun_int(F,N,Instr).

c_instr(11, An, _, Ai, move_reg(An,Ai)):-
  c_check.

c_instr(12, An, _, Ai, put_variable(O,An,Ai)):-
  c_check,
  new_offset(O).

c_instr(62, Times, _ , _, write_void(O,Times)):-
  c_check,
  new_offset(O),
  ( for(I,2,Times),
    new_offset(_),
    fail
  ; true
  ).

c_instr(14, _, _, _, push_cut(O)):-
  c_check,
  new_offset(O).

c_instr_put_fun_int(An, F, _, put_integer(F,An)):-integer(F),!,
  c_check.
c_instr_put_fun_int(An, F, N, put_constant(No,An)):-
  c_inc(F,N,No).

c_instr_fun_int(F, _, write_integer(O,F)):-
  integer(F), % Max is 1<<15, F > -Max, F < Max,
  !,
  c_check,
  new_offset(O).  
c_instr_fun_int(F, N, write_constant(O,No)):-
  c_inc(F,N,No),
  new_offset(O).  

% test data


treesize(leaf(_),S0,S):-
   add_node(S0,1,S).

treesize(tree(Left,Right),S0,S) :-
   add_node(S0,1,S1),
   treesize(Left,S1,S2),
   treesize(Right,S2,S).
    
add_node(S0,N,S):-S is S0+N.
