% ## predefined opcodes: see global.h
go:-go(66).

/* ADD NEW BUILTINS HERE */

% simple inline builtins of arity 0,1 with no returned value

b0(fail/0,simple,in_body).
b0(cwrite/1,simple,in_body).
b0(cnl/0,simple,in_body).
b0(var/1,simple,in_body).
b0(nonvar/1,simple,in_body).
b0(integer/1,simple,in_body).
b0(atomic/1,simple,in_body).
b0(is_compiled/1,simple,in_body).

% builtin inline functions f(i,....,i,optional:o)

b0(lift_heap/2,arith(0),in_body).
b0((+)/3,arith(1),in_body).
b0((-)/(3),arith(1),in_body).
b0((*)/3,arith(1),in_body).
b0((/)/3,arith(1),in_body).
b0(mod/3,arith(1),in_body).
b0(random/1,arith(1),in_body).
b0(get0/1,arith(1),in_body).

b0(put/1,arith(0),in_body).

b0(less/2,arith(0),in_body).
b0(greater/2,arith(0),in_body).
b0(less_eq/2,arith(0),in_body).
b0(greater_eq/2,arith(0),in_body).
b0(arith_eq/2,arith(0),in_body).
b0(arith_dif/2,arith(0),in_body).

b0((<<)/3,arith(1),in_body).
b0((>>)/3,arith(1),in_body).
b0((/\)/3,arith(1),in_body).
b0((\/)/3,arith(1),in_body).
b0((#)/3,arith(1),in_body). % xor
b0((\)/3,arith(1),in_body). % complement

b0('compare0'/3,arith(1),in_body).
b0(arg/3,arith(1),in_body).

b0(def/3,arith(0),in_body).
b0(set/3,arith(0),in_body).
b0(val/3,arith(1),in_body).
b0(rm/2,arith(0),in_body).
b0(bb_list0/3,arith(1),in_body).

b0(symcat/3,arith(1),in_body).
b0(copy_term/3,arith(1),in_body).

b0(seeing_telling/2,arith(1),in_body). % seeing=0,telling=1
b0(see_tell/2,arith(0),in_body). % see=0,tell=1
b0(seen_told/1,arith(0),in_body). % seen=0,told=1,flush=2
b0(older_file/2,arith(0),in_body).

b0(det_append0/3,arith(1),in_body).

b0(string_op/3,arith(1),in_body). % sread=0, swrite=1

b0(op0/3,arith(0),in_body). 

b0(lval/3,arith(1),in_body).
b0(term_append/3,arith(1),in_body).
b0(float_fun2/4,arith(1),in_body).
b0(float_fun/3,arith(1),in_body).
b0(input_float/4,arith(1),in_body).
b0(write_float/1,arith(0),in_body).
b0('//'/3,arith(1),in_body).
b0(halt/1,arith(0),in_body).
b0(add_instr/4,arith(0),in_body).
b0(list2term/2,arith(1),in_body).
b0(term2list/4,arith(1),in_body).
b0(strip_cont0/2,arith(1),in_body).
b0(setarg/3,arith(0),in_body).

% invisible dcgs (up to 256 streams)
b0(dcg_connect/1,arith(1),in_body).
b0(dcg_def/1,arith(0),in_body).
b0(dcg_val/1,arith(1),in_body).
b0(dcg_tell/1,arith(0),in_body).
b0(dcg_telling/1,arith(1),in_body).

b0(iso_open_stream/3,arith(1),in_body).
b0(iso_close_stream/2,arith(0),in_body).
b0(iso_write_term/3,arith(0),in_body).
b0(iso_read_term/3,arith(1),in_body).
b0(iso_put_byte/2,arith(0),in_body).
b0(iso_get_byte/2,arith(1),in_body).
b0(iso_peek_byte/2,arith(1),in_body).
b0(iso_eof/1,arith(0),in_body).
b0(iso_lseek/4,arith(1),in_body).

b0(bb_put/2,arith(0),in_body).
b0(bb_get/4,arith(1),in_body).
b0(bb_op/3,arith(1),in_body).

b0(setref/2,arith(0),in_body).
b0(new_builtin/3,arith(1),in_body). % arity 3+1 by binarization

% arbitrary i-o pattern builtins

b0(true/0,simple,in_head).
b0(call/1,simple,in_head).

b0(findall_store_heap/1,simple,in_head).
b0(findall_load_heap/1,simple,in_head).

b0(functor/3,simple,in_head).
b0(name/2,simple,in_head).

b0(abort/0,simple,in_head).
b0(restart/0,simple,in_head).

b0(shell/1,simple,in_head).

b0(stat0/3,simple,in_head).

b0(list_asm/3,simple,in_head).
b0(bb_reset/0,simple,in_head).
b0(profile/0,simple,in_head).

b0(if0/3,simple,in_head).


% ---------- tools to generate builtins.pl -------------- %

get_all_bs(Bs):-
  G0=(b0(F/N,X,Y),N1 is N+1,functor(B,F,N1)),
  G=b0(B,X,Y),
  findall(G,G0,Bs).

filter_b(Class,All,N):-
  arg(1,Class,I),
  findall(I-B,
    ( member_i(OldB,All,0,_),
      rewrite_b(Class,OldB,B)
    ),
  Bs),
  length(Bs,N),
  ( member_i(I-B,Bs,0,I),
    pp_c(B),
    fail
  ; nl
  ).

rewrite_b(n_inline(N), b0(B,simple,  in_body), bu0(B,N,in_body) ).
rewrite_b(n_arith(N),  b0(B,arith(K),in_body), bu0(B,arith(N,K),in_body) ).
rewrite_b(n_builtin(N),b0(B,simple,  in_head), bu0(B,N,in_head) ).

/*
pp_c(C):-
  % numbervars(C,0,_),
  writeq(C),write('.'),nl,fail.
pp_c(_).
*/

pp_c(C):-portray_clause(C).

make_builtins(Start,Info):-
  Info=[P1,P2,P3,P4],
  get_all_bs(All),
  P1=n_inline(A1),filter_b(P1,All,N1),
  P2=n_arith(A2),filter_b(P2,All,N2),
  P3=n_builtin(A3),filter_b(P3,All,N3),
  P4=n_nop(A4),
  A1=Start,
  A2 is A1+N1,
  A3 is A2+N2,
  A4 is A3+N3,
  pp_ctr(P1),
  pp_ctr(P2),
  pp_ctr(P3),
  pp_ctr(P4),
  nl.

pp_ctr(P):-P=..[F,X],NewP=bu_ctr(F,X),pp_c(NewP).
  
make_pl(N,Info):-
  BU='builtins.pl',
  write(making(BU)),nl,
  tell(BU),
  make_builtins(N,Info),
  told.

go(Start):-
  make_pl(Start,Info),
  make_h(Info).

make_h(Info):-
  DEF='defs.h',PROF='prof.h',
  Info=[n_inline(First),n_arith(Arith),n_builtin(Bu),n_nop(Nop)],
  Last is Nop-1,
  write([inline=First,arith=Arith,in_body=Bu,last=Last]),nl,
  write(making(DEF)),nl,
  tell(DEF),
  ( make_defs(First,Arith,Bu,Last)
    ; tell(user),write(failing_on(DEF)),nl,tell(DEF)
  ),
  !,
  make_stats,
  !,
  told,
  write(making(PROF)),nl,
  tell(PROF),
  (   make_names(Info)
    ; tell(user),write(failing_on(PROF)),nl,tell(DEF)
  ),
  !,
  told.

make_defs(First,Arith,Bu,Last0):-
  number_bu(First,Last,N-X),
  write('#define '),write(X),write(' '),write(N),nl,
  N=:=Last,
  !,
  Last=:=Last0,
  nl,write('#define INLINE '),write(First),nl,
  write('#define ARITH '),write(Arith),nl,
  write('#define BUILTIN '),write(Bu),nl,
  write('#define LAST_BUILTIN '),write(Last),nl.

make_stats:-
	nl,
	stat_dict(Name,Val),name(Name,L),
	to_upper(L,L1),
	lappend("STAT_",L1,L2),
	name(SName,L2),
	write('#define '),write(SName),write(' '),write(Val),nl,
	fail.
make_stats:-nl.

make_names(Info):-
  Info=[n_inline(Max)|_],
  write('#if TRACE>0 || PROF '),nl,
  write('char *bu_name[]={'),nl,
  number_bu(Max,Last,N-X),
  write('"'),write(X),write('",'),nl,
  N=:=Last,
  !,
  write('"LAST_BUILTIN"};'),nl,write('#endif'),nl,nl.

number_bu(First,Last,N-X):-
  bagof(B,bname(B),Bs),
  length(Bs,L),!,Last is First+L-1,
  member_i(X,Bs,First,N).

to_upper1(X,Y):-[A]="a",[Z]="z",X>=A,X=<Z,[AA]="A",!,
  Y is AA+(X-A).  
to_upper1(X,X).

to_upper([],[]).
to_upper([X|Xs],[Y|Ys]):-
  to_upper1(X,Y),
  to_upper(Xs,Ys).

b_idiom(+,"PLUS").
b_idiom(-,"SUB").
b_idiom(*,"MUL").
b_idiom(//,"DIV").
b_idiom(/,"FDIV").
b_idiom(put,"PUT0").

b_idiom(<<,"LSHIFT").
b_idiom(>>,"RSHIFT").
b_idiom(/\,"L_AND").
b_idiom(\/,"L_OR").
b_idiom(#,"L_XOR").
b_idiom(\,"L_NEG").

to_bname(F,U):-b_idiom(F,U),!.
to_bname(F,U):-name(F,L),to_upper(L,U).

bname(Name):-
  [X]="_",
  b0(F/N,_,_),name(N,Arity),
  to_bname(F,U),
  lappend(U,[X|Arity],List),
  name(Name,List).

lappend([],Ys,Ys).
lappend([A|Xs],Ys,[A|Zs]):-
	lappend(Xs,Ys,Zs).
