stat_dict(runtime,0).
stat_dict(global_stack,1).
stat_dict(local_stack,2).
stat_dict(trail,3).
stat_dict(code,4).
stat_dict(strings,5).
stat_dict(symbols,6).
stat_dict(htable,7).
stat_dict(bboard,8).

user_error(Mes,Obj):-error_message(basic,Mes,Obj).

errmes(Mes,Obj):-error_message(pretty,Mes,Obj).

error_message(Portray,Mes,Obj):-
	telling(F),
	tell(user),
	  portray_error(Portray,Mes,Obj),!,
	tell(F),
	fail.

portray_error(basic,Mes,Obj):-
  cwrite('>>> '),cwrite(Mes),cwrite(': '),cwrite(Obj),nl.
portray_error(pretty,Mes,Obj):-
  write('*** '),write(Mes),write(': '),nl,
  portray_clause(Obj).

member(C,[C|_]).
member(C,[_|L]):- member(C,L).

nth_member(X,Xs,N):-member_i(X,Xs,1,N).

member_i(X,[X|_],N,N).
member_i(X,[_|Xs],N1,N3):-
  N2 is N1+1,
  member_i(X,Xs,N2,N3).
	
