% TOPLEVEL
main(X):-binprolog_start(X).

binprolog_start(X):-
  call_ifdef(init_io,true),
  exec_run_time_commands,
  call_ifdef(main,toplevel),
  X='$end'.

toplevel:-
	interactive(yes),
	repeat,
    		topstep('?- '),
	!.

topstep(Prompt):-
	ttyprin(Prompt),flush,
	ttyin(top_read_term(Body,Vs)),
	topinterp(Body,Vs).

topinterp(Goal,_):-var(Goal),!,errmes(should_be_nonvar,Goal).
topinterp(end_of_file,_):-!.
topinterp(Goal,Vs):-
	report_answers(Vs,Goal),
	fail.

topcall(G):-
%  savetop(G),
  metacall(G),nothing.

savetop(G):-lval(top,goal,G).

nothing.

report_answers([],Goal):-topcall(Goal),!,
	ttyprint(yes).
report_answers([V|Vs],Goal):-
	topcall(Goal),
	report_one_var(V),report_top_vars(Vs),
	another_sol(Ok),
        ( Ok=no->!,ttyprint(yes)
	; fail
	).
report_answers(_,_):-
	ttyprint(no).

report_top_vars(Eqs):-
	member(Eq,Eqs),
	ttyprint(','),report_one_var(Eq),
	fail.
report_top_vars(_).

report_one_var(V=E):-
	ttyprin(V),ttyprin(=),ttyout(writeq(E)).

another_sol(Ok):-
	is_interactive,!,
	ttyin(get_code(A)),user_action(A,Ok),ttynl.
another_sol(yes):-ttyprint(';'),ttynl.

user_action(10,no):-!.
user_action(59,yes):-!,ttyin(get_code(10)).
user_action(_,Ok):-ttyprin(' ; for more, <return> otherwise '),
  ttyin(get_code(10)),ttyin(get_code(U)),user_action(U,Ok).

