%
% Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
% Computer Science Department,
% Christian-Albrechts-University of Kiel,
% Olshausenstr. 40, 24118 Kiel, Germany
%
% All rights reserved.
% No warranties will be given on any issues arising out of the use
% of this software product.
% Permission to use, copy, modify and distribute this software
% product for non-commercial purposes is hereby granted, provided
% that the above copyright notice appears in all copies and
% respective publications.
% All commercial trades with this product outside the CAU Kiel
% without specific written prior permission are prohibited.
%

%
% agt_prologClear.pl
%
% This is the initial belief base of an agent
% containing some predicates for time realization

% time/1
% contains an integer value representing the current time
time(0).

% set_time/1
% used to set a new time
set_time(T):- retract(time(A)), assert(time(T)).

% valid/2
% defines the validity of a time interval from A to B
% relative to the current time
valid(A,B):- time(C), A=<C, (C=<B; B<A).

% invalid/2
% decides realtive to the current time if the time interval
% from A to B will be valid at any time in the future 
invalid(A,B):- time(C), A=<B, C>B.
