/*                                                                           */
/*  standard.c                                                               */
/*                                                                           */
/*  This is the standard dummy file for AGENT-C-SOURCEs,                     */
/*  a user defined command package written in C                              */
/*  for extending agents actions in IDEAS.                                   */
/*                                                                           */
/*  It is read only, so save it under a new name ending with '.c'            */
/*  in directory 'actSrc' and use it to define a new action procedures       */
/*                                                                           */
/*  Defining a new action written in C concludes two steps:                  */
/*                                                                           */
/*   1. Define the C procedure for the new action,                           */
/*      use the procedure head syntax shown below.                           */
/*      You should use a specifier starting with 'usr_' follow by a capital  */
/*      letter and with suffix 'Cmd' to avoid name conflicts.                */
/*                                                                           */
/*   2. Register the new procedure just defined in the Tcl-interpreter       */
/*      by calling 'Tcl_CreateCommand' in the 'Ideas_ActSrc_Init'-procedure  */
/*      below with the specified syntax.                                     */
/*      For 'cmdName' you should use the same specifier as for the           */
/*      command procedure, but leaving the 'Cmd' at the end.                 */
/*                                                                           */


#include <tcl.h>


/* --------------------------------------------------------------------------*/
/*                                                                           */
/* Define here command procedures for extending agents commands.             */
/*                                                                           */
/* Syntax:   int cmdProc(ClientData clientData, Tcl_interp *interp,          */
/*                       int argc, char *argv[]);                            */
/*                                                                           */
/* Example:  int usr_TestCmd(ClientData clientData, Tcl_Interp *interp,      */
/*                           int argc, char *argv[])                         */
/*                                                                           */
/* --------------------------------------------------------------------------*/







/* --------------------------------------------------------------------------*/
/*                                                                           */
/*       Initialization procedure for the package                            */
/*                                                                           */
/* --------------------------------------------------------------------------*/

int Ideas_ActSrc_Init (Tcl_Interp *interp) {
 
 /*  Call here Tcl_CreateCommand for each command procedures defined above   */
 /*  to register it in the Tcl-interpreter.                                  */
 /*                                                                          */
 /*  Syntax:  Tcl_CreateCommand(interp, char *cmdName, TclCmdProc *cmdProc,  */
 /*                 ClientData clientData, Tcl_CmdDeleteProc *deleteProc);   */
 /*                                                                          */
 /*  Example: Tcl_CreateCommand(interp, "usr_test", usr_TestCmd,             */
 /*                 (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);          */



  return TCL_OK;
}
