  /*                                                                 *
   * test.c                                                          *
   *                                                                 *
   * Simple ACTION-C-SOURCE which defines just one action in C.      *
   * This action is named 'usr_test'. It gets a string as argument   *
   * and writes it 5 times in the Logfile of the agent.              *
   *                                                                 */

  #include <tcl.h>

  /*                                                                 *
   * command procedure 'usr_TestCmd':                                *
   *                                                                 */
   int usr_TestCmd(ClientData clientData, Tcl_Interp *interp,
                   int argc, char *argv[])
   {
    int i;

    for (i = 1; i <= 5; i++)
    {
     /* Call Tcl-function 'Tcl_VarEval':                             *
      * concatenates the argument strings to one string; evals this  *
      * string in the Tcl-interpreter; returns the result of the     *
      * evaluation.                                                  */

      if (Tcl_VarEval(interp, "agt_puts ", argv[1], (char *) NULL)
          != TCL_OK)
      {
       return TCL_ERROR; 
      };
    }

    return TCL_OK;
   }


  /*                                                                 *
   * initialization procedure:                                       *
   * calls Tcl-function 'Tcl_CreateCommand' to create the new com-   *
   * mand 'usr_test', which is defined by the function 'usr_TestCmd' *
   * above.                                                          *
   *                                                                 */
   int Ideas_ActSrc_Init (Tcl_Interp *interp) {

    Tcl_CreateCommand(interp, "usr_test", usr_TestCmd, 
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);

    return TCL_OK;
   }
