#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_actAgt
#
#  Sends a status change message to agents selected in listbox 
#  .frame1.list 'Local Agent List' in UAM.
#  An error message is shown if no listbox entry is
#  selected.
#
# Arguments: None.
#
# Results: None.
#
proc uam_actAgt {} {
  global agents

  # get current selection in 'Local Agent List'
  set sel [.frame1.list curselection]

   keylset mesg :TYPE command :COMMAND chg_status

   foreach i $sel {
     set listentry [.frame1.list get $i]
     set agtName [lindex $listentry 0]

     keylset mesg :RECEIVER $agtName
     uam_sendMesg $mesg
   }
}


