#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_agtAbnormExit
#
#  Handles an abnormal exit of an agent, called by 'uam_commCtrl'.
#
# Arguments:
#
#  agtFid  - name of agents pipe
#  agtName - name of exited agent
#
# Results:  None
#
proc uam_agtAbnormExit {agtFid agtName} {
 global agents

  # remove communication control from pipe
  catch {fileevent $agtFid readable ""}

  # remove information about agent
  uam_rmAgt $agtName

  BEEP
  uam_dialog "ERROR: abnormal exit" "Agent '$agtName' exited abnormally !" left\
      error left 0 -1 OK

 uam_logText "Agent '$agtName' exited abnormally !\n" 

}

