#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_commCtrl
#
#  Controls pipes to agent processes with 'addinput'.
#  Reads message from pipe if reading event is detected
#  and calls 'uam_evalMesg'.
#  Removes agent when pipe is broken, i.e. agent process
#  has exited.
#
# Arguments:
#
#  agtFid  - agtFid of pipe event occured on
#  agtName - name of agent pipe comes from
#
# Results:  None
#
proc uam_commCtrl {agtFid agtName} {
 global agents uam_RecMesgList

 if {[gets $agtFid mesg] == -1} {
 # broken pipe detected, remove agent
 #
   uam_agtAbnormExit $agtFid $agtName
   return 
 }

 lappend uam_RecMesgList [list $agtFid $mesg] 

}


