#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_delAgt
#
#  Deletes all agents marked in listbox .frame1.list
#  'Local Agent List' in UAM after user agreed to do.
#  An error message is shown if no listbox entry is
#  selected.
#
# Arguments: None.
#
# Results: 
#
#  - deletes choosen agents from array agents() 
#  - kill agents process
#  - removes agents entry from .frame1.list in UAM
#
proc uam_delAgt {} {
  global agents

  # get the current selection in 'Local Agent List':
  set sel [.frame1.list curselection]

# create list of marked agent listbox entries sorted
# to falling numbers
#

   set l [expr [llength $sel] -1]
   for {set i $l} {$i >= 0} {incr i -1} {
     lappend indexlist [lindex $sel $i]
   }

# for each marked agent:
# security check !
# kill agents process, remove its agents() entry
# and delete entry in listbox
#
  foreach i $indexlist {
    set agtName [lindex [.frame1.list get $i] 0]
    set del_ok [uam_dialog "Delete Agent" "Are you sure you want\
       to delete\nagent '$agtName' ?" left question left 0 1 OK Cancel]

    if {$del_ok==0} {
      keylget agents($agtName) FID agtFid      
      catch {removeinput $agtFid}

      keylset mesg :RECEIVER $agtName :TYPE command :COMMAND exit
      uam_sendMesg $mesg

      uam_rmAgt $agtName $i
    }
   
  }

}


