#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_exit
#
#  Procedure to exit the UAM and so all agents belonging to it.
#
# Arguments:
#
#   askUser - if specified with 1 the user is asked for confirmation
#             (default 1)
#
# Results: none
#
proc uam_exit {{askUser 1}} {
 global agents uam_VarSubProcs uam_Shortcuts

 if {$askUser} {
   set no_exit [uam_dialog "Exit User Agent Manager" \
      "Do you really want to exit\n\ the User Agent Manager ?" \
      left question left 0 1 OK Cancel ]

   if {$no_exit} {return}
 }

 # send an exit mesg to all agents belonging to this UAM
 # 
 for_array_keys agtName agents {
   if {![cequal $agtName UAM]} {
     fileevent [keylget agents($agtName) FID] readable ""
     keylset mesg :RECEIVER $agtName :TYPE command :COMMAND exit
     uam_sendMesg $mesg
   }
 }


 # save array uam_Shortcuts to file uam_shortcutsFile.tcl
 #

 set fid [open "uam_shortcutsFile.tcl" w]

 for_array_keys key uam_Shortcuts {
     puts $fid "set uam_Shortcuts($key) {$uam_Shortcuts($key)}"
   flush $fid
 }

 close $fid

 # close all open editors
 #
 foreach pid $uam_VarSubProcs {
   catch {exec kill -9 $pid}
 }
   
 set logFile [keylget agents(UAM) LOGFID]

 puts $logFile "Logfile closed at [fmtclock [getclock] "%a %b %d %Y, %T"]\n"

 exit

}

