#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_handlePrologError
#
#  When an agent cannot cretae a Prolog-process it sends an error message to 
#  the UAM. The UAM catches the message by a message-rule, which
#  calls this procedure to show a warning to the user.
#
# Arguments:
# 
#   realFid   - filedesc the mesg arrived on 
#   agtName   - sender of mesg
#
# Results: None.
#
proc uam_handlePrologError {realFid agtName} {
global agents

 # check if the mesg really arrived on the file belonging to this agent
 # 
 if {[catch {keylget agents($agtName) FID agtFid}]} {
   uam_logText "WARNING - received Prolog-Error-Message on foreign FID:\
                $fid\nMessage ignored!\n"
   return
 }
 
 # show a mesg in a toplevel widget
 # 
 BEEP 
 uam_dialog "Prolog Error" "Prolog-Error\n\n received from \
             agent\n\n   $agtName\n\nSee agents logfile for details!" \
             center error left 0 -1 OK

}

