#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_helloIdeas
#
# This procedure displays the IDEAS startwindow.
# 
#
proc uam_helloIdeas {} {
    global tk_priv

set lastchg "last change: 06/03/96"

    # 1. Create the top-level window and divide it into top
    # and bottom parts.
    
    set w .dialog
    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w "About IDEAS"
    wm iconname $w Dialog
    frame $w.top 
    pack $w.top -side top -fill both -padx 5m -pady 5m
    frame $w.bot 
    pack $w.bot -side bottom -fill both

    # 2. Fill the top part with message.

    label $w.bitmap -bitmap @questionbulb
    pack $w.bitmap -in $w.top -side top
    
    message $w.msg1 \
       -text "IDEAS\n\nInteractive Development Environment\nfor Agent\
              Systems\n\nVersion 1.0a, 1995\n\nComputer Science\
              Department\nUniversity of Kiel, Kiel, Germany" \
       -font -Adobe-Times-Medium-R-Normal-*-180-* \
       -width 400 \
       -justify center
    pack $w.msg1 -in $w.top -side top -expand 1 -fill x

    message $w.msg2 \
       -text "\n Copyright (c) 1995 by\n\
              Matthias Klusch, Olaf Scheew, Bernd Grossmann\n\
              Computer Science Dept., Christian-Albrechts-University of Kiel,\n\
              Olshausenstr. 40, 24118 Kiel, Germany\n\n\
              \t\t$lastchg" \
       -font -Adobe-Times-Medium-R-Normal-*-120-* \
       -width 400 \
       -justify left
    pack $w.msg2 -in $w.top -ipadx 5m -expand 1 -fill both

    # 3. Create a button at the bottom of the dialog.
	button $w.button1 -text OK \
			   -command "set tk_priv(button) 1; destroy $w" \
			   -width 8
	    frame $w.default -relief sunken -bd 1
	    raise $w.button1 $w.default
	    pack $w.default -in $w.bot -side left -expand 1 -padx 3m -pady 2m
	    pack $w.button1 -in $w.default -padx 2m -pady 1m \
		    -ipadx 2m -ipady 1m
	    bind $w <Return> "$w.button1 flash
			      $w.button1 invoke"
            bind $w <Escape> "$w.button1 flash
			      $w.button1 invoke"

    # 4. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then place the window relative
    # to its parent and de-iconify it.

    wm withdraw $w
    update idletasks
    set dad [winfo parent $w]

    if {([set dadX [winfo x $dad]] == 0) || ([set dadY [winfo y $dad]] == 0)} {
      set x 300
      set y 200
    } else {
      set x [expr $dadX + ([winfo reqwidth $dad] - [winfo reqwidth $w])/2]
      set y [expr round($dadY + [winfo reqheight $dad]*0.3)]
    }

    wm geom $w +$x+$y
    wm deiconify $w


    # 5. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    set tk_priv(button) -1
    tkwait window $w
    update idletasks
}

