#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_initShortHelp.tcl
#
#  This file initializes the ShortHelp for UAM.
#  The array 'uam_Shorthelp' is filled with help text for
#  specified UAM widgets.
#
#  Entries have the following format:
#
#    set uam_ShortHelp(widgetName) {helpText helfile.hlp}
#
#  This causes 'helpText' to been shown as shortHelp 
#  for widget 'widgetName' and 'helpfile.hlp' is shown in the
#  IDEAS-Help-System if it is invoke out of  the Shorthelp window.
#

#
# ShortHelp about ShortHelp
#
set uam_ShortHelp(.shortHelp) \
  {"The IDEAS - ShortHelp :\n\nThe ShortHelp is\
    invoked by pointing with the cursor on a detail of an IDEAS-window\
    and pressing the right mouse button.\n\nIf ShortHelp is available for\
    this item a window like this appears and gives you a short\
    description." shortHelp.hlp}

#
# ShortHelp about the UAM main window
#
set uam_ShortHelp(.frame1) \
  {"The User Agent Manager :\n\nAs the name says it manages the\
    agents of the user.\n\nIt provides tools to specify and control\
    them and takes the minutes of all actions in a logfile." uam.hlp}

set uam_ShortHelp(.frame1.lbl) $uam_ShortHelp(.frame1) 
set uam_ShortHelp(.frame2.lbl) $uam_ShortHelp(.frame1) 
set uam_ShortHelp(.frame2) $uam_ShortHelp(.frame1)
set uam_ShortHelp(.mbar) $uam_ShortHelp(.frame1)

set uam_ShortHelp(.mbar.exit) \
  {"The Exit Menu :\n\nUse it to quit the User Agent\
    Manager.\n\n'Ctrl-q' is a shortcut." uam.hlp}

set uam_ShortHelp(.mbar.exit.menu) $uam_ShortHelp(.mbar.exit)

set uam_ShortHelp(.mbar.spec) \
  {"The Specification Menu :\n\nContains functions to\
    create and edit\n\nagent descriptions written in the Agent\
    Specification Language (ASL),\n\nlocal Multi-Agent-Systems (MAS)\
    and\n\nthe Action-C-Sources, which allows you to specify actions\
    for the agents in C additionally to that written in TCL." uam.hlp}

set uam_ShortHelp(.mbar.spec.menu) $uam_ShortHelp(.mbar.spec)
set uam_ShortHelp(.mbar.spec.menu.agt) $uam_ShortHelp(.mbar.spec)
set uam_ShortHelp(.mbar.spec.menu.mas) $uam_ShortHelp(.mbar.spec)
set uam_ShortHelp(.mbar.spec.menu.act) $uam_ShortHelp(.mbar.spec)

set uam_ShortHelp(.mbar.view) \
  {"The View Menu :\n\nContains a menubutton to show or to hide (resp.)\
    the User Agent Managers Logfile." uam.hlp}

set uam_ShortHelp(.mbar.view.menu) $uam_ShortHelp(.mbar.view)

set uam_ShortHelp(.mbar.help) \
  {"The Help Menu :\n\nIt leads you to the IDEAS Help-System." uam.hlp}

set uam_ShortHelp(.mbar.help.menu) $uam_ShortHelp(.mbar.help)

set uam_ShortHelp(.frame1.list) \
  {"The Agent List :\n\nThis list contains all agents currently local\
    to this User Agent Manager.\n\nIt displays name, type and\
    status of the agents.\n\nYou can select one agent from list by\
    clicking on it or select more then one by moving the mouse cursor\
    over them while holding the left button pressed down." uam.hlp}

set uam_ShortHelp(.frame2.newB) \
   {"The 'New'-Button :\n\nIt enables you to initialize a new\
     agent by giving an identifier and selecting a specification from\
     a list of all existing ASL-files." uam.hlp}

set uam_ShortHelp(.frame2.actB) \
  {"The 'Activate/Deactivate'-Button :\n\nAfter selecting an agent\
    from the Agent List you can invoke this button to change its status\
    from active to deactive and vice versa." uam.hlp}

set uam_ShortHelp(.frame2.delB)  \
  {"The 'Delete'-Button :\n\nAfter selecting an agent from the Agent\
    List you can delete it from the system by invoking this button.\
    \nBefore deletion is executed you have to confirm." uam.hlp}

set uam_ShortHelp(.frame2.mesgB) \
  {"The 'Message To'-Button :\n\nInvoke this button to specify a message and\
    send it to one or some of the local agents.\n\nYou can specify\
    the receiver of the message by selection from the Agent List before\
    invoking the button." uam.hlp}        
set uam_ShortHelp(.log) \
  {"The Logfile Widget :\n\nIn this widget you can\
    control UAMs activities by having a look in its Logfile.\n\nIn the\
    Logfile the UAM takes the minute of his activities and shows\
    each message sent to the agents and received from them.\n\nThe\
    'Auto-Scroll'-checkbutton is used to see always the latest entry\
    in the widget." uam.hlp}

set uam_ShortHelp(.log.label) $uam_ShortHelp(.log)
set uam_ShortHelp(.log.mbar) $uam_ShortHelp(.log)
set uam_ShortHelp(.log.mbar.scroll) $uam_ShortHelp(.log)
set uam_ShortHelp(.log.text) $uam_ShortHelp(.log)

#
# ShortHelp for the 'Shortcuts' window
#

set uam_ShortHelp(.shorts)\
  {"The Shortcuts Window :\n\nIt allows you to predefine messages to\
    use in the 'Message To' window.\n\nThe list shows you all available\
    shortcuts.\nYou can choice one entry and insert the message belonging\
    to it in the 'Message to' window by pressing the 'Select' button or\
    just doing a double click on the item.\n\nYou can use the shortcut from\
    the 'Message To' window without opening the 'Shortcuts' window by\
    pressing one of the key combinations shown in the list.\n\nFurther you\
    can add new shortcuts for a message, edit or remove an existing one by\
    using the appropriate button.\n\nSee Index for more details."\
    shortcuts.hlp} 

set uam_ShortHelp(.shorts.f1) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.f1.t) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.f1.m) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.f1.m.title) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.f1.b) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.new) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.edit) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.del) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.sel) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.close) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.name) $uam_ShortHelp(.shorts)
set uam_ShortHelp(.shorts.hotk) $uam_ShortHelp(.shorts)

#
# ShortHelp for the Help System
#
set uam_ShortHelp(.help.f0.list) \
  {"The Topics List :\n\nThis listbox includes\
    all available Help Topics.\nYou can select an item from the list and watch\
    its content by invoking the 'Show'-button or double click."}

set uam_ShortHelp(.help.f2.fr.lbl1) \
  {"The Help Title :\n\nThis is the title of the Help Topic\
    currently shown in the text window."}

set uam_ShortHelp(.help.f2.fr.lbl2) $uam_ShortHelp(.help.f2.fr.lbl1)

set uam_ShortHelp(.help.f2.text) \
  {"The Help Content :\n\nHere you see the\
    content of the last selected Help Topic.\n\nIts title is displayed in the\
    headline."}

set uam_ShortHelp(.help.f1.show) \
  {"The Show Button :\n\nInvoke this button\
    after selecting an Help Topic from the list to have a look at its\
    content.\n\nIf no selection is made the information about the Help System\
    is shown."}

set uam_ShortHelp(.help.f1.close) \
   {"The Close Button :\n\nIt just closes the Help System window."}

