#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_logText
#
#  Displays text in UAMs observer window and
#  writes it to the logfile.
#
# Arguments:
#
#	text	 -	text to display
#	nextLine -	if 0 no newline after text,
#			default 1
#
# Results:  None.
#
proc uam_logText {text {nextLine 1}} {
  global agents uam_VarLogScroll

  set logFile [keylget agents(UAM) LOGFID]

  # if the UAM widget is closed, exit the UAM without asking
  #
  if {[catch {.log.text configure -state normal}]} {
    uam_exit 0
    return
  }

  if {$nextLine != 0 } {
    puts $logFile $text
   .log.text insert end "$text \n" 
  } else {
    puts -nonewline $logFile  $text
   .log.text insert end "$text" 
  }

  .log.text configure -state disabled

  if {$uam_VarLogScroll} {
    .log.text yview -pickplace end
  }

  flush $logFile
  update

}

