#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_newAgtChgView
#
#  Changes the view in the widget for selecting new agents to initialize
#  between the list of agent-types and the list of MAS.
#
# Arguments: None.
#
# Results: None.
#
#
proc uam_newAgtChgView {} {
global uam_VarInitType ideas_HomePath

 # value of global variable 'uam_VarInitType' shows which view is actual:
 #   1  agent types
 #   2  Multi-Agent-Systems

  if {$uam_VarInitType == 1} {
    .init.top.inpt configure -state normal
    .init.top.lbl configure -foreground black
    .init.frame1.lbl configure -text "Scripts in Directory:"
    .init.frame2.lbl configure -text "Selected Script:"

    uam_fillLb .init.frame1.list $ideas_HomePath/desc/*.agt
    uam_selectLbEntry .init.frame1.list 0
    uam_insertLbSel .init.frame1.list .init.frame2.inpt

    focus .init.top.inpt
    update
  } else {
    .init.top.inpt configure -state disabled
    .init.top.lbl configure -foreground slategray3
    .init.frame1.lbl configure -text "Systems in Directory:"
    .init.frame2.lbl configure -text "Selected System:"

    uam_fillLb .init.frame1.list $ideas_HomePath/systems/*.mas
    uam_selectLbEntry .init.frame1.list 0
    uam_insertLbSel .init.frame1.list .init.frame2.inpt

    focus .init.frame2.inpt
    update
  }
}

