#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_rmAgt
#
#  Removes a agent from UAMs environment.
#
# Arguments:
#
#  agtName    - Name of an agent to remove
#  agtLbIndex - ListboxIndex of agent in uams agentlist,
#               maybe unspecified
#
# Results:
#  None
#

proc uam_rmAgt {agtName {agtLbIndex -1}} {
 global agents

# wait for exited agentsProcess
#
 catch {wait [keylget agents($agtName) PID]}

# close pipe to agent
#
 catch {close [keylget agents($agtName) FID]}


 set listB .frame1.list

# examine listboxentry of agent if not specified
#
 if {$agtLbIndex == -1} {
  for {set agtLbIndex 0} {$agtLbIndex <= [expr [$listB size]-1]} \
    {incr agtLbIndex} {
    if {[lindex [$listB get $agtLbIndex] 0]==$agtName} {
      break
    }
  }
 }

# delete agent from agentslist
#
 .frame1.list delete $agtLbIndex
 .frame1.list selection set $agtLbIndex
 .frame1.list yview 0

# if Agent List is empty now, disable the activate,
# delete and mesg-to button
#
 if {[.frame1.list size] == 0} {
   .frame2.actB  configure -state disabled
   .frame2.delB  configure -state disabled
   .frame2.mesgB configure -state disabled

   bind . <Alt-Key-a> ""
   bind . <Alt-Key-d> ""
   bind . <Alt-Key-m> ""
 }

# delete agents array entry
#
 catch {unset agents($agtName)}

 update idletasks
}

