#
# Copyright (c) 1995 by Matthias Klusch, Olaf Scheew, Bernd Grossmann
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
#
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#

#
# uam_stuff.tcl
#
# This file concludes several procs that show messages in
# a little toplevel to the user, using 'uam_dialog'.
#
#

proc uam_notImpl {} {
 uam_dialog "Message" "This function is not implemented..." \
            left info left 0 -1 OK
}


proc uam_noAgtIdf {} {
 BEEP
 uam_dialog "Error: No name specified" \
            "You have to specify a name\nfor the new agent." \
	    left error left 0 -1 OK
 focus .init.top.inpt
}

proc uam_illegalAgtName {agtName} {
 BEEP
 uam_dialog "Error: Illegal name"\
            "Illegal identifier for agent name:\n\n'$agtName'\n\nAgents\
             names may consist of alpha-numerical\
             characters only!\n\n\Please choose another identifier." \
             center error left 0 -1 OK
 focus .init.top.inpt
}

proc uam_newNameExists {agtName} {
 BEEP
 uam_dialog "Error: Existing name" \
            "The specifier '$agtName' is in use already.\
             \n\nYou have to specify an other name\nfor the new agent."\
	    left error left 0 -1 OK
 focus .init.top.inpt
}


proc uam_notExType {typeName} {
 BEEP
 uam_dialog "Error: Script not exists" \
            "There is no script file existing\n with name '$typeName'\
             .\n\nPlease choose a file from the list."\
	    left error left 0 -1 OK

}

proc uam_notExSystem {systemName} {
 BEEP
 uam_dialog "Error: System not exists" \
            "There is no system file existing\n with name '$systemName'\
             .\n\nPlease choose a file from the list."\
	    left error left 0 -1 OK

}

proc uam_notExActSrc {fileName} {
 BEEP
 uam_dialog "Error: Action-C-Source not exists" \
            "There is no Action-C-Source\
             file existing with name '$fileName'\
             .\n\nPlease choose a file from the list."\
	    left error left 0 -1 OK

}


proc uam_sendMesgError {text} {
 BEEP
 uam_dialog "Error: Send message" $text left error left 0 -1 OK
}


proc uam_startMASError {system} {
 BEEP 
 uam_dialog "MAS Start-Error" "Error when starting the\
             \nMulti-Agent-System\n\n'$system'\n\nSee UAM logfile\
             for details !" \
             left error left 0 -1 OK
}

proc uam_conMASError {agtName} {
 BEEP 
 uam_dialog "MAS Connection-Error" "Error when trying to connect in\
             \nMulti-Agent-System.\n\nCannot connect\
             agent\n\n'$agtName'\n\nSee UAM logfile\
             for details !" \
             center error left 0 -1 OK
}


proc uam_actSrcError {agtType} {
 BEEP 
 uam_dialog "Action-C-Source Error" \
            "Action-C-Source Error\nwhen starting Agent \
             with script\n\n'$agtType'\n\nSee UAM logfile\
             for details !" \
             center error left 0 -1 OK
}

