/*********************  expand.c  *********************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree.h"
#include "expand.h"

extern Liste *cycle;

/* globale Variablen */
int n, k;

Baum *prim_cycle (char *str, Baum *bm)
{
  char prim_str[64];
  Baum *ptr;
  int i;

  if (bm == NULL)
   return NULL;

  ptr = bm;
  
  if (ptr->child != NULL)
    prim_cycle (str, ptr->child);
  
  if (ptr->brother != NULL)
    prim_cycle (str, ptr->brother);


  /* umformen von str in <str> */
  if (strcmp (str, ptr->Token) == 0) { 
    i = 0;
    prim_str[0] = '\0';
    prim_str[0] = '<';
    while ((ptr->Token)[i] != '\0') {
      prim_str[i+1] = ptr->Token[i];
      i++;
    }
    prim_str[i+1] = '>';
    prim_str[i+2] = '\0';
  
    strcpy(ptr->Token, prim_str);
  }
  
  return (ptr);  
}



int cycle_Term (char *str, Baum *bm)
{

  Baum *ptr;

  if (bm == NULL)
    return (1);

  ptr = bm;

  if (ptr->child != NULL){
    cycle_Term (str, ptr->child);
    if (cycle_Term(str, ptr->child) == 0)
      return (0);
  }

  if (ptr->brother != NULL){ 
    cycle_Term (str, ptr->brother);
    if (cycle_Term(str, ptr->brother) == 0)
      return (0);
  }

  if (strcmp (str, ptr->Token) == 0)
    return (0);
  else
    return(1);
}


int cycle_Terme (Terme *tm)
{
  Terme *ptr;
  char wahl[4];
  Liste *act_cycle;

  ptr = tm;
  
  while (ptr != NULL) {
    if (cycle_Term (ptr->expression->ATerm, ptr->expression->term) == 1)
      ptr = ptr->next;

    else{
      printf ("\nTerm %s ist zyklisch definiert\n", ptr->expression->ATerm);
      printf ("TEWIS erlaubt nur azyklische Terminologien. \n
Wollen Sie Ihre Terminologie neu eingeben? 'ja' oder 'nein'.\n");
      scanf("%s", wahl);
      getchar ( );

      if (strcmp(wahl, "ja") == 0) 
        break;
      else {
        if (strcmp(wahl,"nein") == 0){
          if (cycle == NULL) {
            cycle = Node_Liste ( ); 
            strcpy(cycle->str, ptr->expression->ATerm);
            cycle->next = NULL;
          }
          else {
            act_cycle = cycle;
            while (act_cycle->next != NULL)
              act_cycle = act_cycle->next;
       
            act_cycle->next = Node_Liste ( );
            act_cycle = act_cycle->next;
            strcpy (act_cycle->str, ptr->expression->ATerm);
            act_cycle->next = NULL;
          }

          ptr->expression->term = prim_cycle (ptr->expression->ATerm, 
                                              ptr->expression->term); 
          ptr = ptr->next;         
        }
      }
    }
  }
  if (ptr == NULL)
    return (0); 

  return (1);
}



/******************************************************/
/* FUNCTION  : Anhang_Terme                           */
/* PARAMETER : Terme *tm, char *s1, char *s2,         */
/*             char *s3, char *s4                     */
/* RETURN    : Terme *                                */
/* PURPOSE   : Hilfsfunktion fuer die Funktion form.  */
/*             Eine Termdefinition wird erstellt und  */
/*             am Ende der Terminologie tm angehaengt.*/
/******************************************************/


Terme *Anhang_Terme (Terme *tm, char *s1, char *s2, char *s3, char *s4)
{
  Terme *ptr;
 
  ptr = tm;
  while (ptr->next != NULL)
    ptr = ptr->next;

  /* Erzeugung einer neuen Termdefinition */  
  ptr->next = Node_Terme ( );
  ptr = ptr->next;
  ptr->expression = Node_Term ( );
  ptr->expression->ATerm = (char *)strdup (s1);
  ptr->expression->equal = (char*)strdup (s3);
  ptr->expression->term = Node_Baum ( );      

  ptr->expression->term->Token = (char *)strdup (s2);
  ptr->expression->term->lKlammer = (char *)strdup ("( ");
  ptr->expression->term->rKlammer = (char *)strdup (") ");

  ptr->expression->term->child = Node_Baum ( ); 
  ptr->expression->term->child->Token = (char *)strdup (s4);
  ptr->expression->term->child->lKlammer = (char *)strdup (" ");
  ptr->expression->term->child->rKlammer = (char *)strdup (" ");
  ptr->expression->term->child->child = NULL;
  ptr->expression->term->child->brother = NULL;
  ptr->expression->term->child->father = ptr->expression->term;

  ptr->next = NULL;

  return (tm);
}



/*****************************************************/
/* FUNCTION  : form                                  */
/* PARAMETER : Baum *B, Baum *father, Terme *t       */
/* RETURN    : Baum *                                */
/* PURPOSE   : Jeder atomare Term B, der in einem    */
/*             konzept- oder rollendefinierenden     */
/*             Term vorkommt, aber selbst keinen     */
/*             definierenden Term besitzt, wird als  */
/*             eine Termdefinition                   */
/*             B :=C(and <B>) oder B :=R(androle <B>)*/
/*             am Ende der Terminologie t angehaengt.*/
/*****************************************************/


Terme *form (Baum *bm, Baum *father, Terme *tm)
{
   int k, n; 
   char str[64];
   Terme *ptr;
   Baum *bm1, *bm2; 

 
   /* Den Baum mit der Wurzel bm rekursiv umformen. */
   if (bm->child != NULL) {
     form (bm->child, bm, tm); 
      
     bm2 = bm->child->brother;
     while (bm2 != NULL) {
       form (bm2, bm, tm);
       bm2 = bm2->brother;
     }
   } 
   else {
 
     /* Der atmoare Term ist kein primitive Komponente, */
     /* auch nicht 'NOTHING'.*/

     if ((bm->Token)[0] != '<'&& 
          strcmp (bm->Token,"NOTHING") != 0 && bm->father != NULL) {
        
        /* umformen von C in <C> */ 
        n = 0;
        str[0] = '\0';
        str[0] = '<';
        while ((bm->Token)[n] != '\0') {
          str[n+1] = bm->Token[n];
          n++;
        }
        str[n+1] = '>';
        str[n+2] = '\0';  

        /* Der atomare Term ist kein Element vom 'aset'_Term. */
        if (strcmp (bm->father->Token, " ") != 0) { 
       
          /* ptr zeigt auf den Beginn der Terminologie tm. */
          ptr = tm;
          k = 0;
       
          while (ptr != NULL) {
            /* Der atmomare Term besitzt definierenden Term. */
            if (strcmp (bm->Token, ptr->expression->ATerm) == 0) {
              k = 1;   
              break;
            }
            else
              ptr = ptr->next;
          }

          /* Der atmomare Term besitzt keinen definierenden */
          /* Term und ist auch keinen Zahl.                 */
          if ( k == 0 && (bm->Token[0]) != '1' && (bm->Token[0]) !='2' 
               && (bm->Token[0]) !='3' && (bm->Token[0]) !='4'
               && (bm->Token[0]) !='5' && (bm->Token[0]) !='6'
               && (bm->Token[0]) !='7' && (bm->Token[0]) !='8'
               && (bm->Token[0]) !='9' && (bm->Token[0]) !='0') { 

            /* Der atmoare Term ist ein Konzept */
            if (strcmp (father->Token, "and") == 0 ||
               (strcmp (father->Token, "all") == 0 
                && bm->brother == NULL)||
               (strcmp (father->Token, "exist") == 0 
                && bm->brother == NULL))

              Anhang_Terme (tm, bm->Token, "and", ":=C", str);
            
            else {
              /* Der atmoare Term ist eine Rolle */
              if (strcmp (father->Token, "androle") == 0 ||
                 strcmp (father->Token, "atleast") == 0 ||
                 strcmp (father->Token, "atmost") == 0)

                Anhang_Terme (tm, bm->Token, "androle",":=R", str);
            }
          }
        }

        /* Der atmoare Term ist Element vom 'aset_Term'. */
        else
          bm->Token = (char *)strdup (str);
      }
   }

   return (tm);
}


/*****************************************************/
/* FUNCTION  : form_Terme                            */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : wendet Funktion form auf die          */
/*             Terminologie tm an.                   */
/*****************************************************/

void *form_Terme (Terme *tm)
{

   Terme *ptr, *tm1;
   ptr = tm;
 
   while (ptr != NULL) {
     form (ptr->expression->term, NULL, tm);
     ptr = ptr->next;
   } 
}


/*****************************************************/
/* FUNCTION  : all_expand                            */
/* PARAMETER : Baum *bm, Terme *tm                   */
/* RETURN    : Baum *                                */
/* PURPOSE   : Alle atomaren Term im definierenden   */
/*             Term eines Konzept- oder Rollen-      */
/*             bezeichners werden durch ihre         */
/*             definierenden Term ersetzt.           */
/*****************************************************/


Baum *all_expand (Baum *bm, Terme *tm)
{

  Terme *ptr;
  Baum *bm1, *bm2, *bm3, *bm4; 

  
  /* rekursive Anwendung der Funktion auf den Baum mit der Wurzel bm */
  if (bm == NULL)
    return NULL;
 
  if (bm->child != NULL) {  

     /* Fuer den ersten Nachfolger des Baums */
     bm1 = all_expand (bm->child, tm);
           
     /* wenn ein atomare Term C ersetzt werden soll, zeigt */
     /* bm1 nicht auf C. Ansonsten zeigt bm1 auf  C.       */

     /* atomare Term wird ersetzt. */
     if (bm->child != bm1) {
       bm3 = bm->child;
      
       /* Versetzen der Verbindungen */
       bm->child = bm1;
       bm1->father = bm;
       bm1->brother = bm3->brother;

       free (bm3);
     }
     
     /* Der gleicher Durchlauf fuer die anderen Nachfolger des Baums */

     bm2 = bm->child->brother;

     /* bm4: Vorgaenger von bm2 */
     bm4 = bm->child;

     while (bm2 != NULL) {
       bm1 = all_expand (bm2, tm);

       if (bm2 != bm1) {
         bm4->brother = bm1;
         bm1->father = bm;
         bm1->brother = bm2->brother;
         free (bm2);
         bm2 = bm1->brother;
         bm4 = bm1;
       }
       else {
         bm4 = bm4->brother;
         bm2 = bm2->brother;
       }
    }
  }

  /* Erreichen eines Blatt des Baums. */
  else {
    /* Zeiger auf den Beginn der Terminologie */
    ptr = tm;

    while (ptr != NULL) {
      if (strcmp (bm->Token, ptr->expression->ATerm) == 0) {

        /* Der atomare Term wird durch ihren */
        /* definierenden Term ersetzt.       */
        bm = copy_Baum (ptr->expression->term, NULL);
        n = 1;
        break;
      }
      else
        ptr = ptr->next;
    }
  }     
  return (bm);

}

/*****************************************************/
/* FUNCTION  : all_exp_Terme                         */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : wendet Funktion all_expand auf alle   */
/*             Termdefinitionen der Terminologie an. */
/*****************************************************/

void all_exp_Terme (Terme *tm)
{
   Terme *ptr;

   do {
     n = 0;  

     if (cycle_Terme (tm) == 1)
       break; 

     ptr = tm;
     while (ptr != NULL) {
       all_expand (ptr->expression->term, tm);
       ptr = ptr->next;
     } 
   } while (n == 1);
  
   ENDE: ;
}



/*****************************************************/
/* FUNCTION  : expand                                */
/* PARAMETER : Baum *bm, Terme *tm                   */
/* RETURN    : Baum *                                */
/* PURPOSE   : wie Funktion expand, expandiert jedoch*/
/*             eine Termdefinition ohne Expansion der*/
/*             Rollenrestriktionen.                  */
/*****************************************************/

Baum *expand (Baum *bm, Terme *tm)
{

  Terme *ptr;
  Baum *bm1, *bm2, *bm3, *bm4; 

  if (bm == NULL)
    return NULL;
  
  if (bm->child != NULL) { 

    /* keine Rollenrestriktion */
    if (strcmp (bm->Token, "all") != 0 &&
        strcmp (bm->Token, "atleast") != 0 &&
        strcmp (bm->Token, "atmost") != 0 && 
        strcmp (bm->Token, "exists") != 0 ) {
            
       bm1 = expand (bm->child, tm);

       if (bm->child != bm1) {
         bm3 = bm->child;
         bm->child = bm1;
         bm1->father = bm;
         bm1->brother = bm3->brother;
         free (bm3);
       }

       bm2 = bm->child->brother;
       bm4 = bm->child;

       while (bm2 != NULL) {
         bm1 = expand (bm2, tm);

         if (bm2 != bm1) {
           bm4->brother = bm1;
           bm1->father = bm;
           bm1->brother = bm2->brother;
           free (bm2);
           bm2 = bm1->brother;
           bm4 = bm1;
         }
         else {
           bm4 = bm4->brother;
           bm2 = bm2->brother;
         }
       }
     }
  }
  else {  
    ptr = tm;
    while (ptr != NULL) {
      if (strcmp (bm->Token, ptr->expression->ATerm) == 0) {
        bm = copy_Baum (ptr->expression->term, NULL);
        k = 1;
        break;
      }
      else
        ptr = ptr->next;
    }
  }
 
  return (bm);
}


/*****************************************************/
/* FUNCTION  : exp_Terme                             */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : wendet Funktion expand auf alle Term- */
/*             definitionen der Terminologie tm an.  */
/*****************************************************/

void exp_Terme (Terme *tm)
{
   Terme *ptr;

   do {
     k = 0;
 
     if (cycle_Terme (tm) == 1)
       break;      

     ptr = tm;
     while (ptr != NULL) {
       expand (ptr->expression->term, tm);
       ptr = ptr->next;
     }

   } while (k == 1);  

   ENDE: ;
}


