/**************************  file.c   *****************************/

#include <stdio.h>
#include "tree.h"

Terme *ITF = NULL;   
Welt *SAF = NULL;
int yyparse();
FILE *yyin;

extern char T_file[101], W_file[101];
extern enum BOOL a;


/*****************************************************/
/* FUNCTION  : neu_File                              */
/* PARAMETER : char filename [36]                    */
/* RETURN    : FILE *                                */
/* PURPOSE   : Die ueber die Tastatur eingegebene    */
/*             Datensaetze werden unter dem Name     */
/*             'filename' in einem File gespeichert. */
/*****************************************************/

FILE *new_File (char filename[36] ) {

   char satz[256];
   FILE *fp;
  
   printf ("Bitte neue Datensaetze eingeben: \n");

   fp = fopen (filename, "a+");

   do {
     gets(satz);
     fprintf (fp, "%s", satz);
     if (satz [strlen (satz) -1] == ';')
       putc ('\n', fp);
   } while(satz[strlen(satz) - 1] == ';' );

   fclose (fp);
  
   return fp;
}

  
/*****************************************************/
/* FUNCTION  : zufuegen_File1                        */
/* PARAMETER : char filename [36]                    */
/* RETURN    : FILE *                                */
/* PURPOSE   : neue Datensaetze werden ueber die     */
/*             Tastatur am Ende des Files mit dem    */
/*             Name 'filename' zugefuegt.            */
/*****************************************************/


FILE *zufuegen_File1 (char filename[36] ) {

   char satz[256];
   FILE *fp;

   if (fopen(filename, "r") == NULL) {   
     printf("Die Datei %s existiert noch nicht.\n", filename); 
     return NULL;
   };
  
   printf ("Bitte neue Datensaetze eingeben: \n");

   fp = fopen (filename, "a+");
   putc (';', fp);
   putc ('\n', fp);

   do {
     gets(satz);
     fprintf (fp, "%s", satz);

     if (satz [strlen (satz) -1] == ';')
       putc ('\n', fp);
   } while(satz[strlen(satz) - 1] == ';' );

   fclose (fp);
  
   return fp;
}    



/*****************************************************/
/* FUNCTION  : zufuegen_File1                        */
/* PARAMETER : char filename [36]                    */
/* RETURN    : FILE *                                */
/* PURPOSE   : Die Funktion dient dazu, ein File am  */
/*             Ende des Files mit dem Name 'filename'*/
/*             anzuhaengen.                          */ 
/*****************************************************/

FILE *zufuegen_File2 (char filename[36] ) {

   char fname[36], c;
   FILE *fp, *fp1;

   if (fopen(filename, "r") == NULL) {   
     printf("Die Datei %s existiert noch nicht.\n", filename); 
     return NULL;
   };
  
   printf ("Bitte den Namen der Datei, das zur Datei %s zugefuegt wird,\
eingeben.\n", filename);

   scanf ("%s", fname);
   getchar ( );   

   fp = fopen (filename, "a+");
   putc (';', fp);
   putc ('\n', fp);

   fp1 = fopen (fname, "r");
   if (fp1 == NULL) {
     printf ("Die Datei %s kann nicht zum Lesen geoeffnet werden.\n", fname);
     exit (1);
   }

   while ((c = getc (fp1)) != EOF)
     putc (c, fp);

   fclose (fp1);
   fclose (fp);
  
   return fp;
}    



/*****************************************************/
/* FUNCTION  : tmp_file                              */
/* PARAMETER :                                       */
/* RETURN    : void                                  */
/* PURPOSE   : Die neue Termdefinition (en) wird in  */
/*             der Terminologie nach dem Wunsch des  */
/*             Benutzers gespeichert.                */
/*****************************************************/


void tmp_file ( )
{
    char c, key[4];
    FILE *fp, *fp1;

    printf ("\n\nSoll(en) die eben eingegebene(n) Termdefinition(en) in \
der Terminologiedatei gespeichert werden? 'ja' oder 'nein'\n");

    scanf ("%s", key);

    if (strcmp (key, "ja") == 0) {
       fp = fopen (T_file, "a+");
       putc (';', fp);
       putc ('\n', fp);
       putc ('\n', fp);

       fp1 = fopen ("tmpfile", "r");
       if (fp1 == NULL) {
         printf ("tmp_file kann nicht zum Lesen geoeffnet werden.\n");
         exit (1);
       }

       while ((c = getc (fp1)) != EOF) {
         putc (c, fp);
         if (c == ';') {
           putc ('\n', fp); 
           putc ('\n', fp);
         }
       }

       fclose (fp1);
       fclose (fp);
       a = TRUE;
    }
    else
      if (strcmp (key, "nein") == 0)
        ;
      else
        printf ("Falsche Eingabe, es soll 'ja' oder 'nein' sein.\n");
 
}



/*****************************************************/
/* FUNCTION  : File                                  */
/* PARAMETER :                                       */
/* RETURN    : char *f                               */
/* PURPOSE   : Menuesteuerung                        */
/*             Laden eines exisitierenden Files oder */
/*             Erstellen eines neuen Files oder      */
/*             Modifizieren eines existierenden Files*/
/*****************************************************/

void File (char file1[36] ) {

   int f, d;
   /*   char *file1[36];*/

   win_File ( );

   printf ("Bitte Ihre Wahl eingeben:\n");   
   scanf ("%d", &f);
           
   switch (f) {
     case 1:  printf ("Den Namen der Datei eingeben:\n");
              scanf("%s", file1);
	      getchar ( );
              break;

     case 2: printf ("Unter welchem Namen sollen die eingegebenen Datensaetze \
gespeichert werden ?\n");
             scanf ("%s", file1);
             getchar ( );
    
             new_File (file1);
             break;

      case 3: printf ("Zu welcher Datei sollen die neuen Datensaetze \
hinzugefuegt werden ?\n");
              scanf ("%s", file1);
              getchar ( );

              printf ("Die neuen Datensaetze: 1. ueber die Tastatur eingeben \
2.aus einer anderen Datei laden\n");

              scanf("%d", &d);
              getchar ( );
 
              if (d == 1)                    
                zufuegen_File1 (file1);
              else
                if (d == 2)
                  zufuegen_File2 (file1);

              break;
     
      default: printf ("Ihre Eingabe wird nicht akzeptiert. \n");
               return ;
   }
}



/*****************************************************/
/* FUNCTION  : TF                                    */
/* PARAMETER :                                       */
/* RETURN    : Terme *                               */
/* PURPOSE   : Ein File der Grundterminologie wird   */
/*             lexikalisch und syntaktisch geprueft. */
/*             und in den entsprechenden Daten-      */
/*             strukturen von "tree.h" abgespeichert.*/
/*****************************************************/

Terme *TF ( )
{
   
   yyin = fopen(T_file, "r");   
   if (yyin == NULL) {      
     printf("Datei %s kann nicht geoffenet werden.\n", T_file); 
     return NULL;
   };
     
   yyparse();

   sort1 (ITF);
   sort2 (ITF);
 
   return (ITF);
}


/*****************************************************/
/* FUNCTION  : AF                                    */
/* PARAMETER :                                       */
/* RETURN    : Welt *                                */
/* PURPOSE   : Ein File der Objektwelt wird          */
/*             lexikalisch und syntaktisch geprueft  */
/*             und in den entsprechenden Daten-      */
/*             strukturen von "tree.h" abgespeichert.*/ 
/*****************************************************/


Welt *AF ( )
{
   
   yyin = fopen(W_file, "r");   
   if (yyin == NULL) {      
     printf("Datei %s kann nicht geoeffnet werden.\n", W_file); 
     return NULL;
   };
     
   yyparse();

   return (SAF);
}







