/**************************  help.c  ******************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree.h"


/********************************************************************/
/*    Die Funktionen Node_Baum, Node_Baume, Node_Term, Node_Terme   */
/*    Node_Welt, Node_Liste, Node_OW, Node_srole generieren den     */
/*    Speicher fuer die Datenstrukturen Baum, Baume, Term, Terme,   */
/*    Welt, Liste, O_Welt und set_role.                             */
/********************************************************************/

Baum *Node_Baum ( )
{
   Baum *ptr;

   if ((ptr = (Baum *)malloc (sizeof (Baum))) == NULL )
   printf ("Speicheranforderung fuer Baum konnte nicht erfuellt \
werden.\n");

   return ptr; 
}


Baume *Node_Baume ( )
{
   Baume *ptr;

   if ((ptr = (Baume *)malloc (sizeof (Baume))) == NULL )
   printf ("Speicheranforderung fuer Baum konnte nicht erfuellt \
werden.\n");

   return ptr; 
}


Term *Node_Term ( )
{
   Term *ptr;

   if ((ptr = (Term *)malloc (sizeof (Term))) == NULL )
   printf ("Speicheranforderung fuer Term konnte nicht erfuellt \
werden.\n");

   return ptr; 
}


Terme *Node_Terme ( )
{
   Terme *ptr;

   if ((ptr = (Terme *)malloc (sizeof (Terme))) == NULL )
   printf ("Speicheranforderung fuer Terme konnte nicht erfuellt\
 werden.\n");

   return ptr; 
}


Welt *Node_Welt ( )
{
   Welt *ptr;

   if ((ptr = (Welt *)malloc (sizeof (Welt))) == NULL )
   printf ("Speicheranforderung fuer Welt konnte nicht erfuellt \
werden.\n");

   return ptr; 
}



Liste *Node_Liste ( )
{
   Liste *ptr;

   if ((ptr = (Liste *)malloc (sizeof (Liste))) == NULL )
   printf ("Speicheranforderung fuer Liste konnte nicht erfuellt \
werden.\n");

   return ptr; 
}




O_Welt *Node_OW ( )
{
   O_Welt *ptr;

   if ((ptr = (O_Welt *)malloc (sizeof (O_Welt))) == NULL )
   printf ("Speicheranforderung fuer O_Welt konnte nicht erfuellt \n
werden.\n");

   return ptr; 
}



set_role *Node_srole ( )
{
    set_role *ptr;

   if ((ptr = (set_role *)malloc (sizeof (set_role))) == NULL )
   printf ("Speicheranforderung fuer set_role konnte nicht erfuellt \n
werden.\n");

   return ptr;
}




/*****************************************************/
/* FUNCTION  : copy_Baum                             */
/* PARAMETER : Baum *a, Baum *b                      */
/* RETURN    : Baum *c                               */
/* PURPOSE   : Baum a wird mit der Hilfe von Baum b  */
/*             nach Baum c kopiert                   */
/*****************************************************/

Baum *copy_Baum (Baum *alt_Baum, Baum *father)
{
   Baum *neu_Baum;

   if (alt_Baum == NULL)
     return NULL;

   /* Generieren des Speichers neu_Baum */
   neu_Baum = Node_Baum ( );

   /* Die Inhalte (lKlammer, rKlammer, Token) des   */
   /* alten Baums werden in den neuen Baum kopiert. */ 
   neu_Baum->lKlammer = (char *) strdup (alt_Baum->lKlammer);
   neu_Baum->Token = (char *) strdup (alt_Baum->Token);
   neu_Baum->rKlammer = (char *) strdup (alt_Baum->rKlammer);

   /* Initialisierung der Zeiger */
   neu_Baum->father = father;
   neu_Baum->brother = NULL;     
   neu_Baum->child = NULL;  

   /* rekursiv kopieren */
   if (alt_Baum->child != NULL)
      neu_Baum->child = copy_Baum (alt_Baum->child, neu_Baum);
      
   if (alt_Baum->brother != NULL)
      neu_Baum->brother = copy_Baum (alt_Baum->brother,father);
     

   return neu_Baum;
}


/*****************************************************/
/* FUNCTION  : copy_Terme                            */
/* PARAMETER : Terme *a                              */
/* RETURN    : Terme *b                              */
/* PURPOSE   : Terme a wird nach Terme b kopiert     */
/*****************************************************/

Terme *copy_Terme (Terme *alt_Terme)
{
   Terme *neu_Terme;
  
   if (alt_Terme == NULL)
     return NULL;

   /* Generieren des Speichers neu_Terme */
   neu_Terme = Node_Terme ( ); 
     
   /* Generieren des Speichers Term von neu_Terme */
   neu_Terme->expression = Node_Term ( );      

   /* Die Inhalte eines alten Terms wird in den neuen Term kopiert. */
   neu_Terme->expression->ATerm = 
                    (char *) strdup (alt_Terme->expression->ATerm);

   neu_Terme->expression->equal = 
                    (char *) strdup (alt_Terme->expression->equal);

   neu_Terme->expression->term = 
                    copy_Baum (alt_Terme->expression->term, NULL);
   
   neu_Terme->next = NULL;
 

   /* rekursiv kopieren */
   if (alt_Terme->next != NULL)
      neu_Terme->next = copy_Terme (alt_Terme->next);
  

   return neu_Terme;
}


/*****************************************************/
/* FUNCTION  : copy_Liste                            */
/* PARAMETER : Liste *a                              */
/* RETURN    : Liste *b                              */
/* PURPOSE   : Liste a wird nach Liste b kopiert     */
/*****************************************************/

Liste *copy_Liste (Liste *lst)
{

   Liste *neu_Liste;

   if (lst == NULL)
     return NULL;

   neu_Liste = Node_Liste ( );
   strcpy (neu_Liste->str, lst->str);
   neu_Liste->next = NULL;

   if (lst->next != NULL)
     neu_Liste->next = copy_Liste (lst->next);

   return (neu_Liste);
}


/*****************************************************/
/* FUNCTION  : copy_Welt                             */
/* PARAMETER : Welt *a                               */
/* RETURN    : Welt *b                               */
/* PURPOSE   : Welt a wird nach Welt b kopiert       */
/*****************************************************/

Welt *copy_Welt (Welt *W)
{

   Welt *neu_Welt;


   if (W == NULL)
     return NULL;

   neu_Welt = Node_Welt ( );
   neu_Welt->ls = copy_Liste (W->ls);
   neu_Welt->next = NULL;

   if (W->next)
     neu_Welt->next = copy_Welt (W->next);


   return (neu_Welt);
}






/*****************************************************/
/* FUNCTION  : del_Liste                             */
/* PARAMETER : char *s, Liste *l                     */
/* RETURN    : Liste                                 */
/* PURPOSE   : Das Element s wird aus der Liste l    */
/*             entfernt.                             */
/*****************************************************/

Liste *del_Liste (char *str, Liste *list)
{
   Liste *Zeiger1, *Zeiger2;

   if (list != NULL) { 

     /* Das Element 'str' ist das erste Element der Liste. */
     if (strcmp (list->str, str) == 0) {
       Zeiger1 = list->next;
       free (list);
       list = Zeiger1;
     }

     /* Das Element 'str' ist nicht das erste Element der Liste. */
     else {
       Zeiger1 = list;
      
       while (Zeiger1->next != NULL){
         Zeiger2 = Zeiger1->next;
         
         if (strcmp (Zeiger2->str, str) == 0) {
           Zeiger1->next = Zeiger2->next;
           free (Zeiger2);
           goto Ende;
         }
         Zeiger1 = Zeiger2;
       }
     }
   }

   else {
     printf ("Die Liste in Funktion del_Liste ist leer.\n");
     exit (1);
   }
  
   Ende:;
   return (list);
}



/*****************************************************/
/* FUNCTION  : loesch_Baum                           */
/* PARAMETER : Baum *a                               */
/* RETURN    : void                                  */
/* PURPOSE   : Freigeben des Speichers von Baum a.   */ 
/*****************************************************/

void loesch_Baum (Baum *bm)
{ 
   Baum *bm1, *bm2;
    
   if (bm != NULL) {
 
     /* rekursiv freigeben */
     bm1 = bm->child;
     while (bm1 != NULL) {
       bm2 = bm1->brother;
       loesch_Baum (bm1);
       bm1 = bm2;
     }
     
   
     /* Speicher freigeben */
     free (bm->lKlammer);
     bm->lKlammer = NULL;
    
     free (bm->rKlammer);
     bm->rKlammer = NULL;
   
     free (bm->Token); 
     bm->Token = NULL;
   
     bm->father = NULL;
     bm->child = NULL;
     bm->brother = NULL;
 
     free (bm);
   }
  
}




/****************************************************/
/* FUNCTION  : loesch_Terme                         */
/* PARAMETER : Terme **tm                           */
/* RETURN    : void                                 */
/* PURPOSE   : Freigeben des Speichers von Terme tm.*/ 
/****************************************************/

void loesch_Terme (Terme **tm)
{

   Terme *h_tm; 

   if ( *tm != NULL) {

     do {
       h_tm = (*tm)->next;

       free ((*tm)->expression->ATerm);
       free ((*tm)->expression->equal);
       free ((*tm)->expression->term);
       free ((*tm)->expression);
       free (*tm);

       *tm = h_tm;
     } while (*tm != NULL);

   }
}


/*****************************************************/
/* FUNCTION  : print_Baum                            */
/* PARAMETER : Baum *                                */
/* RETURN    : void                                  */
/* PURPOSE   : Ausdrucken eines Baums                */
/*****************************************************/


void print_Baum (Baum *bm)
{   

   /* Ausgabe: lKlammer und Token des Baums */
   if (bm != NULL) {
     printf(" %s%s", bm->lKlammer, bm->Token);   

     /* rekursiv ausdrucken */
     if (bm->child != NULL) 
        print_Baum (bm->child); 

     /* Ausgabe: rKlammer des Baums */ 
     printf("%s ", bm->rKlammer);

     /* rekursiv ausdrucken */ 
     if (bm->brother != NULL)
       print_Baum (bm->brother);
   }
}



/*****************************************************/
/* FUNCTION  : print_Liste                           */
/* PARAMETER : Liste *                               */
/* RETURN    : void                                  */
/* PURPOSE   : Ausdrucken einer Liste                */
/*****************************************************/


void print_Liste (Liste *lst)
{

   printf ("\n");
   while (lst != NULL) {
     printf ("  %s  ", lst->str);
     lst = lst->next;
   }

   printf ("\n");
}



/*****************************************************/
/* FUNCTION  : print_Terme                           */
/* PARAMETER : Terme *                               */
/* RETURN    : void                                  */
/* PURPOSE   : Ausdrucken einer Terme                */
/*****************************************************/


void print_Terme (Terme *tp)
{  
     
   /* Ausgabe: TermDefinition ::= */  
   if (tp != NULL) {
     printf("\n%s %s", tp->expression->ATerm, tp->expression->equal);

     /* Ausgabe: KonzeptDefinition oder RollenDefinition */
     print_Baum (tp->expression->term);
     printf ("\n");
   }
   
   /* rekursiv ausdrucken */   
   if (tp->next) 
     print_Terme(tp->next);

}



/*****************************************************/
/* FUNCTION  : print_Welt                            */
/* PARAMETER : Welt *                                */
/* RETURN    : void                                  */
/* PURPOSE   : Ausdrucken einer Objektwelt           */
/*****************************************************/

void print_Welt (Welt *welt)
{
  
   while (welt != NULL) {

     /* Ausdrucken einer Weltbeschreibung */
     print_Liste (welt->ls);
     
     /* Zeiger auf die naechste Weltbeschreibung */
     welt = welt->next;
   }
}







void win_tewis ( )
{
   

printf ("         -----------------------------------------------------\n\
        |                                                     |\n\
        |                    TEWIS                            |\n\
        |                                                     |\n\
        |     Terminologisches Wissensrepraesentations-       |\n\
        |               und Inferenzsystem                    |\n\
        |                                                     |\n\
        |                                                     |\n\
        |     Dateimanager                                    |\n\
        |       1. Terminologie                               |\n\
        |       2. Objektwelt                                 |\n\
        |                                                     |\n\
        |     Terminologische Inferenz                        |\n\
        |       3. Subsumption (A, B)                         |\n\
        |       4. Klassifikation (A)                         |\n\
        |                                                     |\n\
        |     Hybride terminologische Inferenz                |\n\
        |       5. Abstraktion eines Objektes                 |\n\
        |       6. Most Specific Concepts eines Objektes      |\n\
        |       7. Instanzen eines Konzeptes                  |\n\
        |       8. Ueberpruefung einer Konzeptinstanziierung  |\n\
        |                                                     |\n\
        |       9. Ende                                       |\n\
         -----------------------------------------------------\n");
}



void win_File ( )
{
printf ("         -------------------------------------------------\n\
        |                                                 |\n\
        |   Dateimanager                                  |\n\
        |                                                 |\n\
        |       1. Laden einer existierenden Datei        |\n\
        |                                                 |\n\
        |       2. Erstellen einer neuen Datei            |\n\
        |                                                 |\n\
        |       3. Modifizieren einer existierenden Datei |\n\
        |                                                 |\n\
         -------------------------------------------------\n");
}



void win_sub ( )
{
printf ("         -----------------------------------------------------------\n\
        |                                                           |\n\
        |  Subsumption (A, B)                                       |\n\
        |       ( A, B sind Termbezeichner )                        |\n\
        |                                                           |\n\
        |   1. A, B stammen aus der Terminologie                    |\n\
        |                                                           |\n\
        |   2. A, B werden neu definiert                            |\n\
        |                                                           |\n\
        |   3. A stammt aus der Terminologie, B wird neu definiert  |\n\
        |                                                           |\n\
        |   4. A wird neu definiert, B stammt aus der Terminologie  |\n\
        |                                                           |\n\
         -----------------------------------------------------------\n");
}


void win_class ( )
{
printf ("         --------------------------------------\n\
        |                                      |\n\
        |  Klassifikation (A)                  |\n\
        |     ( A ist Termbezeichner )         |\n\
        |                                      |\n\
        |   1. A stammt aus der Terminologie   |\n\
        |                                      |\n\
        |   2. A wird neu definiert            |\n\
        |                                      |\n\
         --------------------------------------\n");
}



void win_inst ( )
{
printf ("         --------------------------------------\n\
        |                                      |\n\
        |  Instanzen eines Konzeptes C         |\n\
        |                                      |\n\
        |   1. C ist ein Konzeptbezeichner     |\n\
        |                                      |\n\
        |   2. C ist ein Konzeptterm           |\n\
        |                                      |\n\
         --------------------------------------\n");
}





/* Die Funktionen 'sort_and' und 'sort_leer' aendert die Baumgestalt */
/* fuer einen Ausdruck der Form (and ...) oder (androle ...).        */

void sort_and (Baum *bm)
{ 
   Baum *bm1;

   if (bm == NULL)
     return;

   if (bm->child != NULL)
     sort_and (bm->child);
   if (bm->brother != NULL)
     sort_and (bm->brother);
  
   if ((strcmp (bm->Token, "and") == 0 ||
        strcmp (bm->Token, "androle") == 0) &&
        bm->child != NULL &&
        strcmp (bm->child->Token, " ") == 0) {

      bm1 = bm->child;
      bm->child = bm1->child;
      bm->child->father = bm;
      bm->child->brother->father = bm;

      free (bm1->lKlammer);
      free (bm1->rKlammer);
      free (bm1->Token);
      free (bm1);
   }
}



void sort_leer (Baum *bm)
{ 
   Baum *ptr = NULL, *ptr1 = NULL;
  

   if (bm == NULL)
     return;
  
   if (bm->child != NULL)
     sort_leer (bm->child);
   if (bm->brother != NULL)
     sort_leer (bm->brother);
  
   if (strcmp (bm->Token, "and") == 0 ||
       strcmp (bm->Token, "androle") == 0) {
       ptr = bm->child;
       
       if (ptr != NULL) {
         ptr1 = ptr->brother;
       
         while (ptr1 != NULL) {
           if (strcmp (ptr1->Token, " ") == 0) {
             ptr->brother = ptr1->child;

             free (ptr1->lKlammer);
             free (ptr1->rKlammer);
             free (ptr1->Token);
             free (ptr1);

             ptr->brother->father = ptr->father;
             ptr->brother->brother->father = ptr->father;
           }
           ptr = ptr->brother;
           ptr1 = ptr->brother;
        }
     }
   }
}


void sort1 (Terme *terme)
{
   if (terme != NULL) {

     if (terme->expression != NULL && terme->expression->term != NULL)
       sort_and (terme->expression->term);

     if (terme->next != NULL) 
       sort1 (terme->next);
   }
}



void sort2 (Terme *terme)
{

   if (terme != NULL) {

     if (terme->expression != NULL && terme->expression->term != NULL)
       sort_leer (terme->expression->term);
   
     if (terme->next != NULL) 
       sort2 (terme->next);
   }
}




