#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree.h"
#include "menue.h"

extern enum BOOL Warnung, c;
extern O_Welt *W_Abst;
extern Welt *SAF, *W, *MSC;
extern Terme *T, *T1, *ITF;
extern Welt *a_Sub, *sub, *Sub;


int yyparse ();
FILE *yyin;


/*****************************************************/
/* FUNCTION  : abst                                  */
/* PARAMETER : void                                  */
/* RETURN    : void                                  */
/* PURPOSE   : Menufunktion fuer die Bestimmung der  */
/*             terminologischen Abstraktion eines    */
/*             Objektes.                             */
/*****************************************************/

void abst ( )
{

   char str[36], wahl[4];
   O_Welt *OW;

   if (SAF != NULL) {
     if (Warnung == TRUE) {
     I:  printf ("Die Terminologie ist geaendert. \nWollen Sie die \
terminologische Abstraction des Objektes auf der neuen Terminologie \
bestimmen ? 'ja' oder 'nein' ?\n"); 
     scanf("%s", wahl);
     getchar ( );

     if (strcmp (wahl, "ja") == 0)
       c = TRUE;
     else
       if (strcmp (wahl, "nein") == 0)
         ;
       else {
         printf ("Ihre Eingabe wird nicht akzptiert. Es soll 'ja' \
oder 'nein' sein.\n");
         goto I;
        }
     }  
  
     if (Warnung == TRUE && c == TRUE) {
       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }
 
     printf ("Die terminologische Abstraktion eines Objektes wird bestimmt.\n");
     printf ("Bitte den Name des Objektes eingeben:\n");
     scanf ("%s", str);
     getchar ( );

     /* W_Abst: globale Variable. W_Abst enthaelt die */
     /* Abstraction aller Objekte in der Objektwelt.  */
     OW = W_Abst;
     while (OW != NULL) {
       if (strcmp (str, OW->name) != 0)
         OW = OW->next;
       else {
         printf ("Die Abstraction vom Objekt %s ist: \n\n", OW->name);
         print_Baum (OW->abstract);
         printf ("\n");
         break;
       }
     }

 
     if (OW == NULL)
       printf ("Das Objekt %s ist nicht in der Objektwelt definiert.\n", str);
   }

   else
     printf ("Die Datei fuer die Objektwelt existiert in TEWIS nicht. \n");
}




/*****************************************************/
/* FUNCTION  : w_check                               */
/* PARAMETER : Welt *W, Terme *T                     */
/* RETURN    : void                                  */
/* PURPOSE   : Menufunktion fuer die Ueberpruefung,  */
/*             ob ein Objekt die Instanz eines       */
/*             Konzepts ist.                         */
/*****************************************************/


void w_check (Welt *W, Terme *T )
{
   int i = 0;
   FILE *fp;
   char O[36], C[36], wahl[4];
   
   if (SAF != NULL) {
      if (Warnung == TRUE) {
       I: printf ("Die Terminologie ist geaendert. \nWollen Sie die \
Konzeptinstanziierung auf der neuen Terminologie ueberpruefen ? \
'ja' oder 'nein' ?\n"); 
       scanf("%s", wahl);
       getchar ( );

       if (strcmp (wahl, "ja") == 0)
         c = TRUE;
       else
         if (strcmp (wahl, "nein") == 0)
         ;
         else {
           printf ("Ihre Eingabe wird nicht akzptiert. Es soll 'ja' \
oder 'nein' sein.\n");
           goto I;
         }
     }  
  
     if (Warnung == TRUE && c == TRUE) {

       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }

     printf ("Hier wird ueberprueft, ob ein Objekt O eine Instanz eines Konzeptes C ist.\n");
     printf ("Bitte den Objektbezeichner O eingeben: \n");
     scanf ("%s", O);
     getchar ( );

     printf ("Bitte den Konzeptbezeichner C eingeben: \n");
     scanf ("%s", C);
        
   
     if (check (O, C, W, T) == 1 )
       printf ("Das Objekt '%s' ist in dem Konzept '%s' enthalten.\n", O, C);
     else
       printf ("Das Objekt '%s' ist in dem Konzept '%s' nicht enthalten.\n",O, C);
   }
   else
     printf ("Die Datei fuer die Objektwelt existiert in TEWIS nicht.\n");
}




/*****************************************************/
/* FUNCTION  : class                                 */
/* PARAMETER : Terme *tm                             */
/* RETURN    : int                                   */
/* PURPOSE   : Klassifikation eines Terms in der     */
/*             Komzept- oder Rollentaxonomie der     */
/*             Terminologie tm.                      */
/*****************************************************/


int class(Terme *tm)
{
   int i, j = 0;
   char str[36], satz[256];
   Welt *s, *S;
   Liste *lst1, *lst2;
   Terme *tm1, *ptr, *ptr1;
   FILE *fp;

   if (tm == NULL) {
     printf ("Die Terminologiedatei existiert nicht.\n");
     return (2);
   }
   
   win_class ( );
   printf ("\nKlassifikation eines Terms in der Taxonomie.\n");    
   printf ("Bitte Ihre Wahl eingeben:\n");
   scanf ("%d", &i);
   getchar ( );
   

   if (i == 1) {

      /* Die Termdefinition mit dem Termbezeichner A ist definiert. */ 
      printf ("Den Termbezeichner von A eingeben: \n");
      scanf ("%s", str);
      getchar ( );

      /* sucht die 'sub_liste' und 'Sub_Liste' von */
      /* A in den globalen Variablen sub und Sub.  */

      s = sub;
      while (s != NULL) {
        if (strcmp (s->ls->str, str) != 0)
          s = s->next;
        else
          break;
      }

      if (s == NULL) {
        printf ("Der Termbezeichner %s ist in der Terminologie nicht \
definiert.\n", str);
        return (2);
      }

      printf ("\nimsub ( %s ): ", s->ls->str);
      print_Liste (s->ls->next);

      S = Sub;
      while (S != NULL) {
        if (strcmp (S->ls->str, str) != 0)
          S = S->next;
        else
          break;
      }

      printf ("\nimSub ( %s ): ", S->ls->str);
      print_Liste (S->ls->next);       
     
    }
    else
      if (i == 2) {

         /* Eine neue Termdefinition wird definiert. */
         printf ("Bitte die Termdefinition eingeben:\n");

         fp = fopen ("tmpfile", "w+");
         if (fp == NULL) {
            printf ("tmpfile in Sub1 kann nicht zum Schreiben geoeffnet \
werden.\n");
            exit (1);
         } 

         do {
           gets(satz);
           fprintf (fp, "%s", satz);
         } while(satz[strlen(satz) - 1] == ';' );
         fclose (fp);

         /* lexkalisch uns syntaktisch Analysis */
         /* der neuen Termdefinition.           */
         yyin = fopen ("tmpfile", "r");
         yyparse();
 
         sort1 (ITF);
         sort2 (ITF);
 
 
         /* Die neue Termdefinition am Ende der Terminologie anhaengen. */ 
         tm1 = copy_Terme (tm);
         ptr = tm1;
         while (ptr->next != NULL) {
           ptr = ptr->next;
           j++;
	 }

         ptr->next = Node_Terme ( );
         ptr->next = ITF;
         ptr = ptr->next;  
    
         form_Terme (tm1);
         all_exp_Terme (tm1);
         norm_Terme (tm1);
        
         ptr = tm1;
         while (j >= 0) {
           ptr = ptr->next;
           j--;
	 }

         ptr1 = tm1;

         /* prueft nach, ob die neu definierte Termidefinition */
         /* schon in der Terminologie vorhanden ist.           */
         while (ptr1 != ptr) {
           if (comp(ptr->expression->term, ptr1->expression->term) == 1 &&
               comp(ptr1->expression->term, ptr->expression->term) == 1 )
             break;
           else
             ptr1 = ptr1->next;
	 }

         /* Die neu definierte Termdefinition  */
         /* exisiert schon in der Terminologie */ 

         if (ptr1 != ptr) {

           /* sucht die 'sub_liste' und 'Sub_Liste' von diesem */
           /* Term in den globalen Variablen sub und Sub.     */
           s = sub;
           while (s != NULL) {
             if (strcmp (s->ls->str, ptr1->expression->ATerm) != 0)
               s = s->next;
             else
               break;
           }

           S = Sub;
           while (S != NULL) {
             if (strcmp (S->ls->str, ptr1->expression->ATerm) != 0)
               S = S->next;
             else
               break;
           }

           printf ("\nimsub ( %s ):\n ", ptr->expression->ATerm);
           print_Liste (s->ls->next);
          
           printf ("\nimSub ( %s ): \n", ptr->expression->ATerm);
           print_Liste (S->ls->next);
          
	 }


         else {
           /* berechnet die 'Sub_Liste' und 'sub_Liste' */
           /* fuer die neu definierten Term.            */
           lst1 = imsub (ptr->expression->term, tm1);
           lst2 = imSub (ptr->expression->term, tm1);
   
           printf ("\nimsub ( %s ): ", lst1->str);
           print_Liste (lst1->next);
   
           printf ("\nimSub ( %s ): ", lst2->str);
           print_Liste (lst2->next);
	 }

         loesch_Terme (&tm1);

         /* Die neue Termdefinition, falls der Benutzer  */
         /* sich wunscht, in der Terminologie angehaengt.*/ 
         tmp_file ( );
   
       }
      else {
        printf ("Ihre Wahl ist nicht erlaubt.\n");
        return (0);
      }
    
  ende:;

  return (1);
}


/*****************************************************/
/* FUNCTION  : w_Inst                                */
/* PARAMETER : Welt *W, Terme *T                     */
/* RETURN    : Liste *                               */
/* PURPOSE   : Menufunktion fuer die Instanzen eines */
/*             Konzepts.                             */
/*             (Eingabe: Konzeptbezeichner oder      */
/*             Konzeptterm ).                        */ 
/*****************************************************/

Liste *w_Inst (Welt *W, Terme *T)
{
   int k, i;
   char satz[256], Cbez[36], wahl[4];
   Liste  *ret, *lst, *lst1, *lst2, *act_lst1, *act_lst2, *ptr;
   FILE *stream;
   Terme *tm, *act_tm, *h_tm;

   
   if (SAF != NULL) { 
     if (Warnung == TRUE) {
       I: printf ("Die Terminologie ist geaendert. \nWollen Sie die \
Instanzen des Objektes auf der neuen Terminologie berechnen ? \
'ja' oder 'nein' ?\n"); 
       scanf("%s", wahl);
       getchar ( );

       if (strcmp (wahl, "ja") == 0)
         c = TRUE;
       else
         if (strcmp (wahl, "nein") == 0)
         ;
         else {
           printf ("Ihre Eingabe wird nicht akzeptiert. Es soll 'ja' \
oder 'nein' sein.\n");
           goto I;
         }
     }  
  
     if (Warnung == TRUE && c == TRUE) {
       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }

     printf ("Die Instanzen eines Konzeptes werden berechnet.\n");
     win_inst ( );
     printf ("Bitte Ihre Wahl eingeben:\n");
     scanf ("%d", &i);
     getchar ( );

     ret = NULL;
 
     /* Die Instanzen eines Konzepts (Eingabe: Konzeptbezeichner)  */
     /* werden berechnet.*/
     if ( i == 1 ) {
       printf ("Bitte den Konzeptbezeichner eingeben\n");
       scanf ("%s", Cbez);
       getchar ( );
    
       h_tm = T;
       while (h_tm != NULL) {
         if (strcmp (h_tm->expression->ATerm, Cbez) != 0)
           h_tm = h_tm->next;
         else
           break;
       }

       if (h_tm == NULL) {
         printf ("Der Termbezeichner %s ist in der Terminologie nicht \
definiert.\n", Cbez);
         return NULL;
       }

       ret = Inst (Cbez, W, T);
     }
   
     /* Die Instanzen eines Konzepts (Eingabe: Konzeptterm) */
     /* werden berechnet.*/
     else {
       if ( i == 2 ) {

         /* Konzeptterm eingeben. Die neu TermDefinition: */
         /* neu_Cbez :=C Konzeptterm wird als ein File    */
         /* unter dem Name "tmpfile" gespeichert.         */

         stream = fopen ("tmpfile", "w+");
         fprintf (stream, "%s %s", "neu_Cbez", ":=C"); 
         printf ("Bitte Konzeptterm eingeben: \n");
         gets(satz);
         fprintf (stream, "%s", satz);
         fclose(stream);
      
         /* lexikalisch und syntaktisch Analysis des Files 'tmpfile'. */
         yyin = fopen("tmpfile", "r");   
         if (yyin == NULL) {      
           printf("Datei tmpfile in w_Inst kann nicht geoffenet werden.\n");
           exit(1);  
         };

         yyparse();

         sort1 (ITF);
         sort2 (ITF); 

         /* Kopieren der alten Terminologie T */
         tm = copy_Terme (T);

         /* "tmpfile" an T anhaengen */
         act_tm = tm;
         while (act_tm->next != NULL)
           act_tm = act_tm->next;
         act_tm->next = Node_Terme ( );
         act_tm->next = ITF;
         act_tm = act_tm->next;
         act_tm->next = NULL;
  
         form_Terme (tm);
         all_exp_Terme (tm);
         norm_Terme (tm);

         act_tm = tm;
         while (strcmp (act_tm->expression->ATerm, "neu_Cbez") != 0)
           act_tm = act_tm->next;

         /* prueft nach, ob der gegebene Konzeptterm K */
         /* in der Terminologie T definiert ist.  */
         h_tm = tm;
         while (h_tm != act_tm) {
           if (vergleich (h_tm->expression->term, 
                          act_tm->expression->term) == -1)
             h_tm = h_tm->next;
           else
             break;
         } 

         /* K ist in T definiert. */
         if (h_tm != act_tm)
            ret = Inst (h_tm->expression->ATerm, W, T);
  
         /* K ist nicht in T definiert. */
         else {
           /* lst enthaelt alle Termbezeichner, deren */
           /* definierden Terme den eingegebene       */
           /* Konzeptterm unmittelbar subsummieren.   */
           lst = imSub (act_tm->expression->term, tm);
                
           lst = lst->next;

           /* Die gemeinsame Elemente von Instanzen  */
           /* jedes Konzepts aus lst wird ausgesucht.*/ 
           if (lst != NULL) {
             lst1 = NULL;
             lst1 = Inst(lst->str, W, T);
        
             if (lst1 != NULL) {  
               lst = lst->next;
                   
               while (lst != NULL) {  
                 lst2 = Inst(lst->str, W, T);
               
                 if (lst2 != NULL) {  
                   act_lst1 = lst1;
      
                   /* prueft nach, ob es ein gemeinsames */
                   /* Element von lst1 und lst2 ist.     */
                   while (act_lst1 != NULL) {
                      k = 0;
                      act_lst2 = lst2;
                      while (act_lst2 != NULL) {
                        if (strcmp (act_lst1->str, act_lst2->str) == 0) {
                          k = 1;
                          break;
                        }
                        else
                          act_lst2 = act_lst2->next;
                      }  

                      /* kein gemeinsames Element. */
                      /* entfernet das Element aus lst1 */
                      if (k == 0) {
                        if (act_lst1 == lst1) {
                          ptr = lst1->next;
                          free (lst1);
                          lst1 = ptr;
                          act_lst1 = lst1;
	                }
                        else {
                          ptr = lst1;
                          while (ptr->next != act_lst1)
                            ptr = ptr->next;
                          ptr->next = act_lst1->next;
                          free (act_lst1);
                          act_lst1 = ptr->next;
	                }
	              }
                      else
                        act_lst1 = act_lst1->next;
		    }
	         }

                 /* Die Menge der Instanzen eines     */
                 /* Konzeptbezeichner in lst ist leer.*/
                 else {
                   lst1 = NULL; 
                   printf ("Der definerende Konzeptterm hat keine Instanz.\n");
                   goto RET;
	         }

                 lst = lst->next;
	       }
	     }

             RET: ret = lst1;
           }
 
           /* imSub (Konzeptterm) = NULL */
           else {
             ret = NULL;
             printf ("Der definerende Konzeptterm hat keine Instanz.\n");
	   }
         }

       }
       else {
         printf ("Ihr Wahl ist nicht erlaubt.\n");
         return NULL;
       }
     }

     if (ret == NULL)
       printf ("\nDieser Konzeptterm hat keine Instanz.\n");
     else 
       print_Liste (ret);
   }
   else {
     printf ("Die Datei fuer die Objektwelt existiert in TEWIS nicht.\n");
     return NULL;
   }

   return (ret);
}




/*****************************************************/
/* FUNCTION  : MSC_Welt                              */
/* PARAMETER : void                                  */
/* RETURN    : void                                  */
/* PURPOSE   : Menufunktion fuer MSC eines Objekts.  */
/*****************************************************/

void w_MSC ( )
{
   char str[36], wahl[4];
   Welt *ptr;

   if (SAF != NULL) {
     if (Warnung == TRUE) {
       I: printf ("Die Terminologie ist geaendert. \nWollen Sie die \
Most Specific Concepts des Objektes auf der neuen Terminologie \
berechnen ? 'ja' oder 'nein' ?\n"); 
       scanf("%s", wahl);
       getchar ( );

       if (strcmp (wahl, "ja") == 0)
         c = TRUE;
       else
         if (strcmp (wahl, "nein") == 0)
         ;
         else {
           printf ("Ihre Eingabe wird nicht akzeptiert. Es soll 'ja' \
oder 'nein' sein.\n");
           goto I;
         }
     }  
  
     if (Warnung == TRUE && c == TRUE) {
       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }

     printf ("Most Specific Concepts eines Objektes werden berechnet.\n");
     printf ("Bitte den Namen des Objektes eingeben:\n");
     scanf ("%s", str);
     getchar ( );

     ptr = MSC;
   
     while (ptr != NULL) {
       if (strcmp (str, ptr->ls->str) != 0)
         ptr = ptr->next;
       else {
         printf ("\nDas MSC vom Objekt %s ist: \n", ptr->ls->str);
         print_Liste (ptr->ls->next);
         break;
       }
     }

     Ende:;
     if (ptr == NULL)
       printf ("\nDas Objekt %s ist nicht in der Objektwelt definiert.\n", str);
   }
   else
     printf ("Die Datei fuer die Objektwelt existiert in TEWIS nicht. \n");     

}


/*****************************************************/
/* FUNCTION  : Sub_Term                              */
/* PARAMETER : char *a, char *b, Terme *tm           */
/* RETURN    : void                                  */
/* PURPOSE   : Hilfsfunktion fuer die Funktion       */
/*             Menefunktion 'Subsumption'.           */
/*             Es wird nachgeprueft, ob der Term mit */
/*             dem Termbezeichner a den Term mit dem */
/*             Termbezeichner b in der Terminologie  */
/*             tm subsummiert.                       */
/*****************************************************/

int Sub_Term (char *str1, char *str2, Terme *tm)
{
   Terme *ptr1, *ptr2;

   /* Suche den erste Termbezeichner in der Terminologie */
   ptr1 = tm;

   while (ptr1 != NULL) {
     if (strcmp (ptr1->expression->ATerm, str1) != 0)
       ptr1 = ptr1->next;

     else {
       /* Suche den zweite Termbezeichner in der Terminologie */
       ptr2 = tm;

       while (ptr2 != NULL) {
         if (strcmp (ptr2->expression->ATerm, str2) != 0)
           ptr2 = ptr2->next;
         else {
           /* Beide Termbezeichner sind in */
           /* der Terminologie definiert.  */

           if (comp (ptr1->expression->term, 
                     ptr2->expression->term) == 1) {

             if (strcmp (ptr1->expression->equal, ":=C") == 0)
                 printf ("\nDas Konzept %s subsummiert das Konzept \
%s.\n", str1, str2);
             else              
               printf ("\nDie Rolle %s subsummiert die Rolle %s.\n",\
str1, str2);
	   }

           else { 

             if (strcmp (ptr1->expression->equal, ":=C") == 0)
               printf ("\nDas Konzept %s subsummiert nicht das Konzept \
%s.\n", str1, str2);
             else              
               printf ("\nDie Rolle %s subsummiert nicht die Rolle \
%s.\n", str1, str2);
	   }

           goto ende;
         }
       }

       if (ptr2 == NULL) {
         printf ("\n %s ist nicht in der Terminologie definiert.\n", str2);
         return (2);
       }
     }
   }
    
   if (ptr1 == NULL) {
        printf ("\n %s ist nicht in der Terminologie definiert.\n", str1);
        return (2);      
   }

   ende:;
   return (1);
}


/*****************************************************/
/* FUNCTION  : Sub1                                  */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : Hilfsfunktion fuer die Funktion       */
/*             'Subsumption'.                        */
/*             Sub_Term (a, b, tm) wird in Sub1 an-  */
/*             wendet, wenn die Termidefinitionen    */
/*             (mit dem Bezeichner a, b) nicht in der*/
/*             Terminologie existieren, sondern vom  */
/*             Benutzer neue definiert werden.       */
/*****************************************************/

void Sub1 (Terme *tm)
{
    char satz[256]; 
    FILE *fp;
    Terme *tm1, *ptr;

    printf ("Bitte zwei Termdefinitionen eingeben:\n");


    /* Die Termdefinitionen eingeben und die */
    /* Datei im File 'tmpfile' speichern.    */

    fp = fopen ("tmpfile", "w+");
    if (fp == NULL) {
      printf ("tmpfile in Sub1 kann nicht zum Schreiben geoeffnet werden.\n");
      exit (1);
    } 

    do {
      gets(satz);
      fprintf (fp, "%s", satz);
    } while(satz[strlen(satz) - 1] == ';' );
    fclose (fp);

    /* Die neue Termdefinitionen werden vom lex und yacc geprueft */
    yyin = fopen ("tmpfile", "r");
    yyparse();
    
    sort1 (ITF);
    sort2 (ITF);
 
 
    /* Die neue Termdefinitionen am Ende der Terminologie anhaengen. */ 
    tm1 = copy_Terme (tm);
    ptr = tm1;

    while (ptr->next != NULL) 
      ptr = ptr->next;


    ptr->next = Node_Terme ( );
    ptr->next = ITF;
    ptr = ptr->next;  
    
    form_Terme (tm1);
    all_exp_Terme (tm1);
    norm_Terme (tm1);
    
    /* Subsumptionstest */
    Sub_Term (ptr->expression->ATerm, ptr->next->expression->ATerm, tm1);

    loesch_Terme (&tm1);
}       



/*****************************************************/
/* FUNCTION  : Sub2                                  */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : Hilfsfunktion fuer die Funktion       */
/*             'Subsumption'.                        */
/*             Sub_Term (a, b, tm) wird in Sub2 an-  */
/*             wendet, wenn die Termidefinition      */
/*             (mit dem Bezeichner a) nicht in der   */
/*             Terminologie tm existiert, sondern vom*/
/*             Benutzer neue definiert wird und die  */
/*             Termdefinition mit dem Termbezeichner */
/*             b in tm existiert.                    */
/*****************************************************/


void Sub2 (Terme *tm)
{
    char satz[256], str[36]; 
    FILE *fp;
    Terme *tm1, *ptr;

    printf ("\nDen Termbezeichner von A eingeben: \n");
    scanf ("%s", str);
    getchar ( );

    printf ("Die Termdefinition  von B eingeben:\n");

    /* Die Termdefinition eingeben und die */
    /* Datei im File 'tmpfile' speichern.  */
    fp = fopen ("tmpfile", "w+");
    if (fp == NULL) {
      printf ("tmpfile in Sub2 kann nicht zum Schreiben geoeffnet werden.\n");
      exit (1);
    } 

    do {
      gets(satz);
      fprintf (fp, "%s", satz);
    } while(satz[strlen(satz) - 1] == ';' );
    fclose (fp);

    /* Die neue Termdefinition wird vom lex und yacc geprueft */
    yyin = fopen ("tmpfile", "r");
    yyparse();
    

    sort1 (ITF);
    sort2 (ITF);

    /* Die neue Termdefinitionen am Ende der Terminologie anhaengen. */  
    tm1 = copy_Terme (tm);
    ptr = tm1;
    while (ptr->next != NULL) 
      ptr = ptr->next;


    ptr->next = Node_Terme ( );
    ptr->next = ITF;
    ptr = ptr->next;  
    
    form_Terme (tm1);
    all_exp_Terme (tm1);
    norm_Terme (tm1);
       

    /* Subsumptionstest */    
    Sub_Term (str, ptr->expression->ATerm, tm1);

    loesch_Terme (&tm1);
}       


/*****************************************************/
/* FUNCTION  : Sub3                                  */
/* PARAMETER : Terme *tm                             */
/* RETURN    : void                                  */
/* PURPOSE   : Hilfsfunktion fuer die Funktion       */
/*             'Subsumption'.                        */
/*             Sub_Term (a, b, tm) wird in Sub3 an-  */
/*             gewendet, wenn die Termidefinition    */
/*             (mit dem Bezeichner b) nicht in der   */
/*             Terminologie tm existiert, sondern vom*/
/*             Benutzer neue definiert wird und die  */
/*             Termdefinition mit dem Termbezeichner */
/*             a in tm existiert.                    */
/*****************************************************/

void Sub3 (Terme *tm)
{
    char satz[256], str[36]; 
    FILE *fp;
    Terme *tm1, *ptr;


    printf ("Die Termdefinition  von A eingeben:\n");

    /* Die Termdefinition eingeben und die */
    /* Datei im File 'tmpfile' speichern.  */
    fp = fopen ("tmpfile", "w+");
    if (fp == NULL) {
      printf ("tmpfile in Sub2 kann nicht zum Schreiben geoeffnet werden.\n");
      exit (1);
    } 

    do {
      gets(satz);
      fprintf (fp, "%s", satz);
    } while(satz[strlen(satz) - 1] == ';' );
    fclose (fp);

    /* Die neue Termdefinition wird vom lex und yacc geprueft */
    yyin = fopen ("tmpfile", "r");
    yyparse();

    sort1 (ITF);
    sort2 (ITF);

    /* Die neue Termdefinitionen am Ende der Terminologie anhaengen. */ 
    tm1 = copy_Terme (tm);
    ptr = tm1;
    while (ptr->next != NULL)
      ptr = ptr->next;
    ptr->next = Node_Terme ( );
    ptr->next = ITF;
    ptr = ptr->next;  
    
    form_Terme (tm1);
    all_exp_Terme (tm1);
    norm_Terme (tm1);
 
 
    printf ("\nDen Termbezeichner von B eingeben: \n");
    scanf ("%s", str);
    getchar ( );

    /* Subsumptionstest */    
    Sub_Term (ptr->expression->ATerm, str, tm1);

    loesch_Terme (&tm1);
}       



 



/*****************************************************/
/* FUNCTION  : Subsumption                           */
/* PARAMETER : Terme *tm                             */
/* RETURN    : int                                   */
/* PURPOSE   : Menufunktion fuer Subsumption.        */
/*****************************************************/


int Subsumption (Terme *tm) {
 
   char str1[36], str2[36];
   int i;    

   if (tm == NULL) {
     printf ("Die Terminologiedatei existiert noch nicht.\n");
     exit (1);
   }

   win_sub ( );
   printf ("Ueberpruefung der Subsumptionsbeziehung zweier Terme A und B.\n"); 
   printf ("Bitte Ihre Wahl eingeben:\n");   
   scanf ("%d", &i);
   getchar ( );

   if (i == 1) {
      printf ("Den Termbezeichner von A eingeben: \n");
      scanf ("%s", str1);

      printf ("Den Termbezeichner von B eingeben: \n");
      scanf ("%s", str2);
      getchar ( );

      Sub_Term (str1, str2, tm);
   }
   else
     if (i == 2) { 
       Sub1 (tm);
       tmp_file ( );
     }
     else
       if (i == 3) {
         Sub2 (tm);
         tmp_file ( );
       }
       else
         if (i == 4) {
           Sub3 (tm);
           tmp_file ( );
         }
         else {
           printf ("Ihre Wahl ist nicht erlaubt.\n");
           return (0);
	 }
   
   return (1);
}




