#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree.h"
#include "menue.h"

extern enum BOOL Warnung, c;
extern O_Welt *W_Abst;
extern Welt *SAF, *W, *MSC;
extern Terme *T, *T1, *ITF;
extern Welt *a_Sub, *sub, *Sub;


int yyparse ();
FILE *yyin;




/*****************************************************/
/* FUNCTION  : w_check                               */
/* PARAMETER : Welt *W, Terme *T                     */
/* RETURN    : void                                  */
/* PURPOSE   : Menufunktion fuer die Ueberpruefung,  */
/*             ob ein Objekt die Instanz eines       */
/*             Konzepts ist.                         */
/*****************************************************/


void w_check (Welt *W, Terme *T )
{
   int i = 0;
   FILE *fp;
   char O[36], C[36], wahl[4];
   
   if (SAF != NULL) {
      if (Warnung == TRUE) {
       I: printf ("Die Grungterminologie ist geaendert. \nWollen Sie die \
Konzeptinstnziierun auf der neuen Grundterminologie ueberpruefen ? \
'ja' oder 'nein' ?\n"); 
       scanf("%s", wahl);
       getchar ( );

       if (strcmp (wahl, "ja") == 0)
         c = TRUE;
       else
         if (strcmp (wahl, "nein") == 0)
         ;
         else {
           printf ("Ihre Eingabe wird nicht akzptiert. Es soll 'ja' \
oder 'nein' sein.\n");
           goto I;
         }
     }  
  
     if (Warnung == TRUE && c == TRUE) {

       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }

     printf ("Hier wird ueberpruft, ob ein Objekt eine Instanz eines Konzepts ist.\n");
     printf ("Bitte den Objektbezeichner O eingeben: \n");
     scanf ("%s", O);
     getchar ( );

     printf ("Bitte den Konzeptbezeichner C eingeben: \n");
     scanf ("%s", C);
        
   
     if (check (O, C, W, T) == 1 )
       printf ("Das Objekt '%s' ist in dem Konzept '%s' enthalten.\n", O, C);
     else
       printf ("Das Objekt '%s' ist in dem Konzept '%s' nicht enthalten.\n",O, C);
   }
   else
     printf ("Das File fuer die Objektwelt exisitiert in TEWIS nicht.\n");
}


/*****************************************************/
/* FUNCTION  : w_Inst                                */
/* PARAMETER : Welt *W, Terme *T                     */
/* RETURN    : Liste *                               */
/* PURPOSE   : Menufunktion fuer die Instanzen eines */
/*             Konzepts.                             */
/*             (Eingabe: Konzeptbezeichner oder      */
/*             Konzeptterm ).                        */ 
/*****************************************************/

Liste *w_Inst (Welt *W, Terme *T)
{
   int k, i;
   char satz[256], Cbez[36], wahl[4];
   Liste  *ret, *lst, *lst1, *lst2, *act_lst1, *act_lst2, *ptr;
   FILE *stream;
   Terme *tm, *act_tm, *h_tm;

   
   if (SAF != NULL) { 
     if (Warnung == TRUE) {
       I: printf ("Die Grungterminologie ist geaendert. \nWollen Sie die \
Instanzen des Objekts auf der neuen Grundterminologie berechnen ? \
'ja' oder 'nein' ?\n"); 
       scanf("%s", wahl);
       getchar ( );

       if (strcmp (wahl, "ja") == 0)
         c = TRUE;
       else
         if (strcmp (wahl, "nein") == 0)
         ;
         else {
           printf ("Ihre Eingabe wird nicht akzptiert. Es soll 'ja' \
oder 'nein' sein.\n");
           goto I;
         }
     }  
  
     if (Warnung == TRUE && c == TRUE) {
       /* Propagation */
       termprop (W, T1);
  
       /* berechnet die globale Variablen */
       W_Abst = abstraction (W, T1);
       MSC = MSC_Welt (W, T);
   
       Warnung = FALSE;
       c = FALSE;
     }

     printf ("Die Instanzen eines Konzepts wird berechnet.\n");
     win_inst ( );
     printf ("Bitte Ihre Wahl eingeben:\n");
     scanf ("%d", &i);
     getchar ( );

     ret = NULL;
 
     /* Die Instanzen eines Konzepts (Eingabe: Konzeptbezeichner)  */
     /* werden berechnet.*/
     if ( i == 1 ) {
       printf ("Bitte den Konzeptbezeichner eingeben\n");
       scanf ("%s", Cbez);
       getchar ( );
    
       h_tm = T;
       while (h_tm != NULL) {
         if (strcmp (h_tm->expression->ATerm, Cbez) != 0)
           h_tm = h_tm->next;
         else
           break;
       }

       if (h_tm == NULL) {
         printf ("Der Termbezeichner %s ist in der Terminologie nicht \
definiert.\n", Cbez);
         return NULL;
       }

       ret = Inst (Cbez, W, T);
     }
   
     /* Die Instanzen eines Konzepts (Eingabe: Konzeptterm) */
     /* werden berechnet.*/
     else {
       if ( i == 2 ) {

         /* Konzeptterm eingeben. Die neu TermDefinition: */
         /* neu_Cbez :=C Konzeptterm wird als ein File    */
         /* unter dem Name "tmpfile" gespeichert.         */

         stream = fopen ("tmpfile", "w+");
         fprintf (stream, "%s %s", "neu_Cbez", ":=C"); 
         printf ("Bitte Konzeptterm eingeben: \n");
         gets(satz);
         fprintf (stream, "%s", satz);
         fclose(stream);
      
         /* lexikalisch und syntaktisch Analysis des Files 'tmpfile'. */
         yyin = fopen("tmpfile", "r");   
         if (yyin == NULL) {      
           printf("Datei tmpfile in w_Inst kann nicht geoffenet werden.\n");
           exit(1);  
         };

         yyparse();

         sort1 (ITF);
         sort2 (ITF); 

         /* Kopieren der alten Terminologie T */
         tm = copy_Terme (T);

         /* "tmpfile" an T anhaengen */
         act_tm = tm;
         while (act_tm->next != NULL)
           act_tm = act_tm->next;
         act_tm->next = Node_Terme ( );
         act_tm->next = ITF;
         act_tm = act_tm->next;
         act_tm->next = NULL;
  
         form_Terme (tm);
         all_exp_Terme (tm);
         norm_Terme (tm);

         act_tm = tm;
         while (strcmp (act_tm->expression->ATerm, "neu_Cbez") != 0)
           act_tm = act_tm->next;

         /* prueft nach, ob der gegebene Konzeptterm K */
         /* in der Terminologie T definiert ist.  */
         h_tm = tm;
         while (h_tm != act_tm) {
           if (vergleich (h_tm->expression->term, 
                          act_tm->expression->term) == -1)
             h_tm = h_tm->next;
           else
             break;
         } 

         /* K ist in T definiert. */
         if (h_tm != act_tm)
            ret = Inst (h_tm->expression->ATerm, W, T);
  
         /* K ist nicht in T definiert. */
         else {
           /* lst enthaelt alle Termbezeichner, deren */
           /* definierden Terme den eingegebene       */
           /* Konzeptterm unmittelbar subsummieren.   */
           lst = imSub (act_tm->expression->term, tm);
                
           lst = lst->next;

           /* Die gemeinsame Elemente von Instanzen  */
           /* jedes Konzepts aus lst wird ausgesucht.*/ 
           if (lst != NULL) {
             lst1 = NULL;
             lst1 = Inst(lst->str, W, T);
        
             if (lst1 != NULL) {  
               lst = lst->next;
                   
               while (lst != NULL) {  
                 lst2 = Inst(lst->str, W, T);
               
                 if (lst2 != NULL) {  
                   act_lst1 = lst1;
      
                   /* prueft nach, ob es ein gemeinsames */
                   /* Element von lst1 und lst2 ist.     */
                   while (act_lst1 != NULL) {
                      k = 0;
                      act_lst2 = lst2;
                      while (act_lst2 != NULL) {
                        if (strcmp (act_lst1->str, act_lst2->str) == 0) {
                          k = 1;
                          break;
                        }
                        else
                          act_lst2 = act_lst2->next;
                      }  

                      /* kein gemeinsames Element. */
                      /* entfernet das Element aus lst1 */
                      if (k == 0) {
                        if (act_lst1 == lst1) {
                          ptr = lst1->next;
                          free (lst1);
                          lst1 = ptr;
                          act_lst1 = lst1;
	                }
                        else {
                          ptr = lst1;
                          while (ptr->next != act_lst1)
                            ptr = ptr->next;
                          ptr->next = act_lst1->next;
                          free (act_lst1);
                          act_lst1 = ptr->next;
	                }
	              }
                      else
                        act_lst1 = act_lst1->next;
		    }
	         }

                 /* Die Menge der Instanzen eines     */
                 /* Konzeptbezeichner in lst ist leer.*/
                 else {
                   lst1 = NULL; 
                   printf ("Der definerende Konzeptterm hat keine Instanz.\n");
                   goto RET;
	         }

                 lst = lst->next;
	       }
	     }

             RET: ret = lst1;
           }
 
           /* imSub (Konzeptterm) = NULL */
           else {
             ret = NULL;
             printf ("Der definerende Konzeptterm hat keine Instanz.\n");
	   }
         }

       }
       else {
         printf ("Ihr Wahl ist nicht erlaubt.\n");
         return NULL;
       }
     }

     if (ret == NULL)
       printf ("\nDieser Konzeptterm hat keine Instanz.\n");
     else 
       print_Liste (ret);
   }
   else {
     printf ("Das File fuer die Objektwelt exisitiert in TEWIS nicht.\n");
     return NULL;
   }

   return (ret);
}


