/*************************termprop.c*********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tree.h"
#include "termprop.h"

/* globale Variable */
Liste *s_Liste;


/*****************************************************/
/* FUNCTION  : Baum_Liste                            */
/* PARAMETER : Baum *a                               */
/* RETURN    : Liste *                               */
/* PURPOSE   : Hilfsfunktion                         */
/*             wandelt eine Datentype 'Baum' zu      */
/*             einer Datentype 'Liste' um            */
/*****************************************************/


Liste *Baum_Liste (Baum *bm)
{
   Liste *act_Liste;
   Baum *ptr;

   /* erstellt eine Liste aus dem Baum bm. */

   if (bm != NULL) {
     if (s_Liste == NULL) {
       s_Liste = Node_Liste ( );

       if (strcmp (bm->lKlammer, "(") == 0) {
         strcpy (s_Liste->str, bm->lKlammer);
         s_Liste->next = Node_Liste ( );
         strcpy (s_Liste->next->str, bm->Token);
         s_Liste->next->next = NULL;
       }
       else {
         strcpy(s_Liste->str, bm->Token);
         s_Liste->next = NULL;
       }
     }

     else {
       act_Liste = s_Liste;
       while (act_Liste->next != NULL) 
         act_Liste = act_Liste->next;
     
       act_Liste->next = Node_Liste ( );
       act_Liste = act_Liste->next;

       if (strcmp (bm->lKlammer, "(") == 0) {
         strcpy (act_Liste->str, bm->lKlammer);
         act_Liste->next = Node_Liste ( );
         strcpy (act_Liste->next->str, bm->Token);
         act_Liste->next->next = NULL;
       }
       else {
         strcpy (act_Liste->str, bm->Token);
         act_Liste->next = NULL;
       }
     }

     /* rekursiv Aufruf der Funktion Baum_Liste */
     /* fuer weitere Baumknoten des Baums bm.   */

     ptr = bm->child;
     while (ptr != NULL) {
       Baum_Liste (ptr); 
       ptr = ptr->brother;
     }

  
     if (strcmp (bm->rKlammer, ")") == 0) { 
       act_Liste = s_Liste;
       while (act_Liste->next != NULL) 
         act_Liste = act_Liste->next;   
       act_Liste->next = Node_Liste ( );
       act_Liste = act_Liste->next;
       strcpy (act_Liste->str, bm->rKlammer);
       act_Liste->next = NULL;
     }
   } 

   return (s_Liste);
}


/*****************************************************/
/* FUNCTION  : compare_Listen                        */
/* PARAMETER : Liste *a, Liste *b                    */
/* RETURN    : int                                   */
/* PURPOSE   : Hilfsfunktion                         */
/*             Die Funktion compare_Listen liefert   */
/*             ein Integer 1, wenn die beide Listen  */
/*             a und b identisch sind. Ansonsten -1. */
/*****************************************************/


int compare_Listen (Liste *a, Liste *b)
{
   while (a != NULL && b != NULL) {
     if (strcmp (a->str, b->str) == 0) {
       a = a->next;
       b = b->next;
     }
     else
       return (-1);
   }

   if (a == NULL && b == NULL)
     return (1);
   else
     return (-1);
}   


/*****************************************************/
/* FUNCTION  : neu_Liste                             */
/* PARAMETER : char *c, Baum *bm                     */
/* RETURN    : Liste *                               */
/* PURPOSE   : Hilfsfunktion.                        */
/*             erstellt eine Liste aus einem Ausdruck*/
/*             der Form (char * Baum *).             */
/*****************************************************/

Liste *neu_Liste (char *arg1, Baum *arg2)
{
    Liste *act_Liste, *start_Liste;

       
    /* Erstellen einer Liste */

    start_Liste = Node_Liste ( );
    strcpy (start_Liste->str, "(");

    start_Liste->next = Node_Liste ( );
    strcpy (start_Liste->next->str, arg1);

    s_Liste = NULL;
    start_Liste->next->next = Baum_Liste (arg2);

    act_Liste = start_Liste;
    while (act_Liste->next != NULL)
      act_Liste = act_Liste->next;

    act_Liste->next = Node_Liste ( );
    act_Liste = act_Liste->next;
    strcpy (act_Liste->str, ")");

    act_Liste->next = NULL;
    
    return (start_Liste);
}


/*****************************************************/
/* FUNCTION  : append_Liste                          */
/* PARAMETER : Welt *w, Liste *lst                   */
/* RETURN    : void                                  */
/* PURPOSE   : Hilfsfunktion.                        */
/*             Die Liste lst wird am Ende der Welt   */
/*             w angehaengt, wenn lst in w nicht     */
/*             vorhanden ist.                        */  
/*****************************************************/

void append_Liste (Welt *w, Liste *lst)
{
   Welt *act_welt;

   act_welt = w;

   if (w != NULL) {

     /* prueft nach, ob die Liste lst in w */ 
     /* (ohne letzte Liste) vorhanden ist. */
     while (act_welt->next != NULL) { 
       if (compare_Listen (act_welt->ls, lst ) != 1)
         act_welt = act_welt->next;
       else
         /* Die Listen act_welt->ls und lst sind gleich */
         /* lst ist in w vorhanden.                     */
         break;
     }
 
     
     if (act_welt->next == NULL) { 

       /* lst ist in w nicht vorhanden */
       if (compare_Listen (act_welt->ls, lst) != 1) {

         /* Haengt die Liste lst am Ende der w */
         act_welt->next = Node_Welt ( );
         act_welt = act_welt->next;
         act_welt->ls = lst;
         act_welt->next = NULL;
       }
     }
   }
   else {
     printf ("Die Welt ist noch leer.\n");
     exit (1);
   }

}




/*****************************************************/
/* FUNCTION  : termprop                              */
/* PARAMETER : Welt *W, Terme *T                     */
/* RETURN    : Welt                                  */
/* PURPOSE   : Zu jedem Objekt O in einer Objektwelt */
/*             W werden die fuer das Objekt relevante*/
/*             Rollen zu allen mit O ueber genau     */
/*             diese Rollen in Beziehung stehenden   */
/*             Objekte propagiert.                   */
/*****************************************************/


Welt *termprop (Welt *W, Terme *T)
{ 
   int i;
   Baum *BM1, *bm1, *bm2, *bm3; 
   Terme *tm, *tm1, *tm2; 
   Welt *w1, *w2, *start;
   Liste *lst, *tmp_lst, *lst1; 
   char str[20];

   start = W;

   tm = copy_Terme (T);
 
   w1 = W; 
   while (w1 != NULL) {
     lst = w1->ls;

     /* Die Form der Liste wird mit der Hilfe  */
     /* der Anzahl ihres Elements festgestellt.*/
     i = 0;
     while (lst != NULL) {
       i++;
       lst  = lst->next; 
     }

     /* Die Liste ist in der Form (O C) */
     if (i == 4) {
       tm1 = tm;
       lst = w1->ls;

       /* Suche die TermDefinition von C in der Terminologie */
       while ( tm1 != NULL && strcmp (lst->next->next->str, tm1->expression->ATerm) != 0)
         tm1 = tm1->next;
       
       if (tm1 == NULL) {
         printf ("Term %s ist nicht in der Terminologie definiert.\n",
                 lst->next->next->str);
         return NULL;
       }
       else { 
         /* BM1 = (and t[1], t[2], ..., t[n]) */
         BM1 = tm1->expression->term;
         bm1 = BM1->child; /* bm1 zeigt auf t[1] */ 
       
         /* Fuer alle t[i] in BM1 */
         while (bm1 != NULL) { 
          
           /* t[i] = (atleast n R) oder t[i] = (atmost n R)  */
           if (strcmp (bm1->Token, "atleast") == 0 ||
               strcmp (bm1->Token, "atmost") == 0 ) {
            
             /* Erstellen einer neuen Liste (O (atleast n R)) */
             tmp_lst = neu_Liste (lst->next->str, bm1);
                 
             /* Die neue Liste wird am Ende der Welt start angehaengt,*/ 
             /* falls sie in start noch nicht vorhanden ist.          */       
             append_Liste (start, tmp_lst);
           }
           else {
             /* t[i] = (all R C') */
             if (strcmp (bm1->Token, "all") == 0) {

               /* Sucht die Liste der Form (O R' O') aus W */
               w2 = W;
               while (w2 != NULL) {
                 lst1 = w2->ls;
                 i = 0;
                 while (lst1 != NULL) {
                   i++;
                   lst1  = lst1->next;
                 }

                 lst1 = w2->ls;
                 /* Fuer jedes (O R' O') aus der Welt */           
                 if (i == 5 
                     && strcmp (lst1->next->str, lst->next->str) == 0) {

                   /* lst1 zeigt auf R' */
                   lst1 = lst1->next->next; 
                   
                   tm1 = tm;
                   /* Sucht die TermDefinition von R' in T */
                   while ( strcmp (lst1->str, tm1->expression->ATerm) != 0
                         && tm1 != NULL)
                     tm1 = tm1->next; 
                     
                   if (tm1 == NULL) {
                     printf ("Term %s ist nicht in der Terminologie \
definiert.\n", lst->str);       
                     return NULL;
                   }
                   else {
                   
                     /* Sucht die TermDefinition von R in T */
                     tm2 = tm;
                     while (strcmp (bm1->child->Token, 
                                    tm2->expression->ATerm) != 0 
                          && tm2 != NULL)
                     tm2 = tm2->next;
                   
                   
                     if (tm2 == NULL) {
                        /* kopiert die TermDefinition fuer Term R' */
                        bm2 = copy_Baum (tm1->expression->term, NULL);
                   
                        /* kopiert R zum Baum bm3 */
                        bm3 = copy_Baum (bm1->child, NULL);
                        loesch_Baum (bm3->brother); 
                        bm3->brother = NULL;
                       
                     }
                     else { 
                       /* kopiert die TermDefinition fuer Term R' und R */
                       bm2 = copy_Baum (tm1->expression->term, NULL);
                       bm3 = copy_Baum (tm2->expression->term, NULL);
                     }
                         
                     /* termsub (R, R') */
                     if (comp (bm3, bm2) == 1) {  
                       lst1 = lst1->next; /* lst zeigt auf O' */
                       
                       /* Erstellen einer neuen Liste (O' C') */
                       tmp_lst = neu_Liste (lst1->str, bm1->child->brother);
                 
                       /* Die neue Liste wird am Ende der start */
                       /* angehaengt, falls sie in start noch   */
                       /* nicht vorhanden ist.                  */
                       append_Liste (start, tmp_lst);
		     }
                             
                     /* Speicherplatz fuer Hilfsbaeume bm2 und bm3 freigeben*/
                     loesch_Baum (bm2); 
                     bm2 = NULL;
                     loesch_Baum (bm3);
                     bm3 = NULL;
		   }
		 }
	         w2 = w2->next;
               } 
	     }
	   }
	   bm1 = bm1->brother;
	 }
       }
     }   

     else {
       /* Die Liste aus W ist (O R O') */
       if (i == 5) { 
         /* lst zeigt auf der Liste (O R O') */
         lst = w1->ls;

         /* Sucht die TermDefinition von R in der Terminologie */   
         tm1 = tm;
         while ( strcmp (lst->next->next->str, 
                         tm1->expression->ATerm) != 0 && tm1 != NULL)
           tm1 = tm1->next;

         if (tm1 == NULL) {
           printf ("Term %s ist nicht in der Terminologie definiert.\n",
                     lst->next->next->str);
           return NULL;
         } 

        /* Fuer jede noch nicht markiert Liste der W */ 
         w2 = W;
         while (w2 != w1)
           w2 = w2->next;
         w2 = w2->next;
       
         while (w2 != NULL) {
           lst1 = w2->ls;
           i = 0;
           while (lst1 != NULL) {
             i++;
             lst1 = lst1->next;
           }

           lst1 = w2->ls;

           /* Die unmarkierte Liste ist (O C) */
           if (i == 4 &&
               strcmp (lst1->next->str, lst->next->str) == 0) {
              
             /* Sucht die TermDefinition von C in der Terminologie */   
             tm2 = tm;
             while ( strcmp (lst1->next->next->str, 
                             tm2->expression->ATerm) != 0 && tm2 != NULL)
               tm2 = tm2->next;

             if (tm2 == NULL) {
               printf ("Term %s ist nicht in der Terminologie definiert.\n",
                 lst1->next->next->str);
               return NULL;
             }
             else { 
   
               /* BM1 = (and t[1], t[2], ..., t[n]) */
               BM1 = tm2->expression->term;  
               bm1 = BM1->child;
  
               /* Fuer alle t[i] aus BM1 */         
               while (bm1 != NULL) {
                 /* t[i] = (all R' C') */
                 if (strcmp (bm1->Token, "all") == 0) {

                   /* Sucht die Termdefinition von R' in T */
                   tm2 = tm;
                   while ( strcmp (bm1->child->Token, 
                                   tm2->expression->ATerm) != 0
                             && tm2 != NULL)
                     tm2 = tm2->next;
                                      
                   /* R' und R sind gleich. */ 
                   if (tm1 == tm2) {
                     
                     /* Erstellen einer neuen Liste (O' C') */
                     tmp_lst = neu_Liste (lst->next->next->next->str, 
                                          bm1->child->brother);
                     append_Liste (start, tmp_lst);
       		   }
		 }
		 bm1 = bm1->brother;
	       }
	     }
	   }
           w2 = w2->next;   
	 }
       }
     }
     w1 = w1->next;
   }

   /* nicht benoetigter Speicher frei geben. */
   loesch_Terme (&tm);

   return (start);
}

