extern enum BOOL Warnung, c;
extern O_Welt *W_Abst;
extern Welt *SAF, *W, *MSC;
extern Terme *T, *T1, *ITF;
extern Welt *a_Sub, *sub, *Sub;


int yyparse ();
FILE *yyin;

/******************************************************/
/* FUNKTION  : tewis_class_old                        */
/* ARGUMENTE : Termbezeichner                         */
/* ZWECK     : Klassifikation eines Terms in der      */
/*             Komzept- oder Rollentaxonomie der      */
/*             Terminologie                           */
/******************************************************/

int tewis_class_old(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[])
{
   int i, j = 0;
   char str[36];
   char out[500];
   Welt *s, *S;
   Liste *lst;
   Terme *tm1, *ptr, *ptr1;
   FILE *fp;

   if (T == NULL) {
     interp->result = "Die Terminologiedatei existiert nicht.";
     return TCL_ERROR;
   }
   if (argc != 2) {
     interp->result = "Falsche Anzahl von Argumenten.";
     return TCL_ERROR;
   }

   /* Die Termdefinition mit dem Termbezeichner A ist definiert. */ 
   strncpy(str,argv[1],36);

   /* sucht die 'sub_liste' und 'Sub_Liste' von */
   /* A in den globalen Variablen sub und Sub.  */
   
   s = sub;
   while (s != NULL) {
     if (strcmp (s->ls->str, str) != 0)
       s = s->next;
     else
       break;
   }
   
   if (s == NULL) {
     interp->result = "Der Termbezeichner ist in der Terminologie nicht definiert.";
     return TCL_OK;
   }

   strcpy(out,"imsub ( ");
   strcat(out,s->ls->str);
   strcat(out," ): ");
   lst = s->ls->next;
   while (lst != NULL) {
     strcat(out,"  ");
     strcat(out,lst->str);
     strcat(out,"  ");
     lst = lst->next;
   }
   /* out enthaelt jetzt imsub... */

   S = Sub;
   while (S != NULL) {
     if (strcmp (S->ls->str, str) != 0)
       S = S->next;
     else
       break;
   }

   /* imSub auch an out anhaengen: */
   strcat(out,"imSub ( ");
   strcat(out,S->ls->str);
   strcat(out," ): ");
   lst = S->ls->next;
   while (lst != NULL) {
     strcat(out,"  ");
     strcat(out,lst->str);
     strcat(out,"  ");
     lst = lst->next;
   }
   interp->result = out;

   return TCL_OK;
}


/******************************************************/
/* FUNKTION  : tewis_class_new                        */
/* ARGUMENTE : Termdefinition                         */
/* ZWECK     : Klassifikation eines Terms in der      */
/*             Komzept- oder Rollentaxonomie der      */
/*             Terminologie                           */
/******************************************************/

int tewis_class_new(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[])
{
   int i, j = 0;
   char satz[256];
   char out[500];
   Welt *s, *S;
   Liste *lst, *lst1, *lst2;
   Terme *tm1, *ptr, *ptr1;
   FILE *fp;
   if (T == NULL) {
     interp->result = "Die Terminologiedatei existiert nicht.";
     return TCL_ERROR;
   }
   if (argc != 2) {
     interp->result = "Falsche Anzahl von Argumenten.";
     return TCL_ERROR;
   }
   

   /* Eine neue Termdefinition wird definiert. */
   fp = fopen ("tmpfile", "w+");
   if (fp == NULL) {
     interp->result = "tmpfile in tewis_class_new kann nicht zum Schreiben geoeffnet werden.";
     return TCL_ERROR;
   } 
   fprintf (fp, "%s", argv[1]);
   fclose (fp);
   
   /* lexkalisch uns syntaktisch Analysis */
   /* der neuen Termdefinition.           */
   yyin = fopen ("tmpfile", "r");
   yyparse();
   
   sort1 (ITF);
   sort2 (ITF);
   
   
   /* Die neue Termdefinition am Ende der Terminologie anhaengen. */ 
   tm1 = copy_Terme (T);
   ptr = tm1;
   while (ptr->next != NULL) {
     ptr = ptr->next;
     j++;
   }
   
   ptr->next = (void*)Node_Terme ( );
   ptr->next = ITF;
   ptr = ptr->next;  
   
   form_Terme (tm1);
   all_exp_Terme (tm1);
   norm_Terme (tm1);
   
   ptr = tm1;
   while (j >= 0) {
     ptr = ptr->next;
     j--;
   }
   
   ptr1 = tm1;
   
   /* prueft nach, ob die neu definierte Termidefinition */
   /* schon in der Terminologie vorhanden ist.           */
   while (ptr1 != ptr) {
     if (comp(ptr->expression->term, ptr1->expression->term) == 1 &&
	 comp(ptr1->expression->term, ptr->expression->term) == 1 )
       break;
     else
       ptr1 = ptr1->next;
   }
   
   /* Die neu definierte Termdefinition  */
   /* exisiert schon in der Terminologie */ 
   
   if (ptr1 != ptr) {
     
     /* sucht die 'sub_liste' und 'Sub_Liste' von diesem */
     /* Term in den globalen Variablen sub und Sub.     */
     s = sub;
     while (s != NULL) {
       if (strcmp (s->ls->str, ptr1->expression->ATerm) != 0)
	 s = s->next;
       else
	 break;
     }
     
     S = Sub;
     while (S != NULL) {
       if (strcmp (S->ls->str, ptr1->expression->ATerm) != 0)
	 S = S->next;
       else
	 break;
     }
     
     strcpy(out,"imsub ( ");
     strcat(out,ptr->expression->ATerm);
     strcat(out," ): ");
     lst = s->ls->next;
     while (lst != NULL) {
       strcat(out,"  ");
       strcat(out,lst->str);
       strcat(out,"  ");
       lst = lst->next;
     }
     /* out enthaelt jetzt imsub... */;
     /* imSub wird angehaengt: */
     strcat(out,"imSub ( ");
     strcat(out,ptr->expression->ATerm);
     strcat(out," ): ");
     lst = S->ls->next;
     while (lst != NULL) {
       strcat(out,"  ");
       strcat(out,lst->str);
       strcat(out,"  ");
       lst = lst->next;
     }
     interp->result = out;
     
   }
   
   
   else {
     /* berechnet die 'Sub_Liste' und 'sub_Liste' */
     /* fuer die neu definierten Term.            */
     lst1 = (void*)imsub (ptr->expression->term, tm1);
     lst2 = (void*)imSub (ptr->expression->term, tm1);
 

     strcpy(out,"imsub ( ");
     strcat(out,lst1->str);
     strcat(out," ): ");
     lst = lst1->next;
     while (lst != NULL) {
       strcat(out,"  ");
       strcat(out,lst->str);
       strcat(out,"  ");
       lst = lst->next;
     }
     /* out enthaelt jetzt imsub... */;
     /* imSub wird angehaengt: */
     
     strcat(out,"imSub ( ");
     strcat(out,lst2->str);
     strcat(out," ): ");
     lst = lst2->next;
     while (lst != NULL) {
       strcat(out,"  ");
       strcat(out,lst->str);
       strcat(out,"  ");
       lst = lst->next;
     }
     interp->result = out;

   }
   
   loesch_Terme (&tm1);
   
   return TCL_OK;
}












