extern enum BOOL Warnung, c;
extern O_Welt *W_Abst;
extern Welt *SAF, *W, *MSC;
extern Terme *T, *T1, *ITF;
extern Welt *a_Sub, *sub, *Sub;


int yyparse ();
FILE *yyin;

/******************************************************/
/* FUNKTION  : tewis_w_Inst_bezeichner                */
/* ARGUMENTE : Konzeptbezeichner                      */
/* ZWECK     : Berechnung der Instanzen des Konzepts  */
/******************************************************/

int tewis_w_Inst_bezeichner(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[])
{
  char Cbez[36];
  char out[500];
  Liste  *ret;
  Terme  *h_tm;

  if (argc != 2) {
    interp->result = "Falsche Anzahl von Argumenten.";
    return TCL_ERROR;
  }
  strncpy(Cbez,argv[1],36);

  if (SAF != NULL) { 
    ret = NULL;
 
    /* Die Instanzen eines Konzepts (Eingabe: Konzeptbezeichner)  */
    /* werden berechnet.*/
    
    h_tm = T;
    while (h_tm != NULL) {
      if (strcmp (h_tm->expression->ATerm, Cbez) != 0)
	h_tm = h_tm->next;
      else
	break;
    }
    
    if (h_tm == NULL) {
      interp->result = "Der Termbezeichner ist in der Terminologie nicht definiert.";
      return TCL_OK;
    }
    
    ret = (void*)Inst (Cbez, W, T);
    
    if (ret == NULL)
      interp->result = "Dieser Konzeptterm hat keine Instanz.";
    else {
      while (ret != NULL) {
	strcat(out,"  ");
	strcat(out,ret->str);
	strcat(out,"  ");
	ret = ret->next;
      }
      interp->result = out;
    }
  }
  else {
    interp->result = "Die Datei fuer die Objektwelt existiert in TEWIS nicht.";
    return TCL_ERROR;
  }
  return TCL_OK;
}

/******************************************************/
/* FUNKTION  : tewis_w_Inst_term                      */
/* ARGUMENTE : neuer Konzeptterm                      */
/* ZWECK     : Berechnung der Instanzen des Konzepts  */
/******************************************************/

int tewis_w_Inst_term(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[])
{
  int k, i;
  char satz[256];
  char out[500];
  Liste  *ret, *lst, *lst1, *lst2, *act_lst1, *act_lst2, *ptr;
  FILE *stream;
  Terme *tm, *act_tm, *h_tm;

  if (argc != 2) {
    interp->result = "Falsche Anzahl von Argumenten.";
    return TCL_ERROR;
  }
  strncpy(satz,argv[1],256);
  
  if (SAF != NULL) { 
    ret = NULL;

    /* Die Instanzen eines Konzepts (Eingabe: Konzeptterm) */
    /* werden berechnet.*/
  
    /* Konzeptterm eingeben. Die neu TermDefinition: */
    /* neu_Cbez :=C Konzeptterm wird als ein File    */
    /* unter dem Name "tmpfile" gespeichert.         */

    stream = fopen ("tmpfile", "w+");
    fprintf (stream, "%s %s", "neu_Cbez", ":=C"); 
    fprintf (stream, "%s", satz);
    fclose(stream);
      
    /* lexikalisch und syntaktisch Analysis des Files 'tmpfile'. */
    yyin = fopen("tmpfile", "r");   
    if (yyin == NULL) {      
      interp->result = "Datei tmpfile in w_Inst kann nicht geoeffnet werden.";
      return TCL_ERROR;
    };
    
    yyparse();
    
    sort1 (ITF);
    sort2 (ITF); 
    
    /* Kopieren der alten Terminologie T */
    tm = copy_Terme (T);
    
    /* "tmpfile" an T anhaengen */
    act_tm = tm;
    while (act_tm->next != NULL)
      act_tm = act_tm->next;
    act_tm->next = (void*)Node_Terme ( );
    act_tm->next = ITF;
    act_tm = act_tm->next;
    act_tm->next = NULL;
    
    form_Terme (tm);
    all_exp_Terme (tm);
    norm_Terme (tm);
    
    act_tm = tm;
    while (strcmp (act_tm->expression->ATerm, "neu_Cbez") != 0)
      act_tm = act_tm->next;
    
    /* prueft nach, ob der gegebene Konzeptterm K */
    /* in der Terminologie T definiert ist.  */
    h_tm = tm;
    while (h_tm != act_tm) {
      if (vergleich (h_tm->expression->term, 
		     act_tm->expression->term) == -1)
	h_tm = h_tm->next;
      else
	break;
    } 
    
    /* K ist in T definiert. */
    if (h_tm != act_tm)
      ret = (void*)Inst (h_tm->expression->ATerm, W, T);
    
    /* K ist nicht in T definiert. */
    else {
      /* lst enthaelt alle Termbezeichner, deren */
      /* definierden Terme den eingegebene       */
      /* Konzeptterm unmittelbar subsummieren.   */
      lst = (void*)imSub (act_tm->expression->term, tm);
      
      lst = lst->next;
      
      /* Die gemeinsame Elemente von Instanzen  */
      /* jedes Konzepts aus lst wird ausgesucht.*/ 
      if (lst != NULL) {
	lst1 = NULL;
	lst1 = (void*)Inst(lst->str, W, T);
        
	if (lst1 != NULL) {  
	  lst = lst->next;
	  
	  while (lst != NULL) {  
	    lst2 = (void*)Inst(lst->str, W, T);
	    
	    if (lst2 != NULL) {  
	      act_lst1 = lst1;
	      
	      /* prueft nach, ob es ein gemeinsames */
	      /* Element von lst1 und lst2 ist.     */
	      while (act_lst1 != NULL) {
		k = 0;
		act_lst2 = lst2;
		while (act_lst2 != NULL) {
		  if (strcmp (act_lst1->str, act_lst2->str) == 0) {
		    k = 1;
		    break;
		  }
		  else
		    act_lst2 = act_lst2->next;
		}  
		
		/* kein gemeinsames Element. */
		/* entfernet das Element aus lst1 */
		if (k == 0) {
		  if (act_lst1 == lst1) {
		    ptr = lst1->next;
		    free (lst1);
		    lst1 = ptr;
		    act_lst1 = lst1;
		  }
		  else {
		    ptr = lst1;
		    while (ptr->next != act_lst1)
		      ptr = ptr->next;
		    ptr->next = act_lst1->next;
		    free (act_lst1);
		    act_lst1 = ptr->next;
		  }
		}
		else
		  act_lst1 = act_lst1->next;
	      }
	    }
	    
	    /* Die Menge der Instanzen eines     */
	    /* Konzeptbezeichner in lst ist leer.*/
	    else {
	      lst1 = NULL; 
	      interp->result = "Der definerende Konzeptterm hat keine Instanz.";
	      goto RET;
	    }
	    
	    lst = lst->next;
	  }
	}
	
      RET: ret = lst1;
      }
      
      /* imSub (Konzeptterm) = NULL */
      else {
	ret = NULL;
	interp->result = "Der definerende Konzeptterm hat keine Instanz.";
      }
    }  
    if (ret == NULL)
      interp->result = "Dieser Konzeptterm hat keine Instanz.";
    else {
      while (ret != NULL) {
	strcat(out,"  ");
	strcat(out,ret->str);
	strcat(out,"  ");
	ret = ret->next;
      }
      interp->result = out;
    }
  }
  else {
    interp->result = "Die Datei fuer die Objektwelt existiert in TEWIS nicht.";
    return TCL_ERROR;
  }
  
  return TCL_OK;
}




