/******************************************************/
/* FUNKTION  : tewis_init                             */
/* ARGUMENTE : keine                                  */
/* ZWECK     : Initialisierung globaler Variablen     */
/******************************************************/

int tewis_init(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[]){
   int t, f;
   char key[4], wahl[4];
   O_Welt *OW;

   T = NULL;
   T1 = NULL;
   W = NULL;
   a = FALSE;
   b = FALSE;
   c = FALSE;
   Warnung = FALSE;
   return(TCL_OK);
}

/******************************************************/
/* FUNKTION  : tewis_process_terminology              */
/* ARGUMENTE : keine                                  */
/* ZWECK     : Laden der Terminologiedatei T_file     */
/*             und Berechnung der benoetigten         */
/*             globalen Variablen                     */
/******************************************************/

int tewis_process_terminology(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[]){
   cycle = NULL; 

  T = TF();

    if(T == NULL){
    interp->result = "Die Terminologiedatei kann nicht geoeffnet werden.";
    return(TCL_ERROR);
  } else { 
  
  /* Expansion und Normierung. */
  
    form_Terme (T);
    T1 = copy_Terme (T); 
    exp_Terme (T1);  
    norm_Terme (T1); 
    T = copy_Terme (T1);  
    all_exp_Terme (T);
    norm_Terme (T);

    /* berechnet die globale Variablen */

    a_Sub = all_Sub_Terme (T);
    Sub = imSub_Terme (T);
    a_sub = all_sub_Terme (T);
    sub = imsub_Terme (T);

    return(TCL_OK);
  }   
}

/******************************************************/
/* FUNKTION  : tewis_process_objectworld              */
/* ARGUMENTE : keine                                  */
/* ZWECK     : Laden der Objektweltdatei W_file       */
/*             und Berechnung der benoetigten         */
/*             globalen Variablen                     */
/******************************************************/

int tewis_process_objectworld(ClientData clientData, Tcl_Interp *interp,int argc,char *argv[]){
    W = AF ( );
    termprop (W, T1);
    W_Abst = abstraction (W, T1);
    MSC = MSC_Welt (W, T);
    return TCL_OK;
}


/**************************************/
/*** Hilfsfunktionen                ***/
/**************************************/

/******************************************************/
/* FUNKTION  : baum_to_string                         */
/* ARGUMENTE : Baum, String                           */
/* ZWECK     : Umwandeln einer Baumstruktur in einen  */
/*             lesbaren String                        */
/******************************************************/

void baum_to_string (Baum *bm,char *out)
{   
  /* Ausgabe: lKlammer und Token des Baums */
  if (bm != NULL) {
    /* printf(" %s%s", bm->lKlammer, bm->Token);   */
    strcat(out," ");
    strcat(out,bm->lKlammer);
    strcat(out,bm->Token);

    /* rekursiv ausdrucken */
    if (bm->child != NULL) 
      baum_to_string(bm->child,out); 

    /* Ausgabe: rKlammer des Baums */ 
    strcat(out,bm->rKlammer);
    strcat(out," ");

    /* rekursiv ausdrucken */ 
    if (bm->brother != NULL)
      baum_to_string(bm->brother,out);
    return;
  }
}

/******************************************************/
/* FUNKTION  : tewis_save_term                        */
/* ARGUMENTE : keine                                  */
/* ZWECK     : Sichern der Aenderungen an der         */
/*             Terminologie in der bekannten Datei    */
/******************************************************/

int tewis_save_term (ClientData clientData, Tcl_Interp *interp,int argc,char *argv[])
{
    char c;
    FILE *fp, *fp1;
    fp = fopen (T_file, "a+");
    putc (';', fp);
    putc ('\n', fp);
    putc ('\n', fp);
    
    fp1 = fopen ("tmpfile", "r");
    if (fp1 == NULL) {
      interp->result = "tmp_file kann nicht zum Lesen geoeffnet werden.";
      return TCL_ERROR;
    }
    
    while ((c = getc (fp1)) != EOF) {
      putc (c, fp);
      if (c == ';') {
	putc ('\n', fp); 
	putc ('\n', fp);
      }
    }
    
    fclose (fp1);
    fclose (fp);
    return TCL_OK;
}





































