/***********                    tree.h                       *********/

   
/*********************************************************************/
/***           Erstellen des Datenstruktur                         ***/
/*********************************************************************/


/*    Ein Teil der Syntax des ITF ist:                              */

/*    <Terminologie> ::= <TermDefinition>*
/*    <TermDefinition> ::= <KonzeptDefinition> | <RolleDefinition>  */
/*    <KonzeptDefinition> ::= <atomaresKonzept> = <Konzept>         */
/*    <RolleDefinition> ::= <atomareRolle > = <Rolle>               */

/*    Konzept bzw. Rolle wird als Datentyp Baum definiert.          */
/*    TermDefinition wird als Datentyp Term definiert.              */
/*    Terminologie wird als Datentyp Terme definiert.               */

enum BOOL {FALSE, TRUE};


typedef struct Baum
{    
    char *lKlammer;
    char *Token; 
    char *rKlammer;         
    /* {lKlammer, Token, rKlammer sind die Inhalte eines Baumknotens} */

    struct Baum *child;      /* {Der Zeiger zum Nachfolger} */
    struct Baum *father;     /* {Der Zeiger zum Vorgaenger} */
    struct Baum *brother;    /* {Der Zeiger zum rechten Nachbar} */
    
} Baum;


typedef struct {
  
   char  *ATerm;        /* {AomaresKonzept oder AotmareRolle} */
   char  *equal;        /* {:=C fuer KonzeptDefinition, */
                        /*  :=R fuer RolleDefinition}   */
   Baum  *term;         /* {Konzept oder Rolle} */

} Term;
 

typedef struct Terme {   /* {TermDefinition} */

  Term *expression; 
  struct Terme *next;

} Terme;



/*    Ein Teil der Syntax des SAF ist:                              */

/*    <Objektwelt> ::= <Weltbeschreibung>*                          */
/*    <Weltbeschreibung> ::= <Konzeptinstanziierung> |              */
/*                          <Rolleninstanziierung>                  */


/*    Objektwelt wird als Datentyp Obj_Welt definiert.              */
/*    Weltbeschreibung wird als Datentyp List definiert.            */


 
typedef struct Liste {

  char str[36];
  struct Liste *next;

} Liste;


typedef struct Welt {     /* {Weltbeschreibung} */

  Liste *ls;               
  struct Welt *next;

} Welt;


typedef struct Baume {
  
  Baum *bm;
  struct Baume *next;

} Baume;


typedef struct set_role {
 
  Baum  *role, *MSG;
  Baume *sub_role, *super_role;
  Liste *filler;
  int   count, max;
  struct set_role *next;

} set_role;


typedef struct O_Welt {

  char name[36];
  Baum *abstract;
  set_role *srole;
  enum BOOL abstChange;
  struct O_Welt *next;

} O_Welt;


 
